﻿using System;
using REBORN.Common.Plugin.Redis;
using REBORN.CacheManager.DataStatistic;
using REBORN.Common.Plugin;
using REBORN.Common;
using Property.Repository;
using Property.Model.Extend;
using Property.Model.CacheEntity;

namespace Property.CacheManager.User
{
    /// <summary>
    /// redis缓存（只适用于数据统计）
    /// </summary>
    public class BranchReidsCache 
    {
        static RedisHelper redis = new RedisHelper(DataConstant.REDIS_DB3);

        /// <summary>
        /// 根据员工编号获取员工信息
        /// </summary>
        /// <param name="EmployeeId">员工编号</param>
        /// <returns></returns>
        public static CacheBranch GetBranch(object BranchId)
        {
            if (BranchId != null)
            {
                int.TryParse(BranchId.ToString(), out int bid);
                string key = string.Concat(CacheKey.UserCacheKeyConfig.USER_BRANCH_LIST, bid.ToString());
                if (bid >= 0)
                {
                    if (redis.KeyExists(key))
                    {
                        return redis.StringGet<CacheBranch>(key);
                    }
                    else
                    {
                        RB_SchoolRepository repository = new RB_SchoolRepository();
                        RB_School_ViewModel model = repository.GetEntity(bid).RefMapperTo<RB_School_ViewModel>();
                        if (model != null)
                        {
                            var branch = new CacheBranch()
                            {
                                Id = model.SId,
                                BName = model.SName,
                                Domain = model.SDomain,
                                RB_Group_Id = model.Group_Id
                            };
                            TimeSpan ts = GetExpirTime((int)REBORN.Common.Enum.CacheTimeEnum.OneDay);
                            redis.StringSet<CacheBranch>(key, branch, ts);
                            return branch;
                        }
                        else
                        {
                            return null;
                        }
                    }
                }
                else
                {
                    return null;
                }
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获取缓存时长
        /// </summary>
        /// <param name="JwtExpirTime"></param>
        /// <returns></returns>
        private static TimeSpan GetExpirTime(int JwtExpirTime)
        {
            DateTime dt = DateTime.Now;
            DateTime dt2 = DateTime.Now;
            TimeSpan ts = dt.AddSeconds(JwtExpirTime) - dt2;
            return ts;
        }
    }
}
