﻿using REBORN.Common.Plugin;

namespace REBORN.Common.Enum
{
    /// <summary>
    /// 财务流程费用配置枚举
    /// </summary>
    public enum FinanceConfigTypeEnum
    {
        /// <summary>
        /// 教师课时费
        /// </summary>
        [EnumField("教师课时费")]
        ClassFees = 1,

        /// <summary>
        /// 教师绩效
        /// </summary>
        [EnumField("教师绩效")]
        Perf = 2,

        /// <summary>
        /// 学生退课
        /// </summary>
        [EnumField("学生退课")]
        DropCourse = 3,

        /// <summary>
        /// 资产采购
        /// </summary>
        [EnumField("资产采购")]
        AssetPurchase = 4,
        /// <summary>
        /// 耗材采购
        /// </summary>
        [EnumField("耗材采购")]
        SuppliesPurchase = 5,
        /// <summary>
        /// 耗材费用（直接制费用单）
        /// </summary>
        [EnumField("耗材费用")]
        SuppliesCost = 6,
        /// <summary>
        /// 主营耗材出库
        /// </summary>
        [EnumField("主营耗材出库")]
        SuppliesStockOut = 7,
        /// <summary>
        /// 其他耗材出库
        /// </summary>
        [EnumField("其他耗材出库")]
        OtherSuppliesStockOut = 13,
        /// <summary>
        /// 教育商品- 咖啡
        /// </summary>
        [EnumField("教育咖啡劵")]
        EduCoffee = 15,

        /// <summary>
        /// 教育商品- 资产
        /// </summary>
        [EnumField("教育资产商品")]
        EduProperty = 16,
    }
}
