﻿using System;
using Property.Common.Models;
using System.Collections.Generic;
using System.Text;

namespace Property.Common.Message
{
    /// <summary>
    /// 消息推送实体
    /// </summary>
    public class PushMessageModel
    {
		/// <summary>
		/// 推送标题
		/// </summary>
		public string Title { get; set; }

		/// <summary>
		/// 推送内容
		/// </summary>
		public string Content { get; set; }

		/// <summary>
		/// 封面图
		/// </summary>
		public string CoverImg { get; set; }

		/// <summary>
		/// 所属分类
		/// </summary>
		public PushMessageCategoryEnum CategoryId { get; set; }

        /// <summary>
        /// 推送平台[1-手机端，2-Web端，3-短信，4-邮件, 5-企业微信]
        /// </summary>
        public int Platform { get; set; }

		/// <summary>
		/// 推送类型(0-立即推送,1-指定时间推送)
		/// </summary>
		public int SendType { get; set; }

		/// <summary>
		/// 推送时间
		/// </summary>
		public DateTime SendTime { get; set; }

		/// <summary>
		/// 接收人员
		/// </summary>
		public string ReceiveId { get; set; }

		/// <summary>
		/// 跳转地址
		/// </summary>
		public string JumpUrl { get; set; }

        /// <summary>
        /// 企业微信消息类型
        /// </summary>
        public string WorkMsgType { get; set; }

        /// <summary>
        /// 创建人姓名
        /// </summary>
        public string CreateByName { get; set; }

		/// <summary>
		/// 短信模板代码
		/// </summary>
		public string MsgTemplateCode { get; set; }

		/// <summary>
		/// 短信签名
		/// </summary>
		public string MsgSign { get; set; }
	}
}
