﻿using REBORN.Common;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;
using Property.Model.Entity;
using Property.Model.Extend;
using Property.Repository;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Property.Module.UserModule
{
    /// <summary>
    /// 账号管理处理类
    /// </summary>
    public class AccountModule
    {
        /// <summary>
        /// 账号管理处理类对象
        /// </summary>
        private readonly RB_AccountRepository accountRepository = new RB_AccountRepository();

        /// <summary>
        /// 获取账号列表
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Account_ViewModel> GetAccountListModule(RB_Account_ViewModel query)
        {
            return accountRepository.GetAccountListRepository(query);
        }


        /// <summary>
        /// 获取账号列表(批量修改密码专用)
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Account_ViewModel> GetUpdateAccountListRepository(List<RB_Account_ViewModel> query)
        {
            return accountRepository.GetUpdateAccountListRepository(query);
        }

        /// <summary>
        /// 获取账号列表扩展列表
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Account_ViewModel> GetAccountListExtModule(RB_Account_ViewModel query)
        {
            return accountRepository.GetAccountListExtRepository(query);
        }

        /// <summary>
        /// 获取账号列表扩展列表
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<Employee_ViewModel> GetEmployeeListExtModule(Employee_ViewModel query)
        {
            return accountRepository.GetEmployeeListRepository(query);
        }

        /// <summary>
        /// 获取学员账号信息
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Account_ViewModel> GetStudentExt(RB_Account_ViewModel query)
        {
            return accountRepository.GetStudentExt(query);
        }

        /// <summary>
        /// 添加修改账号
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public bool SetAccountModule(RB_Account_ViewModel model)
        {
            bool flag;
            if (model.Id > 0)
            {
                Dictionary<string, object> fileds = new Dictionary<string, object>()
                {
                    {nameof(RB_Account_ViewModel.Account),model.Account.Trim() },
                    {nameof(RB_Account_ViewModel.UpdateBy),model.UpdateBy},
                    {nameof(RB_Account_ViewModel.UpdateTime),model.UpdateTime},
                    {nameof(RB_Account_ViewModel.DirectSupervisor),model.DirectSupervisor},
                    {nameof(RB_Account_ViewModel.School_Id),model.School_Id},
                };
                flag = accountRepository.Update(fileds, new WhereHelper(nameof(RB_Account_ViewModel.Id), model.Id));
            }
            else
            {
                var newId = accountRepository.Insert(model);
                model.Id = newId;
                flag = newId > 0;
            }
            return flag;
        }

        /// <summary>
        /// 修改账号状态
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public bool SetAccountStatusModule(RB_Account_ViewModel model)
        {
            bool flag;
            Dictionary<string, object> fileds = new Dictionary<string, object>()
            {
                {nameof(RB_Account_ViewModel.Status),(int)model.Status },
                {nameof(RB_Account_ViewModel.UpdateTime),model.UpdateTime },
            };
            List<WhereHelper> list = new List<WhereHelper>()
            {
                new WhereHelper(nameof(RB_Account_ViewModel.AccountId),model.AccountId),
                new WhereHelper(nameof(RB_Account_ViewModel.AccountType),(int)model.AccountType),
            };
            flag = accountRepository.Update(fileds, list);
            return flag;
        }
    }
}
