﻿using REBORN.Common;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;
using Property.Model.Entity;
using Property.Model.Extend;
using Property.Repository;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Property.Module.UserModule
{
    /// <summary>
    /// 岗位处理类
    /// </summary>
    public class PostModule
    {
        /// <summary>
        /// 岗位仓储层对象
        /// </summary>
        private readonly RB_PostRepository postRepository = new RB_PostRepository();

        /// <summary>
        /// 获取岗位分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowsCount"></param>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Post_ViewModel> GetPostPageListModule(int pageIndex, int pageSize, out long rowsCount, RB_Post_ViewModel query)
        {
            var list = postRepository.GetPostPageListRepository(pageIndex, pageSize, out rowsCount, query);
            return list;
        }

        /// <summary>
        /// 获取岗位列表
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Post_ViewModel> GetPostListModule(RB_Post_ViewModel query)
        {
            return postRepository.GetPostListRepository(query);
        }

        /// <summary>
        /// 根据部门编号获取岗位列表
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Post_ViewModel> GetDeptPostListModule(RB_Post_ViewModel query)
        {
            return postRepository.GetDeptPostListRepository(query);
        }

        /// <summary>
        /// 修改岗位状态
        /// </summary>
        /// <param name="PostId">岗位编号</param>
        /// <param name="Status">状态</param>
        /// <returns></returns>
        public bool RemovePostModule(int PostId, int Status)
        {
            Dictionary<string, object> fileds = new Dictionary<string, object>()
            {
                {nameof(RB_Post_ViewModel.Status),Status }
            };
            return postRepository.Update(fileds, new WhereHelper(nameof(RB_Post_ViewModel.PostId), PostId));
        }
    }
}
