﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产耗材调拨日志实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Allocate_Record
    {
        /// <summary>
        /// Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 类型  1 资产转耗材   2耗材转资产
        /// </summary>
        public int Type { get; set; }

        /// <summary>
        /// 资产id
        /// </summary>
        public int PropertyId { get; set; }

        /// <summary>
        /// 资产校区id
        /// </summary>
        public int SchoolId { get; set; }

        /// <summary>
        /// 耗材id
        /// </summary>
        public int MaterialId { get; set; }

        /// <summary>
        /// 耗材所在仓库
        /// </summary>
        public int WarehouseId { get; set; }

        /// <summary>
        /// 转入资产分类
        /// </summary>
        public int CategoryId { get; set; }

        /// <summary>
        /// 相关入库出库单号
        /// </summary>
        public string StockInOutNo { get; set; }

        /// <summary>
        /// 状态 0 正常 1删除
        /// </summary>
        public int Status { get; set; }

        /// <summary>
        /// 公司
        /// </summary>
        public int RB_Branch_Id { get; set; }

        /// <summary>
        /// 集团
        /// </summary>
        public int RB_Group_Id { get; set; }

        /// <summary>
        /// CreateBy
        /// </summary>
        public int CreateBy { get; set; }

        /// <summary>
        /// CreateDate
        /// </summary>
        public DateTime CreateDate { get; set; }

    }
}