﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产入库实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Property_Stockin
    {
        /// <summary>
        /// Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 入库状态  1已入库  2待入库   3驳回   4取消
        /// </summary>
        public StockInStatusEnum StockInState { get; set; }

        /// <summary>
        /// 入库日期
        /// </summary>
        public DateTime StockInDate { get; set; }

        /// <summary>
        /// 入库总金额
        /// </summary>
        public decimal Money { get; set; }

        /// <summary>
        /// 供应商id
        /// </summary>
        public int SupplierId { get; set; }

        /// <summary>
        /// 供应商名称
        /// </summary>
        public string SupplierName { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }

        /// <summary>
        /// 状态 0正常  1删除
        /// </summary>
        public int Status { get; set; }

        /// <summary>
        /// 公司
        /// </summary>
        public int RB_Branch_Id { get; set; }

        /// <summary>
        /// 集团
        /// </summary>
        public int RB_Group_Id { get; set; }

        /// <summary>
        /// CreateBy
        /// </summary>
        public int CreateBy { get; set; }

        /// <summary>
        /// CreateDate
        /// </summary>
        public DateTime CreateDate { get; set; }

        /// <summary>
        /// UpdateBy
        /// </summary>
        public int UpdateBy { get; set; }

        /// <summary>
        /// UpdateDate
        /// </summary>
        public DateTime UpdateDate { get; set; }

        /// <summary>
        /// 入库单号
        /// </summary>
        public string StockInNum { get; set; }

        /// <summary>
        /// 采购单id
        /// </summary>
        public int ProcurementId { get; set; }

        /// <summary>
        /// 模板id
        /// </summary>
        public int TempleteId { get; set; }

        /// <summary>
        /// 附件  json格式  可图片  可文件
        /// </summary>
        public string Voucher { get; set; }

        /// <summary>
        /// 入库审核备注
        /// </summary>
        public string AuditRemark { get; set; }

        /// <summary>
        /// 校区id
        /// </summary>
        public int SchoolId { get; set; }

        /// <summary>
        /// 购置日期
        /// </summary>
        public DateTime BuyDate { get; set; }

    }
}