﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产入库明细实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Property_StockinDetail
    {
        /// <summary>
        /// Id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 入库id
        /// </summary>
        public int StockInId { get; set; }

        /// <summary>
        /// 资产名称
        /// </summary>
        public string PropertyName { get; set; }

        /// <summary>
        /// 品牌名称
        /// </summary>
        public string BrandName { get; set; }

        /// <summary>
        /// 分类id
        /// </summary>
        public int CategoryId { get; set; }

        /// <summary>
        /// 入库数量
        /// </summary>
        public int Number { get; set; }

        /// <summary>
        /// 成本价格
        /// </summary>
        public decimal CostMoney { get; set; }

        /// <summary>
        /// 状态 0 正常 1删除
        /// </summary>
        public int Status { get; set; }

        /// <summary>
        /// 公司
        /// </summary>
        public int RB_Branch_Id { get; set; }

        /// <summary>
        /// 集团
        /// </summary>
        public int RB_Group_Id { get; set; }

        /// <summary>
        /// CreateBy
        /// </summary>
        public int CreateBy { get; set; }

        /// <summary>
        /// CreateDate
        /// </summary>
        public DateTime CreateDate { get; set; }

        /// <summary>
        /// 关联资产id (入库时  直接根据该资产信息生成)
        /// </summary>
        public int PropertyId { get; set; }

    }
}