﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{
    /// <summary>
    /// 部门表实体类
    /// </summary>
    [Serializable]
    [DB(ConnectionName = "EduConnection")]
    public class RB_Department
    {
		/// <summary>
		/// 部门编号(主键)
		/// </summary>
		public int DeptId { get; set; }

		/// <summary>
		/// 部门名称
		/// </summary>
		public string DeptName { get; set; }

		/// <summary>
		/// 部门电话
		/// </summary>
		public string DeptTel { get; set; }

		/// <summary>
		/// 部门负责人编号【多个逗号分隔】
		/// </summary>
		public string ManagerIds { get; set; }

		/// <summary>
		/// 上级部门编号
		/// </summary>
		public int ParentId { get; set; }

		/// <summary>
		/// 集团编号
		/// </summary>
		public int Group_Id { get; set; }

		/// <summary>
		/// 删除状态(1-删除)
		/// </summary>
		public DateStateEnum? Status { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public int CreateBy { get; set; }

		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 更新人
		/// </summary>
		public int UpdateBy { get; set; }

		/// <summary>
		/// 更新时间
		/// </summary>
		public DateTime UpdateTime { get; set; }

		/// <summary>
		/// 校区编号
		/// </summary>
		public int School_Id { get; set; }

		/// <summary>
		/// 部门层级
		/// </summary>
		public int DeptTier { get; set; }

		/// <summary>
		/// 部门排序
		/// </summary>
		public int DeptSort { get; set; }

		/// <summary>
		/// 是否为公司(1-是)
		/// </summary>
		public int IsCompany { get; set; }
	}
}
