﻿using System.Collections.Generic;

namespace Property.Model.Extend
{
    /// <summary>
    /// 菜单树形结构实体
    /// </summary>
    public class MenuTree_ViewModel
    {
        /// <summary>
        /// 主键(菜单编号)
        /// </summary>
        public int MenuId { get; set; }

        /// <summary>
        /// 上级菜单编号
        /// </summary>
        public int ParentId { get; set; }

        /// <summary>
        /// 菜单名称
        /// </summary>
        public string MenuName { get; set; }

        /// <summary>
        /// 菜单链接地址
        /// </summary>
        public string MenuUrl { get; set; }

        /// <summary>
        /// 菜单图标
        /// </summary>
        public string MenuIcon { get; set; }
        
        /// <summary>
        /// 是否选中
        /// </summary>
        public bool IsChecked { get; set; }

        /// <summary>
        /// 菜单类型(1-系统菜单,2-功能菜单)
        /// </summary>
        public int MenuType { get; set; }

        /// <summary>
        /// 子菜单列表
        /// </summary>
        public List<MenuTree_ViewModel> SubList { get; set; }
    }
}
