﻿using Property.Model.Entity.Mall;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository.Mall
{
    /// <summary>
    /// 商品订单明细仓储层
    /// </summary>
    public class RB_Goods_OrderDetailRepository : RepositoryBase<RB_Goods_OrderDetail>
    {

        /// <summary>
        /// 获取订单明细列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="count"></param>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Goods_OrderDetail> GetOrderDetailList(RB_Goods_OrderDetail dmodel)
        {
            string where = $" 1=1 ";
            if (dmodel.TenantId > 0)
            {
                where += $@" and a.{nameof(RB_Goods_OrderDetail.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and a.{nameof(RB_Goods_OrderDetail.MallBaseId)}={dmodel.MallBaseId}";
            }
            
            if (dmodel.OrderId > 0)
            {
                where += $@" and a.{nameof(RB_Goods_OrderDetail.OrderId)}={dmodel.OrderId}";
            }
            if (dmodel.OrderType > 0)
            {
                where += $@" and a.{nameof(RB_Goods_OrderDetail.OrderType)}={(int)dmodel.OrderType}";
            }
            if (dmodel.IsComment > 0)
            {
                where += $@" and a.{nameof(RB_Goods_OrderDetail.IsComment)}={(int)dmodel.IsComment}";
            }
            if (!string.IsNullOrEmpty(dmodel.GoodsName))
            {
                where += $@" and a.{nameof(RB_Goods_OrderDetail.GoodsName)} like '%{dmodel.GoodsName}%'";
            }
            if (!string.IsNullOrEmpty(dmodel.ProductCode))
            {
                where += $@" and a.{nameof(RB_Goods_OrderDetail.ProductCode)} like '%{dmodel.ProductCode}%'";
            }
           

            string sql = $@"SELECT a.*,b.`Name` as SupplierName FROM rb_goods_orderdetail as a LEFT JOIN rb_supplier as b on a.SupplierId=b.ID where {where} order by a.Id asc";
            return Get<RB_Goods_OrderDetail>(sql).ToList();
        }

        /// <summary>
        /// 更新电商订单成本 （根据出库商品金额）
        /// </summary>
        /// <param name="costMoney"></param>
        /// <param name="mallOrderId"></param>
        public void UpdateEduGoodsCostMoney(decimal costMoney, int mallOrderId)
        {
            string sql = $@"update rb_goods_order set CostMoney ={costMoney} where OrderId ={mallOrderId}";
            Execute(sql);
        }

        /// <summary>
        /// 更新电商订单商品成本 （根据出库商品金额）
        /// </summary>
        /// <param name="costMoney"></param>
        /// <param name="mallOrderId"></param>
        /// <param name="suppliesId"></param>
        public void UpdateEduGoodsDetailCostMoney(decimal costMoney, int mallOrderId, int suppliesId)
        {
            string sql = $@"update rb_goods_orderdetail set CostMoney ={costMoney} where OrderId ={mallOrderId} and MaterialId ={suppliesId}";
            Execute(sql);
        }
    }
}
