﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产耗材调拨日志仓储类
    /// </summary>
    public partial class RB_Allocate_RecordRepository : RepositoryBase<RB_Allocate_Record>
    {
        /// <summary>
        /// 获取岗位分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Allocate_Record_Extend> GetPageList(int pageIndex, int pageSize, RB_Allocate_Record_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Allocate_Record_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.PropertyId > 0)
            {
                where += " and " + nameof(RB_Allocate_Record_Extend.PropertyId) + "=" + dmodel.PropertyId;
            }
            if (dmodel.Type > 0)
            {
                where += " and " + nameof(RB_Allocate_Record_Extend.Type) + "=" + dmodel.Type;
            }
            if (dmodel.MaterialId > 0)
            {
                where += " and " + nameof(RB_Allocate_Record_Extend.MaterialId) + "=" + dmodel.MaterialId;
            }
            if (dmodel.WarehouseId > 0)
            {
                where += " and " + nameof(RB_Allocate_Record_Extend.WarehouseId) + "=" + dmodel.WarehouseId;
            }
            string sql = $@" select * from RB_Allocate_Record {where} order by Id desc";
            return GetPage<RB_Allocate_Record_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取列表数据
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Allocate_Record_Extend> GetList(RB_Allocate_Record_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Allocate_Record_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.PropertyId > 0)
            {
                where += " and " + nameof(RB_Allocate_Record_Extend.PropertyId) + "=" + dmodel.PropertyId;
            }
            if (dmodel.Type > 0)
            {
                where += " and " + nameof(RB_Allocate_Record_Extend.Type) + "=" + dmodel.Type;
            }
            if (dmodel.MaterialId > 0)
            {
                where += " and " + nameof(RB_Allocate_Record_Extend.MaterialId) + "=" + dmodel.MaterialId;
            }
            if (dmodel.WarehouseId > 0)
            {
                where += " and " + nameof(RB_Allocate_Record_Extend.WarehouseId) + "=" + dmodel.WarehouseId;
            }
            string sql = $@" select * from RB_Allocate_Record {where} order by Id desc";
            return Get<RB_Allocate_Record_Extend>(sql).ToList();
        }
    }
}
