﻿using Dapper;
using Property.Model.Entity;
using Property.Model.Extend;
using REBORN.Common.Enum;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 请购单仓储类
    /// </summary>
    public partial class RB_Property_BuyingRequisitionRepository : RepositoryBase<RB_Property_BuyingRequisition>
    {
        /// <summary>
        /// 获取请购单分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_BuyingRequisition_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_BuyingRequisition_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pb.{0}={1}", nameof(RB_Property_BuyingRequisition_Extend.Status), 0);
            where += $@" and pb.RB_Group_Id={dmodel.RB_Group_Id}";            
            if (!string.IsNullOrEmpty(dmodel.Name)) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Name) + " like '%" + dmodel.Name+"%'";
            }
            if (dmodel.Id > 0) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Id) + " =" + dmodel.Id;
            }
            if (dmodel.Type > 0) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Type) + " =" + dmodel.Type;
            }
            if (dmodel.CreateBy > 0)
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateBy) + " =" + dmodel.CreateBy;
            }
            if (dmodel.ManagersId > 0)
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.ManagersId) + " =" + dmodel.ManagersId;
            }
            if (dmodel.BuyStatus > 0)
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + " =" + (int)dmodel.BuyStatus;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime)) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " >='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime)) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " <='" + dmodel.EndTime + " 23:59:59'";
            }
            string sql = $@" select pb.*,pc.Name as CategoryName from RB_Property_BuyingRequisition pb
left join rb_property_category pc on pb.CategoryId = pc.Id
{where} order by pb.Id desc";
            return GetPage<RB_Property_BuyingRequisition_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }
        /// <summary>
        /// 获取列表数据
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_BuyingRequisition_Extend> GetList(RB_Property_BuyingRequisition_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pb.{0}={1}", nameof(RB_Property_BuyingRequisition_Extend.Status), 0);
            where += $@" and pb.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrEmpty(dmodel.Name))
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (dmodel.Type > 0)
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Type) + " =" + dmodel.Type;
            }
            if (dmodel.BuyStatus > 0)
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + " =" + (int)dmodel.BuyStatus;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " >='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " <='" + dmodel.EndTime + " 23:59:59'";
            }
            string sql = $@" select pb.*,pc.Name as CategoryName from RB_Property_BuyingRequisition pb
left join rb_property_category pc on pb.CategoryId = pc.Id
{where} order by pb.Id desc";
            return Get<RB_Property_BuyingRequisition_Extend>(sql).ToList();
        }


        /// <summary>
        /// 获取待我审批分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_BuyingRequisition_Extend> GetBuyingRequisitionWaitMyAuditPageList(int pageIndex, int pageSize, RB_Property_BuyingRequisition_Extend dmodel, out long count)
        {
            var parameters = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pu.{0}={1}", nameof(RB_Property_BuyingRequisition_Extend.Status), 0);
            where += $@" and pu.RB_Group_Id={dmodel.RB_Group_Id}";

            if (!string.IsNullOrEmpty(dmodel.Name))
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.Name) + " like @Name";
                parameters.Add("Name", "%" + dmodel.Name + "%");
            }
            if (dmodel.Id > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.Id) + "=" + dmodel.Id;
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.Type > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.Type) + "=" + dmodel.Type;
            }
            if (dmodel.BuyStatus > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + "=" + (int)dmodel.BuyStatus;
            }
            if (dmodel.SchoolId >= 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.SchoolId) + "=" + dmodel.SchoolId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " >='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " <='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.CreateBy > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.CreateBy) + "=" + dmodel.CreateBy;
            }
            if (dmodel.ManagersId > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.ManagersId) + "=" + dmodel.ManagersId;
            }
            if (dmodel.IsWaitDeal == 1)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.ManagersId) + "=" + dmodel.ManagersId;
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + "=" + (int)BuyingRequisitionStatusEnum.Purchased;
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.ProcurementId) + "=0";
            }
            if (dmodel.AuditEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + "=" + (int)WFRrocessStatus.NotAudit;
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + "=" + (int)BuyingRequisitionStatusEnum.Pending;//需要申请单在审核中
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.SpecialNode) + " !=" + (int)WFSpecialNodeEnum.Pay;//排除签名的
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.TemplateType) + " =2";
            }
            if (dmodel.AuditedEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditedEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + " in(" + (int)WFRrocessStatus.AuditThrough + "," + (int)WFRrocessStatus.AuditNotThrough + "," + (int)WFRrocessStatus.Rejected + ")";
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.SpecialNode) + " !=" + (int)WFSpecialNodeEnum.Pay;//排除签名的
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.TemplateType) + " =2";
            }
            string sql = $@" select pu.*,pc.Name as CategoryName from 
RB_Property_BuyingRequisition pu 
left join rb_property_category pc on pu.CategoryId = pc.Id
left join rb_workflow_auditrecord wa on pu.Id=wa.WorkFlowId
LEFT JOIN rb_workflow_auditrelevance war on wa.AuditId=war.Id
{where} group by pu.Id order by pu.Id desc";
            return GetPage<RB_Property_BuyingRequisition_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取待我审批数量
        /// </summary>
        /// <param name="dmodel"></param>        
        /// <returns></returns>
        public int GetBuyingRequisitionWaitMyAuditCount(RB_Property_BuyingRequisition_Extend dmodel)
        {
            var parameters = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pu.{0}={1}", nameof(RB_Property_BuyingRequisition_Extend.Status), 0);
            where += $@" and pu.RB_Group_Id={dmodel.RB_Group_Id}";

            if (!string.IsNullOrEmpty(dmodel.Name))
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.Name) + " like @Name";
                parameters.Add("Name", "%" + dmodel.Name + "%");
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.Type > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.Type) + "=" + dmodel.Type;
            }
            if (dmodel.BuyStatus > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + "=" + (int)dmodel.BuyStatus;
            }
            if (dmodel.SchoolId > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.SchoolId) + "=" + dmodel.SchoolId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " >='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " <='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.CreateBy > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.CreateBy) + "=" + dmodel.CreateBy;
            }
            if (dmodel.ManagersId > 0)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.ManagersId) + "=" + dmodel.ManagersId;
            }
            if (dmodel.IsWaitDeal == 1)
            {
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.ManagersId) + "=" + dmodel.ManagersId;
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + "=" + (int)BuyingRequisitionStatusEnum.Purchased;
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.ProcurementId) + "=0";
            }
            if (dmodel.AuditEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + "=" + (int)WFRrocessStatus.NotAudit;
                where += " and pu." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + "=" + (int)BuyingRequisitionStatusEnum.Pending;//需要申请单在审核中
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.SpecialNode) + " !=" + (int)WFSpecialNodeEnum.Pay;//排除签名的
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.TemplateType) + " =2";
            }
            if (dmodel.AuditedEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditedEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + " in(" + (int)WFRrocessStatus.AuditThrough + "," + (int)WFRrocessStatus.AuditNotThrough + "," + (int)WFRrocessStatus.Rejected + ")";
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.SpecialNode) + " !=" + (int)WFSpecialNodeEnum.Pay;//排除签名的
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.TemplateType) + " =2";
            }

            string sql = $@"
SELECT COUNT(0) as Number FROM(
select pu.Id from 
RB_Property_BuyingRequisition pu 
left join rb_workflow_auditrecord wa on pu.Id=wa.WorkFlowId
LEFT JOIN rb_workflow_auditrelevance war on wa.AuditId=war.Id
{where} group by pu.Id)t";
            return Get<RB_Property_UseReceive_Extend>(sql).FirstOrDefault()?.Number ?? 0;
        }
    }
}
