﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dapper;

namespace Property.Repository
{
    /// <summary>
    /// 资产采购明细仓储类
    /// </summary>
    public partial class RB_Property_ProcurementDetailRepository : RepositoryBase<RB_Property_ProcurementDetail>
    {
        /// <summary>
        /// 获取岗位分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_ProcurementDetail_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_ProcurementDetail_Extend dmodel, out long count)
        {
            DynamicParameters parms = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Property_ProcurementDetail_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.ProcurementId > 0)
            {
                where += " and pc." + nameof(RB_Property_ProcurementDetail_Extend.ProcurementId) + "=" + dmodel.ProcurementId;
            }
            if (!string.IsNullOrEmpty(dmodel.ProcurementIds))
            {
                where += " and pc." + nameof(RB_Property_ProcurementDetail_Extend.ProcurementId) + " in(" + dmodel.ProcurementIds + ")";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyName))
            {
                where += " and pc.PropertyName like @PropertyName";
                parms.Add("PropertyName", "%" + dmodel.PropertyName + "%");
            }

            string sql = $@" select pc.* from RB_Property_ProcurementDetail pc
{where} order by pc.Id desc";
            return GetPage<RB_Property_ProcurementDetail_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 根据条件获取岗位列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_ProcurementDetail_Extend> GetList(RB_Property_ProcurementDetail_Extend dmodel)
        {
            DynamicParameters parms = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Property_ProcurementDetail_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.ProcurementId > 0)
            {
                where += " and pc." + nameof(RB_Property_ProcurementDetail_Extend.ProcurementId) + "=" + dmodel.ProcurementId;
            }
            if (!string.IsNullOrEmpty(dmodel.ProcurementIds))
            {
                where += " and pc." + nameof(RB_Property_ProcurementDetail_Extend.ProcurementId) + " in(" + dmodel.ProcurementIds + ")";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyName))
            {
                where += " and pc.PropertyName like @PropertyName";
                parms.Add("PropertyName", "%" + dmodel.PropertyName + "%");
            }

            string sql = $@" select pc.* from RB_Property_ProcurementDetail pc
{where} order by pc.Id desc";
            return Get<RB_Property_ProcurementDetail_Extend>(sql).ToList();
        }
    }
}
