﻿using Property.Model.Entity;
using Property.Model.Extend;
using REBORN.Common.Enum;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产入库明细仓储类
    /// </summary>
    public partial class RB_Property_StockinDetailRepository : RepositoryBase<RB_Property_StockinDetail>
    {
        /// <summary>
        /// 获取入库明细数据
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_StockinDetail_Extend> GetList(RB_Property_StockinDetail_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND ssd.{0}={1}", nameof(RB_Property_StockinDetail_Extend.Status), 0);
            where += $@" and ssd.RB_Group_Id={dmodel.RB_Group_Id}";

            if (dmodel.StockInId > 0)
            {
                where += " and ssd." + nameof(RB_Property_StockinDetail_Extend.StockInId) + "=" + dmodel.StockInId;
            }
            if (dmodel.PropertyId > 0)
            {
                where += " and ssd." + nameof(RB_Property_StockinDetail_Extend.PropertyId) + "=" + dmodel.PropertyId;
            }
            if (!string.IsNullOrEmpty(dmodel.StockInIdStr))
            {
                where += " and ssd." + nameof(RB_Property_StockinDetail_Extend.StockInId) + " in(" + dmodel.StockInIdStr + ")";
            }

            string sql = $@" select ssd.*,pc.Name as CategoryName
from RB_Property_StockinDetail ssd 
left join rb_property_category pc on pc.Id=ssd.CategoryId
{where} order by ssd.Id desc";
            return Get<RB_Property_StockinDetail_Extend>(sql).ToList();
        }

    }
}
