﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dapper;

namespace Property.Repository
{
    /// <summary>
    /// 耗材采购明细仓储类
    /// </summary>
    public partial class RB_Supplies_ProcurementDetailRepository : RepositoryBase<RB_Supplies_ProcurementDetail>
    {
        /// <summary>
        /// 获取岗位分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_ProcurementDetail_Extend> GetPageList(int pageIndex, int pageSize, RB_Supplies_ProcurementDetail_Extend dmodel, out long count)
        {
            DynamicParameters parms = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Supplies_ProcurementDetail_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.ProcurementId > 0)
            {
                where += " and pc." + nameof(RB_Supplies_ProcurementDetail_Extend.ProcurementId) + "=" + dmodel.ProcurementId;
            }
            if (!string.IsNullOrEmpty(dmodel.ProcurementIds))
            {
                where += " and pc." + nameof(RB_Supplies_ProcurementDetail_Extend.ProcurementId) + " in(" + dmodel.ProcurementIds + ")";
            }

            string sql = $@" select pc.* from RB_Supplies_ProcurementDetail pc
{where} order by pc.Id desc";
            return GetPage<RB_Supplies_ProcurementDetail_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_ProcurementDetail_Extend> GetList(RB_Supplies_ProcurementDetail_Extend dmodel)
        {
            DynamicParameters parms = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Supplies_ProcurementDetail_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.ProcurementId > 0)
            {
                where += " and pc." + nameof(RB_Supplies_ProcurementDetail_Extend.ProcurementId) + "=" + dmodel.ProcurementId;
            }
            if (!string.IsNullOrEmpty(dmodel.ProcurementIds))
            {
                where += " and pc." + nameof(RB_Supplies_ProcurementDetail_Extend.ProcurementId) + " in(" + dmodel.ProcurementIds + ")";
            }

            string sql = $@" select pc.*,m.Name as SuppliesName,m.SuppliesNum,m.BrandName,m.Units,m.CategoryId from RB_Supplies_ProcurementDetail pc
left join rb_supplies_material m on pc.MaterialId = m.Id
{where} order by pc.Id desc";
            return Get<RB_Supplies_ProcurementDetail_Extend>(sql).ToList();
        }
    }
}
