﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dapper;

namespace Property.Repository
{
    /// <summary>
    /// 耗材采购仓储类
    /// </summary>
    public partial class RB_Supplies_ProcurementRepository : RepositoryBase<RB_Supplies_Procurement>
    {
        /// <summary>
        /// 获取分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Procurement_Extend> GetPageList(int pageIndex, int pageSize, RB_Supplies_Procurement_Extend dmodel, out long count)
        {
            DynamicParameters parms = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Supplies_Procurement_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.SchoolId > 0)
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.SchoolId) + "=" + dmodel.SchoolId;
            }
            if (dmodel.Id > 0)
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.Id) + "=" + dmodel.Id;
            }
            if (dmodel.StockInStatus > 0)
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.StockInStatus) + "=" + dmodel.StockInStatus;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.CreateDate) + " >='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.CreateDate) + " <='" + dmodel.EndTime + " 23:59:59'";
            }
            if (!string.IsNullOrEmpty(dmodel.SuppliesName))
            {
                where += " and m.Name like @SuppliesName";
                parms.Add("SuppliesName", "%" + dmodel.SuppliesName + "%");
            }

            string sql = $@" select pc.* from RB_Supplies_Procurement pc
left join rb_supplies_procurementdetail pc2 on pc.Id=pc2.ProcurementId
left join rb_supplies_material m on pc2.MaterialId = m.Id
{where} group by pc.Id order by pc.Id desc";
            return GetPage<RB_Supplies_Procurement_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_Procurement_Extend> GetList(RB_Supplies_Procurement_Extend dmodel)
        {
            DynamicParameters parms = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Supplies_Procurement_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.SchoolId > 0)
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.SchoolId) + "=" + dmodel.SchoolId;
            }
            if (dmodel.StockInStatus > 0)
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.StockInStatus) + "=" + dmodel.StockInStatus;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.CreateDate) + " >='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pc." + nameof(RB_Supplies_Procurement_Extend.CreateDate) + " <='" + dmodel.EndTime + " 23:59:59'";
            }
            if (!string.IsNullOrEmpty(dmodel.SuppliesName))
            {
                where += " and m.Name like @SuppliesName";
                parms.Add("SuppliesName", "%" + dmodel.SuppliesName + "%");
            }

            string sql = $@" select pc.* from RB_Supplies_Procurement pc
left join rb_supplies_procurementdetail pc2 on pc.Id=pc2.ProcurementId
left join rb_supplies_material m on pc2.MaterialId = m.Id
{where} group by pc.Id order by pc.Id desc";
            return Get<RB_Supplies_Procurement_Extend>(sql).ToList();
        }
    }
}
