﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dapper;

namespace Property.Repository
{
    /// <summary>
    /// 耗材出库申请明细仓储类
    /// </summary>
    public partial class RB_Supplies_StockOutApplyForDetailRepository : RepositoryBase<RB_Supplies_StockOutApplyForDetail>
    {
        /// <summary>
        /// 获取岗位分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockOutApplyForDetail_Extend> GetPageList(int pageIndex, int pageSize, RB_Supplies_StockOutApplyForDetail_Extend dmodel, out long count)
        {
            DynamicParameters parms = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Supplies_StockOutApplyForDetail_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.ApplyForId > 0)
            {
                where += " and pc." + nameof(RB_Supplies_StockOutApplyForDetail_Extend.ApplyForId) + "=" + dmodel.ApplyForId;
            }
            if (!string.IsNullOrEmpty(dmodel.ApplyForIds))
            {
                where += " and pc." + nameof(RB_Supplies_StockOutApplyForDetail_Extend.ApplyForId) + " in(" + dmodel.ApplyForIds + ")";
            }

            string sql = $@" select pc.* from RB_Supplies_StockOutApplyForDetail pc
{where} order by pc.Id desc";
            return GetPage<RB_Supplies_StockOutApplyForDetail_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockOutApplyForDetail_Extend> GetList(RB_Supplies_StockOutApplyForDetail_Extend dmodel)
        {
            DynamicParameters parms = new DynamicParameters();
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Supplies_StockOutApplyForDetail_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.ApplyForId > 0)
            {
                where += " and pc." + nameof(RB_Supplies_StockOutApplyForDetail_Extend.ApplyForId) + "=" + dmodel.ApplyForId;
            }
            if (!string.IsNullOrEmpty(dmodel.ApplyForIds))
            {
                where += " and pc." + nameof(RB_Supplies_StockOutApplyForDetail_Extend.ApplyForId) + " in(" + dmodel.ApplyForIds + ")";
            }

            string sql = $@" select pc.*,m.Name as SuppliesName,m.SuppliesNum,m.BrandName,m.Units,c.Name as CategoryName from RB_Supplies_StockOutApplyForDetail pc
left join rb_supplies_material m on m.Id = pc.SuppliesId
left join rb_property_category c on c.Id = m.CategoryId
{where} order by pc.Id desc";
            return Get<RB_Supplies_StockOutApplyForDetail_Extend>(sql).ToList();
        }
    }
}
