﻿using Dapper;
using Property.Model.Entity;
using Property.Model.Extend;
using REBORN.Common.Enum;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 财务流程费用配置仓储层
    /// </summary>
    public class RB_Finance_ConfigRepository : RepositoryBase<RB_Finance_Config>
    {
        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Finance_Config_ViewModel> GetList(RB_Finance_Config_ViewModel demodel)
        {
            string where = $@" 1=1 and Status =0";

            if (demodel.Group_Id > 0)
            {
                where += $@" and {nameof(RB_Finance_Config_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (demodel.Type > 0)
            {
                where += $@" and {nameof(RB_Finance_Config_ViewModel.Type)} ={(int)demodel.Type}";
            }

            string sql = $@" select * from RB_Finance_Config where {where} order by Id desc";
            return Get<RB_Finance_Config_ViewModel>(sql).ToList();
        }

        /// <summary>
        /// 更新教育商品统计表 成本价格
        /// </summary>
        /// <param name="costMoney"></param>
        /// <param name="mallOrderId"></param>
        public void UpdateEduGoodsCostMoney(decimal costMoney, int mallOrderId)
        {
            string sql = $@"update rb_goods_order set CostMoney ={costMoney} where MallOrderId ={mallOrderId}";
            Execute(sql);
        }

        /// <summary>
        /// 更新教育商品统计表 订单明细成本价格
        /// </summary>
        /// <param name="costMoney"></param>
        /// <param name="mallOrderId"></param>
        /// <param name="suppliesId"></param>
        public void UpdateEduGoodsDetailCostMoney(decimal costMoney, int mallOrderId, int suppliesId)
        {
            string sql = $@"update rb_goods_orderdetail set CostMoney ={costMoney} where MallOrderId ={mallOrderId} and MaterialId ={suppliesId}";
            Execute(sql);
        }
    }
}
