﻿using REBORN.Common;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;
using Property.Model.Entity;
using Property.Model.Extend;
using Property.Repository;
using System;
using System.Collections.Generic;
using System.Linq;
using Newtonsoft.Json;
using REBORN.Commom.Plugin;
using System.IO;
using Property.Repository.Supplies;
using Property.Model.Extend.Supplies;
using Newtonsoft.Json.Linq;
using REBORN.Common.API;
using Property.Repository.Mall;

namespace Property.Module.FixedAssets
{
    /// <summary>
    /// 耗材模块
    /// </summary>
    public class SuppliesModule
    {
        /// <summary>
        /// 物料档案
        /// </summary>
        private readonly RB_Supplies_MaterialRepository supplies_MaterialRepository = new RB_Supplies_MaterialRepository();
        /// <summary>
        /// 仓库
        /// </summary>
        private readonly RB_Supplies_WareHouseRepository supplies_WareHouseRepository = new RB_Supplies_WareHouseRepository();
        /// <summary>
        /// 入库单
        /// </summary>
        private readonly RB_Supplies_StockInRepository supplies_StockInRepository = new RB_Supplies_StockInRepository();
        /// <summary>
        /// 入库明细
        /// </summary>
        private readonly RB_Supplies_StockInDetailRepository supplies_StockInDetailRepository = new RB_Supplies_StockInDetailRepository();
        /// <summary>
        /// 库存表
        /// </summary>
        private readonly RB_Supplies_InventoryRepository supplies_InventoryRepository = new RB_Supplies_InventoryRepository();
        /// <summary>
        /// 库存明细表
        /// </summary>
        private readonly RB_Supplies_InventoryDetailRepository supplies_InventoryDetailRepository = new RB_Supplies_InventoryDetailRepository();
        /// <summary>
        /// 出库单
        /// </summary>
        private readonly RB_Supplies_StockOutRepository supplies_StockOutRepository = new RB_Supplies_StockOutRepository();
        /// <summary>
        /// 出库单明细
        /// </summary>
        private readonly RB_Supplies_StockOutDetailRepository supplies_StockOutDetailRepository = new RB_Supplies_StockOutDetailRepository();
        /// <summary>
        /// 校区
        /// </summary>
        private readonly RB_SchoolRepository schoolRepository = new RB_SchoolRepository();
        /// <summary>
        /// 部门
        /// </summary>
        private readonly RB_DepartmentRepository departmentRepository = new RB_DepartmentRepository();
        /// <summary>
        /// 人员
        /// </summary>
        private readonly RB_AccountRepository employeeRepository = new RB_AccountRepository();
        //耗材申请
        private readonly RB_Supplies_ApplyforRepository supplies_ApplyforRepository = new RB_Supplies_ApplyforRepository();
        private readonly RB_Supplies_ApplyforWeekdayRepository supplies_ApplyforWeekdayRepository = new RB_Supplies_ApplyforWeekdayRepository();
        private readonly RB_Supplies_ApplyforSpecialRepository supplies_ApplyforSpecialRepository = new RB_Supplies_ApplyforSpecialRepository();
        /// <summary>
        /// 分类
        /// </summary>
        private readonly RB_Property_CategoryRepository property_CategoryRepository = new RB_Property_CategoryRepository();
        /// <summary>
        /// 资产
        /// </summary>
        private readonly RB_Property_InfoRepository property_InfoRepository = new RB_Property_InfoRepository();
        /// <summary>
        /// 资产日志
        /// </summary>
        private readonly RB_Property_LogRepository property_LogRepository = new RB_Property_LogRepository();
        /// <summary>
        /// 调拨记录
        /// </summary>
        private readonly RB_Allocate_RecordRepository allocate_RecordRepository = new RB_Allocate_RecordRepository();
        /// <summary>
        /// 采购单
        /// </summary>
        private readonly RB_ProcurementRepository procurementRepository = new RB_ProcurementRepository();
        /// <summary>
        /// 采购单明细
        /// </summary>
        private readonly RB_Procurement_DetailRepository procurement_DetailRepository = new RB_Procurement_DetailRepository();
        /// <summary>
        /// 盘点单
        /// </summary>
        private readonly RB_Supplies_CheckRepository supplies_CheckRepository = new RB_Supplies_CheckRepository();
        /// <summary>
        /// 盘点明细
        /// </summary>
        private readonly RB_Supplies_CheckDetailRepository supplies_CheckDetailRepository = new RB_Supplies_CheckDetailRepository();

        /// <summary>
        ///盘点报损记录
        /// </summary>
        private readonly RB_Supplies_ReportLossRecordRepository suppliesReportLossRecordRepository = new RB_Supplies_ReportLossRecordRepository();
        /// <summary>
        /// 盘点报损记录详情
        /// </summary>
        private readonly RB_Supplies_ReportLossRecordDetailRepository suppliesReportLossRecordDetailRepository = new RB_Supplies_ReportLossRecordDetailRepository();

        /// <summary>
        /// 耗材入库审核
        /// </summary>
        private readonly Rb_Workflow_TemplateRepository workflow_TemplateRepository = new Rb_Workflow_TemplateRepository();
        private readonly Rb_Workflow_AuditrecordRepository workflow_AuditrecordRepository = new Rb_Workflow_AuditrecordRepository();
        private readonly Rb_Workflow_AuditRelevanceRepository workflow_AuditRelevanceRepository = new Rb_Workflow_AuditRelevanceRepository();
        private readonly RB_Workfolw_Change_LogRepository workfolw_Change_LogRepository = new RB_Workfolw_Change_LogRepository();
        /// <summary>
        /// 出库审核
        /// </summary>
        private readonly RB_WarehouseOut_GoodsDetailRepository warehouseOutGoodsDetailRepository = new RB_WarehouseOut_GoodsDetailRepository();
        /// <summary>
        /// 有效期
        /// </summary>
        private readonly RB_Supplies_StockInValidityRepository supplies_StockInValidityRepository = new RB_Supplies_StockInValidityRepository();
        /// <summary>
        /// 耗材采购
        /// </summary>
        private readonly RB_Supplies_ProcurementRepository supplies_ProcurementRepository = new RB_Supplies_ProcurementRepository();
        /// <summary>
        /// 耗材采购明细
        /// </summary>
        private readonly RB_Supplies_ProcurementDetailRepository supplies_ProcurementDetailRepository = new RB_Supplies_ProcurementDetailRepository();
        /// <summary>
        /// 请购单id
        /// </summary>
        private readonly RB_Property_BuyingRequisitionRepository property_BuyingRequisitionRepository = new RB_Property_BuyingRequisitionRepository();
        /// <summary>
        /// 财务流程费用配置
        /// </summary>
        private readonly RB_Finance_ConfigRepository finance_ConfigRepository = new RB_Finance_ConfigRepository();
        /// <summary>
        /// 供应商
        /// </summary>
        private readonly RB_Property_SupplierRepository property_SupplierRepository = new RB_Property_SupplierRepository();
        /// <summary>
        /// 付款对象
        /// </summary>
        private readonly RB_ClientBankAccountRepository clientBankAccountRepository = new RB_ClientBankAccountRepository();
        /// <summary>
        /// 出库申请
        /// </summary>
        private readonly RB_Supplies_StockOutApplyForRepository supplies_StockOutApplyForRepository = new RB_Supplies_StockOutApplyForRepository();
        /// <summary>
        /// 出库申请明细
        /// </summary>
        private readonly RB_Supplies_StockOutApplyForDetailRepository supplies_StockOutApplyForDetailRepository = new RB_Supplies_StockOutApplyForDetailRepository();
        /// <summary>
        /// 流程
        /// </summary>
        private readonly RB_FinanceFlowConnectRepository financeFlowConnectRepository = new RB_FinanceFlowConnectRepository();
        /// <summary>
        /// 流程
        /// </summary>
        private readonly RB_Property_AuditRelevanceRepository auditRelevanceRepository = new RB_Property_AuditRelevanceRepository();
        /// <summary>
        /// 电商商品
        /// </summary>
        private readonly RB_Goods_OrderDetailRepository goods_OrderDetailRepository = new RB_Goods_OrderDetailRepository();



        //流程模板
        private readonly WorkFlowModule workFlowModule = new WorkFlowModule();



        #region 基础配置

        /// <summary>
        /// 获取物料详情
        /// </summary>
        /// <param name="materialId"></param>
        /// <returns></returns>
        public RB_Supplies_Material_Extend GetMaterialInfo(int materialId)
        {
            var model = supplies_MaterialRepository.GetEntity(materialId).RefMapperTo<RB_Supplies_Material_Extend>();
            if (model == null)
            {
                return new RB_Supplies_Material_Extend();
            }

            if (model.Images == "" || model.Images == null)
            {
                model.Images = "[]";
            }
            var imglist = JsonConvert.DeserializeObject<List<string>>(model.Images);
            model.ImageList = new List<string>();
            foreach (var img in imglist)
            {
                model.ImageList.Add(Config.GetFileUrl(img));
            }
            if (model.CategoryId > 0)
            {
                model.CategoryName = property_CategoryRepository.GetEntity(model.CategoryId)?.Name ?? "";
            }
            return model;
        }

        /// <summary>
        /// 获取物料档案分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Material_Extend> GetMaterialPageList(int pageIndex, int pageSize, RB_Supplies_Material_Extend demodel, out long count)
        {
            var list = supplies_MaterialRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Supplies_Inventory_Extend> iList = new List<RB_Supplies_Inventory_Extend>();
            if (demodel.WareHouseId > 0 && list.Any())
            {
                //查询出该仓库  耗材下 所有的库存
                string Sstr = string.Join(",", list.Select(x => x.Id).Distinct());
                iList = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseIdStr = demodel.WareHouseId.Value.ToString(), SuppliesIdStr = Sstr });
            }
            if (demodel.IsSelectInventory == 1 && list.Any()) {
                string Sstr = string.Join(",", list.Select(x => x.Id).Distinct());
                iList = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, SuppliesIdStr = Sstr });
            }
            foreach (var item in list)
            {
                if (item.Images == "" || item.Images == null)
                {
                    item.Images = "[]";
                }
                var imglist = JsonConvert.DeserializeObject<List<string>>(item.Images);
                item.ImageList = new List<string>();
                foreach (var img in imglist)
                {
                    item.ImageList.Add(Config.GetFileUrl(img));
                }
                item.InventoryNum = iList.Where(x => x.SuppliesId == item.Id)?.Sum(x => x.Number ?? 0);
                item.GoodsSpecificationList = new List<string>();
                item.GoodsCategoryList = new List<string>();
                if (!string.IsNullOrEmpty(item.SpecificationName))
                {
                    item.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(item.SpecificationName);
                }
                if (!string.IsNullOrEmpty(item.GoodsCategoryName))
                {
                    item.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(item.GoodsCategoryName);
                }
            }
            return list;
        }

        /// <summary>
        /// 获取物料档案列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_Material_Extend> GetMaterialList(RB_Supplies_Material_Extend demodel)
        {
            var list = supplies_MaterialRepository.GetList(demodel);
            return list;
        }

        /// <summary>
        /// 设置物料档案信息
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetMaterialInfo(RB_Supplies_Material_Extend demodel)
        {
            if (demodel.Id > 0)
            {
                //图片处理
                List<string> imgList = new List<string>();
                ImageOperation(demodel.ImageList, out imgList);//转移图片  未做删除处理
                demodel.Images = JsonConvert.SerializeObject(imgList);

                var dmodel = supplies_MaterialRepository.GetEntity(demodel.Id);
                dmodel.BrandName = demodel.BrandName;
                dmodel.CategoryId = demodel.CategoryId;
                dmodel.Images = demodel.Images;
                dmodel.Money = demodel.Money;
                dmodel.Name = demodel.Name;
                dmodel.Remark = demodel.Remark;
                dmodel.Units = demodel.Units;
                dmodel.UpdateBy = demodel.UpdateBy;
                dmodel.UpdateDate = demodel.UpdateDate;
                dmodel.Barcode = demodel.Barcode;
                dmodel.ReservedStock = demodel.ReservedStock;
                dmodel.SafetyStock = demodel.SafetyStock;
                dmodel.SupplierName = demodel.SupplierName;
                dmodel.SuppliesModel = demodel.SuppliesModel;
                dmodel.FeeType = demodel.FeeType;
                bool flag = supplies_MaterialRepository.Update(dmodel);
                return flag;
            }
            else
            {
                //图片处理
                List<string> imgList = new List<string>();
                ImageOperation(demodel.ImageList, out imgList);//转移图片  未做删除处理
                demodel.Images = JsonConvert.SerializeObject(imgList);

                int PropertyId = supplies_MaterialRepository.Insert(demodel);
                bool flag = PropertyId > 0;
                if (flag)
                {
                    //编码自动生成
                    string BMStr = PropertyId.ToString();
                    if (BMStr.Length < 5)
                    {
                        switch (BMStr.Length)
                        {
                            case 1:
                                BMStr = "0000" + BMStr; break;
                            case 2:
                                BMStr = "000" + BMStr; break;
                            case 3:
                                BMStr = "00" + BMStr; break;
                            case 4:
                                BMStr = "0" + BMStr; break;
                        }
                    }
                    Dictionary<string, object> files = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_Material_Extend.SuppliesNum),BMStr}
                    };
                    List<WhereHelper> wheres = new List<WhereHelper>() {
                        new WhereHelper(){
                             FiledName=nameof(RB_Supplies_Material_Extend.Id),
                              FiledValue=PropertyId,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_MaterialRepository.Update(files, wheres);
                }
                return flag;
            }
        }

        /// <summary>
        /// 删除物料档案信息
        /// </summary>
        /// <param name="supplierId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelMaterialInfo(int materialId, UserInfo userInfo)
        {
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Supplies_Material_Extend.Status),(int)DateStateEnum.Delete},
                { nameof(RB_Supplies_Material_Extend.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Supplies_Material_Extend.UpdateDate),DateTime.Now},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                 FiledName=nameof(RB_Supplies_Material_Extend.Id),
                  FiledValue=materialId,
                   OperatorEnum=OperatorEnum.Equal
                }
            };
            return supplies_MaterialRepository.Update(files, wheres);
        }

        /// <summary>
        /// 获取仓库列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_WareHouse_Extend> GetWareHouseList(RB_Supplies_WareHouse_Extend demodel)
        {
            return supplies_WareHouseRepository.GetList(demodel);
        }

        /// <summary>
        /// 获取仓库分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_WareHouse_Extend> GetWareHousePageList(int pageIndex, int pageSize, RB_Supplies_WareHouse_Extend demodel, out long count)
        {
            return supplies_WareHouseRepository.GetPageList(pageIndex, pageSize, demodel, out count);
        }

        /// <summary>
        /// 处理图片
        /// </summary>
        /// <param name="images"></param>
        /// <param name="imgList"></param>
        private static void ImageOperation(List<string> images, out List<string> imgList)
        {
            imgList = new List<string>();
            if (images != null && images.Count() > 0)
            {
                for (int i = 0; i < images.Count(); i++)
                {
                    string userFile = "/New/Upload/Property/";
                    string NewFileUrl;
                    if (Config.GetFilePath(images[i]).Contains("/New/"))
                    {
                        NewFileUrl = Config.GetFilePath(images[i]).Replace("Temporary", "Property");
                    }
                    else
                    {
                        NewFileUrl = "/New" + Config.GetFilePath(images[i]).Replace("Temporary", "Property");
                    }
                    FileCommonHelper.OssFileMove(Config.GetFilePath(images[i]), userFile);
                    imgList.Add(NewFileUrl);
                }
            }
        }

        /// <summary>
        /// 设置仓库信息
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetWareHouseInfo(RB_Supplies_WareHouse_Extend demodel)
        {
            if (demodel.Id > 0)
            {
                Dictionary<string, object> files = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_WareHouse.Name),demodel.Name},
                    { nameof(RB_Supplies_WareHouse.UpdateBy),demodel.UpdateBy},
                    { nameof(RB_Supplies_WareHouse.UpdateDate),demodel.UpdateDate}
                };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_WareHouse.Id),
                          FiledValue=demodel.Id,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                return supplies_WareHouseRepository.Update(files, wheres);
            }
            else
            {
                return supplies_WareHouseRepository.Insert(demodel) > 0;
            }
        }

        /// <summary>
        /// 获取入库单列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockIn_Extend> GetStockInPageList(int pageIndex, int pageSize, RB_Supplies_StockIn_Extend demodel, out long count, bool IsFlow = true)
        {
            var list = supplies_StockInRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Supplies_StockInDetail_Extend> sdList = new List<RB_Supplies_StockInDetail_Extend>();
            List<Rb_Workflow_AuditRelevance_Extend> warlist = new List<Rb_Workflow_AuditRelevance_Extend>();

            if (list.Any())
            {
                //查询出所有的耗材详细
                string IdStr = string.Join(",", list.Select(x => x.Id).Distinct());
                sdList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockInIdStr = IdStr });
                //获取流程相关信息
                if (IsFlow)
                {
                    warlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(0, IdStr, null, 3);
                }
            }
            foreach (var item in list)
            {
                item.DetailList = sdList.Where(x => x.StockInId == item.Id).ToList();
                foreach (var qitem in item.DetailList)
                {
                    qitem.GoodsSpecificationList = new List<string>();
                    qitem.GoodsCategoryList = new List<string>();
                    if (!string.IsNullOrEmpty(qitem.SpecificationName))
                    {
                        qitem.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(qitem.SpecificationName);
                    }
                    if (!string.IsNullOrEmpty(qitem.GoodsCategoryName))
                    {
                        qitem.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(qitem.GoodsCategoryName);
                    }
                }

                //流程
                if (IsFlow)
                {
                    //下一步审核节点描述
                    var NextModel = warlist.Where(x => x.WorkFlowId == item.Id && x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort)?.FirstOrDefault();
                    if (item.Status != 1)
                    {
                        item.AuditDescription = NextModel != null ? NextModel.AuditDescription : "";
                    }
                }

                //凭证
                item.VoucherList = new List<VoucherModel>();
                if (!string.IsNullOrEmpty(item.Voucher) && item.Voucher != "[]") {
                    item.VoucherList = JsonHelper.DeserializeObject<List<VoucherModel>>(item.Voucher);
                }
            }

            return list;
        }

        /// <summary>
        /// 获取耗材入库详情
        /// </summary>
        /// <param name="stockInId"></param>
        /// <param name="rB_Group_id"></param>
        /// <returns></returns>
        public RB_Supplies_StockIn_Extend GetSuppliesStockInInfo(int stockInId, int rB_Group_id)
        {
            var model = supplies_StockInRepository.GetEntity<RB_Supplies_StockIn_Extend>(stockInId);
            if (model == null || model.RB_Group_Id != rB_Group_id) { return null; }

            model.DetailList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = rB_Group_id, StockInId = stockInId });

            //凭证
            model.VoucherList = new List<VoucherModel>();
            if (!string.IsNullOrEmpty(model.Voucher) && model.Voucher != "[]")
            {
                model.VoucherList = JsonHelper.DeserializeObject<List<VoucherModel>>(model.Voucher);
            }

            return model;
        }

        /// <summary>
        /// 获取退库单列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockIn_Extend> GetReturnsStockInPageList(int pageIndex, int pageSize, RB_Supplies_StockIn_Extend demodel, out long count, bool IsFlow = true)
        {
            var list = supplies_StockInRepository.GetReturnsPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Supplies_StockInDetail_Extend> sdList = new List<RB_Supplies_StockInDetail_Extend>();
            List<Rb_Workflow_AuditRelevance_Extend> warlist = new List<Rb_Workflow_AuditRelevance_Extend>();
            List<RB_Supplies_StockIn_Extend> outList = new List<RB_Supplies_StockIn_Extend>();//出库单

            if (list.Any())
            {
                //查询出所有的耗材详细
                string IdStr = string.Join(",", list.Select(x => x.Id).Distinct());
                sdList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockInIdStr = IdStr });
                //获取流程相关信息
                if (IsFlow)
                {
                    warlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(0, IdStr, null, 1);
                }
            }
            foreach (var item in list)
            {
                item.DetailList = sdList.Where(x => x.StockInId == item.Id).ToList();
                foreach (var qitem in item.DetailList)
                {
                    qitem.GoodsSpecificationList = new List<string>();
                    qitem.GoodsCategoryList = new List<string>();
                    if (!string.IsNullOrEmpty(qitem.SpecificationName))
                    {
                        qitem.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(qitem.SpecificationName);
                    }
                    if (!string.IsNullOrEmpty(qitem.GoodsCategoryName))
                    {
                        qitem.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(qitem.GoodsCategoryName);
                    }
                }

                //流程
                if (IsFlow)
                {
                    //下一步审核节点描述
                    var NextModel = warlist.Where(x => x.WorkFlowId == item.Id && x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort)?.FirstOrDefault();
                    if (item.Status != 1)
                    {
                        item.AuditDescription = NextModel != null ? NextModel.AuditDescription : "";
                    }
                }
            }

            return list;
        }

        /// <summary>
        /// 删除仓库
        /// </summary>
        /// <param name="wareHouseId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelWareHouseInfo(int wareHouseId, UserInfo userInfo)
        {
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Supplies_WareHouse.Status),(int)DateStateEnum.Delete},
                { nameof(RB_Supplies_WareHouse.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Supplies_WareHouse.UpdateDate),DateTime.Now}
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Supplies_WareHouse.Id),
                        FiledValue=wareHouseId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            return supplies_WareHouseRepository.Update(files, wheres);
        }

        /// <summary>
        /// 验证库存
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool ValidateStockInInfo(RB_Supplies_StockIn_Extend demodel)
        {
            //更新明细
            var list = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockInId = demodel.Id });
            //修改
            var UpdateList = list.Where(x => demodel.DetailList.Select(y => y.SuppliesId).Contains(x.SuppliesId)).ToList();
            //删除
            var DelList = list.Where(x => !demodel.DetailList.Select(y => y.SuppliesId).Contains(x.SuppliesId)).ToList();
            foreach (var item in UpdateList)
            {
                var dmodel = demodel.DetailList.Where(x => x.SuppliesId == item.SuppliesId).FirstOrDefault();
                if ((dmodel.Number ?? 0) - (item.Number ?? 0) < 0)
                {
                    //新增库存表数据
                    var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                    if (ilist.Any())
                    {
                        var iModel = ilist.FirstOrDefault();
                        if (iModel.Number < (item.Number ?? 0) - (dmodel.Number ?? 0))
                        {
                            return false;
                        }
                    }
                    else
                    {
                        return false;
                    }
                }
            }
            foreach (var item in DelList)
            {
                //新增库存表数据
                var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                if (ilist.Any())
                {
                    var iModel = ilist.FirstOrDefault();
                    if (iModel.Number < (item.Number ?? 0))
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            return true;
        }

        /// <summary>
        /// 验证库存
        /// </summary>
        /// <param name="stockInId"></param>
        /// <returns></returns>
        public bool ValidateStockInDel(int stockInId)
        {
            var Model = supplies_StockInRepository.GetEntity(stockInId);
            //更新明细
            var list = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = Model.RB_Group_Id, StockInId = stockInId });
            foreach (var item in list)
            {
                //新增库存表数据
                var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = Model.RB_Group_Id, WarehouseId = Model.WarehouseId, SuppliesId = item.SuppliesId });
                if (ilist.Any())
                {
                    var iModel = ilist.FirstOrDefault();
                    if (iModel.Number < (item.Number ?? 0))
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            return true;
        }

        /// <summary>
        /// 设置入库单
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetStockInInfo(RB_Supplies_StockIn_Extend demodel)
        {
            var trans = supplies_StockInRepository.DbTransaction;
            try
            {
                if (demodel.Id > 0)
                {
                    var model = supplies_StockInRepository.GetEntity(demodel.Id);
                    model.Money = demodel.Money;
                    model.Remark = demodel.Remark;
                    model.StockInDate = demodel.StockInDate;
                    model.SupplierName = demodel.SupplierName;
                    model.WarehouseId = demodel.WarehouseId;
                    model.UpdateBy = demodel.UpdateBy;
                    model.UpdateDate = demodel.UpdateDate;
                    model.StockInState = StockInStatusEnum.StockIn;
                    bool flag = supplies_StockInRepository.Update(model, trans);
                    if (flag)
                    {
                        //更新明细
                        var list = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockInId = demodel.Id });

                        //新增
                        var InsertList = demodel.DetailList.Where(x => !list.Select(y => y.SuppliesId).Contains(x.SuppliesId)).ToList();
                        //修改
                        var UpdateList = list.Where(x => demodel.DetailList.Select(y => y.SuppliesId).Contains(x.SuppliesId)).ToList();
                        //删除
                        var DelList = list.Where(x => !demodel.DetailList.Select(y => y.SuppliesId).Contains(x.SuppliesId)).ToList();
                        foreach (var item in InsertList)
                        {
                            supplies_StockInDetailRepository.Insert(new RB_Supplies_StockInDetail()
                            {
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                Money = item.Money,
                                Number = item.Number,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                Id = 0,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Remark = item.Remark,
                                Status = 0,
                                StockInId = demodel.Id,
                                SuppliesId = item.SuppliesId,
                                UnitPrice = item.UnitPrice,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate
                            }, trans);
                            //新增库存表数据
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number += item.Number;//增加库存
                                iModel.Money += item.Money;//增加库存金额
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = demodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.Number,
                                        Money = item.Money,
                                        RB_Branch_Id = demodel.RB_Branch_Id,
                                        RB_Group_Id = demodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "新增库存-修改入库单"
                                    }, trans);
                                }
                            }
                            else
                            {
                                //新增库存表
                                int iId = supplies_InventoryRepository.Insert(new RB_Supplies_Inventory()
                                {
                                    CreateBy = demodel.CreateBy,
                                    CreateDate = DateTime.Now,
                                    Id = 0,
                                    Number = item.Number,
                                    Money = item.Money,
                                    RB_Branch_Id = demodel.RB_Branch_Id,
                                    RB_Group_Id = demodel.RB_Group_Id,
                                    Status = 0,
                                    SuppliesId = item.SuppliesId,
                                    UpdateBy = demodel.UpdateBy,
                                    UpdateDate = demodel.UpdateDate,
                                    WarehouseId = demodel.WarehouseId
                                }, trans);
                                if (iId > 0)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = demodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iId,
                                        Number = item.Number,
                                        Money = item.Money,
                                        RB_Branch_Id = demodel.RB_Branch_Id,
                                        RB_Group_Id = demodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "新增库存-修改入库单"
                                    }, trans);
                                }
                            }
                        }
                        foreach (var item in UpdateList)
                        {
                            var dmodel = demodel.DetailList.Where(x => x.SuppliesId == item.SuppliesId).FirstOrDefault();
                            Dictionary<string, object> files = new Dictionary<string, object>() {
                                { nameof(RB_Supplies_StockInDetail.Money),dmodel.Money},
                                { nameof(RB_Supplies_StockInDetail.Number),dmodel.Number},
                                { nameof(RB_Supplies_StockInDetail.UnitPrice),dmodel.UnitPrice},
                                { nameof(RB_Supplies_StockInDetail.Remark),dmodel.Remark}
                            };
                            List<WhereHelper> wheres = new List<WhereHelper>() {
                                new WhereHelper(){
                                     FiledName=nameof(RB_Supplies_StockInDetail.Id),
                                      FiledValue=item.Id,
                                       OperatorEnum=OperatorEnum.Equal
                                }
                            };
                            bool dflag = supplies_StockInDetailRepository.Update(files, wheres, trans);
                            if (dflag)
                            {

                                //新增库存表数据
                                var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                                if (ilist.Any())
                                {
                                    var iModel = ilist.FirstOrDefault();
                                    iModel.Number += dmodel.Number;//增加库存
                                    iModel.Money += dmodel.Money;
                                    var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                    if (iflag)
                                    {
                                        //增加库存明细
                                        supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                        {
                                            CreateBy = demodel.CreateBy,
                                            CreateDate = DateTime.Now,
                                            InventoryId = iModel.Id,
                                            Number = dmodel.Number,
                                            Money = dmodel.Money,
                                            RB_Branch_Id = demodel.RB_Branch_Id,
                                            RB_Group_Id = demodel.RB_Group_Id,
                                            Status = 0,
                                            Type = 1,
                                            Id = 0,
                                            Description = "增加库存-修改入库单"
                                        }, trans);
                                    }
                                }
                                else
                                {
                                    //新增库存表
                                    int iId = supplies_InventoryRepository.Insert(new RB_Supplies_Inventory()
                                    {
                                        CreateBy = demodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        Id = 0,
                                        Number = dmodel.Number,
                                        Money = dmodel.Money,
                                        RB_Branch_Id = demodel.RB_Branch_Id,
                                        RB_Group_Id = demodel.RB_Group_Id,
                                        Status = 0,
                                        SuppliesId = item.SuppliesId,
                                        UpdateBy = demodel.UpdateBy,
                                        UpdateDate = demodel.UpdateDate,
                                        WarehouseId = demodel.WarehouseId
                                    }, trans);
                                    if (iId > 0)
                                    {
                                        //增加库存明细
                                        supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                        {
                                            CreateBy = demodel.CreateBy,
                                            CreateDate = DateTime.Now,
                                            InventoryId = iId,
                                            Number = dmodel.Number,
                                            Money = dmodel.Money,
                                            RB_Branch_Id = demodel.RB_Branch_Id,
                                            RB_Group_Id = demodel.RB_Group_Id,
                                            Status = 0,
                                            Type = 1,
                                            Id = 0,
                                            Description = "增加库存-修改入库单"
                                        }, trans);
                                    }
                                }
                            }
                        }
                        foreach (var item in DelList)
                        {
                            Dictionary<string, object> files = new Dictionary<string, object>() {
                                { nameof(RB_Supplies_StockInDetail.Status),(int)DateStateEnum.Delete}
                            };
                            List<WhereHelper> wheres = new List<WhereHelper>() {
                                new WhereHelper(){
                                     FiledName=nameof(RB_Supplies_StockInDetail.Id),
                                      FiledValue=item.Id,
                                       OperatorEnum=OperatorEnum.Equal
                                }
                            };
                            supplies_StockInDetailRepository.Update(files, wheres, trans);
                        }
                    }
                    supplies_StockInRepository.DBSession.Commit();
                    return flag;
                }
                else
                {
                    //生产编号
                    demodel.StockInState = StockInStatusEnum.StockIn;
                    int Id = supplies_StockInRepository.Insert(demodel, trans);
                    if (Id > 0)
                    {
                        //编码自动生成
                        string BMStr = Id.ToString();
                        if (BMStr.Length < 5)
                        {
                            switch (BMStr.Length)
                            {
                                case 1:
                                    BMStr = "0000" + BMStr; break;
                                case 2:
                                    BMStr = "000" + BMStr; break;
                                case 3:
                                    BMStr = "00" + BMStr; break;
                                case 4:
                                    BMStr = "0" + BMStr; break;
                            }
                        }
                        BMStr = "RK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                        Dictionary<string, object> files = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_StockIn.StockInNum),BMStr}
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Supplies_StockIn.Id),
                                  FiledValue=Id,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        supplies_StockInRepository.Update(files, wheres, trans);

                        //新增明细
                        foreach (var item in demodel.DetailList)
                        {
                            supplies_StockInDetailRepository.Insert(new RB_Supplies_StockInDetail()
                            {
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                Money = item.Money,
                                Number = item.Number,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                Id = 0,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Remark = item.Remark,
                                Status = 0,
                                StockInId = Id,
                                SuppliesId = item.SuppliesId,
                                UnitPrice = item.UnitPrice,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate
                            }, trans);

                            //新增库存表数据
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number += item.Number;//增加库存
                                iModel.Money += item.Money;
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = demodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.Number,
                                        Money = item.Money,
                                        RB_Branch_Id = demodel.RB_Branch_Id,
                                        RB_Group_Id = demodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "新增库存"
                                    }, trans);
                                }
                            }
                            else
                            {
                                //新增库存表
                                int iId = supplies_InventoryRepository.Insert(new RB_Supplies_Inventory()
                                {
                                    CreateBy = demodel.CreateBy,
                                    CreateDate = DateTime.Now,
                                    Id = 0,
                                    Number = item.Number,
                                    Money = item.Money,
                                    RB_Branch_Id = demodel.RB_Branch_Id,
                                    RB_Group_Id = demodel.RB_Group_Id,
                                    Status = 0,
                                    SuppliesId = item.SuppliesId,
                                    UpdateBy = demodel.UpdateBy,
                                    UpdateDate = demodel.UpdateDate,
                                    WarehouseId = demodel.WarehouseId
                                }, trans);
                                if (iId > 0)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = demodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iId,
                                        Number = item.Number,
                                        Money = item.Money,
                                        RB_Branch_Id = demodel.RB_Branch_Id,
                                        RB_Group_Id = demodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "新增库存"
                                    }, trans);
                                }
                            }
                        }

                    }

                    supplies_StockInRepository.DBSession.Commit();
                    return Id > 0;
                }
            }
            catch (Exception ex)
            {
                supplies_StockInRepository.DBSession.Rollback("SetStockInInfo");
                LogHelper.Write(ex, "SetStockInInfo");
                return false;
            }
        }

        /// <summary>
        /// 生成退库单
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public string SetReturnsStockInInfo(RB_Supplies_StockIn_Extend demodel)
        {
            #region 验证退库单

            var outModel = supplies_StockOutRepository.GetEntity(demodel.ReturnsId);
            var outDetailList = supplies_StockOutDetailRepository.GetList(new RB_Supplies_StockOutDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockOutId = demodel.ReturnsId });
            if (outModel == null) { return "出库单不存在"; }
            if (outModel.IsReturns == 1) { return "已重新入库，无法重复操作"; }
            if (outDetailList == null || !outDetailList.Any()) { return "出库存不存在!"; }

            foreach (var item in demodel.DetailList) {
                var detailmodel = outDetailList.Where(x => x.SuppliesId == item.SuppliesId).FirstOrDefault();
                if (detailmodel == null) { return "该出库商品不存在"; }
                if (item.Number > detailmodel.Number) {
                    return "物料编码：" + item.SuppliesId + " 不能大于出库数量";
                }
            }

            demodel.WarehouseId = outModel.WarehouseId;
            //demodel.Money = 0; //前端传递
            demodel.SupplierName = "重新入库";
            demodel.ProcurementId = 0;
            demodel.IsAgainStock = 1;
            demodel.ReturnsNo = outModel.StockOutNum;
            #endregion
            var trans = supplies_StockInRepository.DbTransaction;
            try
            {
                //生产编号
                demodel.StockInState = StockInStatusEnum.StockIn;
                int Id = supplies_StockInRepository.Insert(demodel, trans);
                if (Id > 0)
                {
                    //编码自动生成
                    string BMStr = Id.ToString();
                    if (BMStr.Length < 5)
                    {
                        switch (BMStr.Length)
                        {
                            case 1:
                                BMStr = "0000" + BMStr; break;
                            case 2:
                                BMStr = "000" + BMStr; break;
                            case 3:
                                BMStr = "00" + BMStr; break;
                            case 4:
                                BMStr = "0" + BMStr; break;
                        }
                    }
                    BMStr = "TK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                    Dictionary<string, object> files = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_StockIn.StockInNum),BMStr}
                    };
                    List<WhereHelper> wheres = new List<WhereHelper>() {
                        new WhereHelper(){
                                FiledName=nameof(RB_Supplies_StockIn.Id),
                                FiledValue=Id,
                                OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_StockInRepository.Update(files, wheres, trans);

                    //新增明细
                    foreach (var item in demodel.DetailList)
                    {
                        supplies_StockInDetailRepository.Insert(new RB_Supplies_StockInDetail()
                        {
                            CreateBy = demodel.CreateBy,
                            CreateDate = demodel.CreateDate,
                            Money = item.Money,
                            Number = item.Number,
                            RB_Branch_Id = demodel.RB_Branch_Id,
                            Id = 0,
                            RB_Group_Id = demodel.RB_Group_Id,
                            Remark = item.Remark,
                            Status = 0,
                            StockInId = Id,
                            SuppliesId = item.SuppliesId,
                            UnitPrice = item.UnitPrice,
                            UpdateBy = demodel.UpdateBy,
                            UpdateDate = demodel.UpdateDate
                        }, trans);

                        //新增库存表数据
                        var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                        if (ilist.Any())
                        {
                            var iModel = ilist.FirstOrDefault();
                            iModel.Number += item.Number;//增加库存
                            iModel.Money += item.Money;
                            var iflag = supplies_InventoryRepository.Update(iModel, trans);
                            if (iflag)
                            {
                                //增加库存明细
                                supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                {
                                    CreateBy = demodel.CreateBy,
                                    CreateDate = DateTime.Now,
                                    InventoryId = iModel.Id,
                                    Number = item.Number,
                                    Money = item.Money,
                                    RB_Branch_Id = demodel.RB_Branch_Id,
                                    RB_Group_Id = demodel.RB_Group_Id,
                                    Status = 0,
                                    Type = 1,
                                    Id = 0,
                                    Description = "新增库存 - 退库"
                                }, trans);
                            }
                        }
                        else
                        {
                            //新增库存表
                            int iId = supplies_InventoryRepository.Insert(new RB_Supplies_Inventory()
                            {
                                CreateBy = demodel.CreateBy,
                                CreateDate = DateTime.Now,
                                Id = 0,
                                Number = item.Number,
                                Money = item.Money,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Status = 0,
                                SuppliesId = item.SuppliesId,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate,
                                WarehouseId = demodel.WarehouseId
                            }, trans);
                            if (iId > 0)
                            {
                                //增加库存明细
                                supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                {
                                    CreateBy = demodel.CreateBy,
                                    CreateDate = DateTime.Now,
                                    InventoryId = iId,
                                    Number = item.Number,
                                    Money = item.Money,
                                    RB_Branch_Id = demodel.RB_Branch_Id,
                                    RB_Group_Id = demodel.RB_Group_Id,
                                    Status = 0,
                                    Type = 1,
                                    Id = 0,
                                    Description = "新增库存 - 退库"
                                }, trans);
                            }
                        }
                    }

                    #region 更新出库单  退库状态
                    Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_StockOut.IsReturns),1}
                    };
                    List<WhereHelper> wheres1 = new List<WhereHelper>() {
                        new WhereHelper(){
                             FiledName=nameof(RB_Supplies_StockOut.Id),
                              FiledValue=outModel.Id,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_StockOutRepository.Update(keyValues, wheres1, trans);
                    #endregion

                }

                supplies_StockInRepository.DBSession.Commit();
                return Id > 0 ? "" : "出错了，请联系管理员";
            }
            catch (Exception ex)
            {
                supplies_StockInRepository.DBSession.Rollback("SetReturnsStockInInfo");
                LogHelper.Write(ex, "SetReturnsStockInInfo");
                return "出错了，请联系管理员";
            }
        }


        /// <summary>
        /// 根据出库id  获取订单号
        /// </summary>
        /// <param name="stockOutIds"></param>
        /// <returns></returns>
        public List<Model.Extend.Mall.RB_WarehouseOut_GoodsDetail_Extend> GetStockOutOrderNoList(string stockOutIds)
        {
            return warehouseOutGoodsDetailRepository.GetStockOutOrderNoList(stockOutIds);
        }

        /// <summary>
        /// 领用统计
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public RB_Supplies_StockOutDetail_Extend GetRecipientsQueryTotal(RB_Supplies_StockOutDetail_Extend demodel)
        {
            var list = supplies_StockOutDetailRepository.GetRecipientsQueryTotal(demodel);
            return list.FirstOrDefault();
        }

        /// <summary>
        /// 获取领用列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockOutDetail_Extend> GetRecipientsQueryPageList(int pageIndex, int pageSize, RB_Supplies_StockOutDetail_Extend demodel, out long count)
        {
            var list = supplies_StockOutDetailRepository.GetRecipientsQueryPageList(pageIndex, pageSize, demodel, out count);
            List<RB_School_ViewModel> blist = new List<RB_School_ViewModel>();
            List<RB_Department_ViewModel> dlist = new List<RB_Department_ViewModel>();
            if (list.Any())
            {
                string bstr = string.Join(",", list.Select(x => x.BranchId ?? 0).Distinct());
                string dstr = string.Join(",", list.Select(x => x.DepartmentId ?? 0).Distinct());
                blist = schoolRepository.GetSchoolListRepository(new RB_School_ViewModel() { QSIds = bstr });
                dlist = departmentRepository.GetDepartmentListRepository(new RB_Department_ViewModel() { QDeptIds = dstr });
            }
            foreach (var item in list)
            {
                var bmodel = blist.Where(x => x.SId == item.BranchId).FirstOrDefault();
                var dmodel = dlist.Where(x => x.DeptId == item.DepartmentId).FirstOrDefault();
                item.BranchName = bmodel?.SName ?? "";
                item.DepartmentName = dmodel?.DeptName ?? "";
                item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                item.GoodsSpecificationList = new List<string>();
                item.GoodsCategoryList = new List<string>();
                if (!string.IsNullOrEmpty(item.SpecificationName))
                {
                    item.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(item.SpecificationName);
                }
                if (!string.IsNullOrEmpty(item.GoodsCategoryName))
                {
                    item.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(item.GoodsCategoryName);
                }
            }
            return list;
        }

        /// <summary>
        /// 获取库存分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Inventory_Extend> GetInventoryPageList(int pageIndex, int pageSize, RB_Supplies_Inventory_Extend demodel, out long count)
        {
            var list = supplies_InventoryRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            if (list.Any())
            {
                string wstr = string.Join(",", list.Select(x => x.WarehouseId ?? 0).Distinct());
                string sstr = string.Join(",", list.Select(x => x.SuppliesId ?? 0).Distinct());
                //查询仓库
                var wlist = supplies_WareHouseRepository.GetList(new RB_Supplies_WareHouse_Extend() { RB_Group_Id = demodel.RB_Group_Id, WareHouseIdStr = wstr });
                //查询耗材
                var mlist = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = demodel.RB_Group_Id, SuppliesIdStr = sstr }, true);
                List<RB_Supplies_StockInDetail_Extend> expList = new List<RB_Supplies_StockInDetail_Extend>();
                if (demodel.ExpiresDay > 0) {
                    string expirationDate = DateTime.Now.AddDays(demodel.ExpiresDay).ToString("yyyy-MM-dd");
                    //查询即将过期的商品  统计其数量
                    expList = supplies_StockInDetailRepository.GetRecentExpiresSuppliesNumList(demodel.RB_Group_Id ?? 0, sstr, expirationDate);
                }
                foreach (var item in list)
                {
                    item.WModel = wlist.Where(x => x.Id == item.WarehouseId).FirstOrDefault();
                    item.SModel = mlist.Where(x => x.Id == item.SuppliesId).FirstOrDefault();
                    if (item.WModel == null)
                    {
                        item.WModel = new RB_Supplies_WareHouse_Extend();
                    }
                    if (item.SModel == null)
                    {
                        item.SModel = new RB_Supplies_Material_Extend();
                    }
                    item.SModel.GoodsSpecificationList = new List<string>();
                    item.SModel.GoodsCategoryList = new List<string>();
                    if (!string.IsNullOrEmpty(item.SModel.SpecificationName))
                    {
                        item.SModel.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(item.SModel.SpecificationName);
                    }
                    if (!string.IsNullOrEmpty(item.SModel.GoodsCategoryName))
                    {
                        item.SModel.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(item.SModel.GoodsCategoryName);
                    }
                    //近期到期数量
                    item.RecentExpiresNum = expList.Where(x => x.SuppliesId == item.SuppliesId).FirstOrDefault()?.Number ?? 0;
                }
            }
            return list;
        }

        /// <summary>
        /// 获取库存明细分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_InventoryDetail_Extend> GetInventoryDetailPageList(int pageIndex, int pageSize, RB_Supplies_Inventory_Extend demodel, out long count)
        {
            var list = supplies_InventoryRepository.GetInventoryDetailPageList(pageIndex, pageSize, demodel, out count);
            return list;
        }

        /// <summary>
        /// 设置库存总金额
        /// </summary>
        /// <param name="inventoryId"></param>
        /// <param name="totalMoney"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public string SetInventoryMoney(int inventoryId, decimal totalMoney, UserInfo userInfo)
        {
            var imodel = supplies_InventoryRepository.GetEntity(inventoryId);
            if (imodel == null || imodel.Status ==1 || imodel.RB_Group_Id != userInfo.RB_Group_id) { return "库存不存在"; }
            if (imodel.Number == 0) { return "没有库存，无法修改总额"; }
            if (imodel.Money == totalMoney) { return ""; }

            Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                { nameof(RB_Supplies_Inventory_Extend.Money),totalMoney}
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                     FiledName=nameof(RB_Supplies_Inventory_Extend.Id),
                      FiledValue= imodel.Id,
                       OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_InventoryRepository.Update(keyValues, wheres);
            if (flag) {
                //插入记录
                supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                {
                    Id = 0,
                    InventoryId = imodel.Id,
                    Type = 1,
                    Number = 0,
                    Description = "修改库存总金额：由" + (imodel.Money ?? 0) + " 修改为" + totalMoney + "，当前库存：" + imodel.Number,
                    Status = 0,
                    Money = totalMoney - (imodel.Money ?? 0),
                    RB_Group_Id = imodel.RB_Group_Id,
                    RB_Branch_Id = imodel.RB_Branch_Id,
                    CreateBy = userInfo.EmployeeId,
                    CreateDate = DateTime.Now
                });
            }
            return flag ? "" : "出错了，请联系管理员";
        }

        /// <summary>
        /// 取消出库单
        /// </summary>
        /// <param name="stockOutId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool CancelStockOutInfo(int stockOutId, UserInfo userInfo)
        {
            var demodel = supplies_StockOutRepository.GetEntity(stockOutId);
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Supplies_StockOut.StockOutState),(int)StockOutStatusEnum.StockOutCancel},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Supplies_StockOut.Id),
                        FiledValue=stockOutId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_StockOutRepository.Update(files, wheres);
            if (flag && demodel.StockOutState == StockOutStatusEnum.StockOut)
            {
                //删除明细 ---  查库存操作
                var list = supplies_StockOutDetailRepository.GetList(new RB_Supplies_StockOutDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockOutId = stockOutId });
                foreach (var item in list)
                {
                    //减少库存表数据
                    var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                    if (ilist.Any())
                    {
                        var iModel = ilist.FirstOrDefault();
                        iModel.Number += item.Number;//增加库存
                        iModel.Money += item.Money;
                        var iflag = supplies_InventoryRepository.Update(iModel);
                        if (iflag)
                        {
                            //增加库存明细
                            supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                            {
                                CreateBy = userInfo.EmployeeId,
                                CreateDate = DateTime.Now,
                                InventoryId = iModel.Id,
                                Number = item.Number,
                                Money = item.Money,
                                RB_Branch_Id = userInfo.RB_Branch_id,
                                RB_Group_Id = userInfo.RB_Group_id,
                                Status = 0,
                                Type = 1,
                                Id = 0,
                                Description = "增加库存-取消出库单"
                            });
                        }
                    }
                }
            }
            return flag;
        }

        /// <summary>
        /// 删除出库单
        /// </summary>
        /// <param name="stockOutId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelStockOutInfo(int stockOutId, UserInfo userInfo)
        {
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Supplies_StockOut.StockOutState),(int)StockOutStatusEnum.StockOutCancel},
                { nameof(RB_Supplies_StockOut.Status),(int)DateStateEnum.Delete},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Supplies_StockOut.Id),
                        FiledValue=stockOutId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_StockOutRepository.Update(files, wheres);
            if (flag)
            {
                //删除明细 ---  查库存操作
                var list = supplies_StockOutDetailRepository.GetList(new RB_Supplies_StockOutDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, StockOutId = stockOutId });
                foreach (var item in list)
                {
                    Dictionary<string, object> files1 = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_StockOutDetail.Status),(int)DateStateEnum.Delete}
                    };
                    List<WhereHelper> wheres1 = new List<WhereHelper>() {
                        new WhereHelper(){
                                FiledName=nameof(RB_Supplies_StockOutDetail.Id),
                                FiledValue=item.Id,
                                OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_StockOutDetailRepository.Update(files1, wheres1);
                }
            }
            return flag;
        }

        /// <summary>
        /// 验证出库单库存是否足够
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool ValidateStockOutInsert(RB_Supplies_StockOut_Extend demodel)
        {
            //更新明细
            var list = demodel.DetailList;
            foreach (var item in list)
            {
                //新增库存表数据
                var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                if (ilist.Any())
                {
                    var iModel = ilist.FirstOrDefault();
                    if (iModel.Number < (item.Number ?? 0))
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            return true;
        }





        /// <summary>
        /// 保存出库单
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetStockOutInfo(RB_Supplies_StockOut_Extend demodel)
        {
            var trans = supplies_StockInRepository.DbTransaction;
            try
            {
                if (demodel.IsSelfApplication == 1)
                {
                    demodel.StockOutState = StockOutStatusEnum.StockOutWait;
                }
                else
                {
                    demodel.StockOutState = StockOutStatusEnum.StockOut;
                }
                if (demodel.Id > 0)
                {
                    var model = supplies_StockOutRepository.GetEntity(demodel.Id);
                    if (demodel.IsSelfApplication == 1 && model.StockOutState != StockOutStatusEnum.StockOutWait)
                    {
                        supplies_StockInRepository.DBSession.Commit();
                        return false;
                    }
                    var delList = supplies_StockOutDetailRepository.GetList(new RB_Supplies_StockOutDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockOutId = demodel.Id });
                    model.EmployeeId = demodel.EmployeeId;
                    model.WarehouseId = demodel.WarehouseId;
                    model.StockOutDate = demodel.StockOutDate;
                    model.Remark = demodel.Remark;
                    model.UpdateBy = demodel.UpdateBy;
                    model.UpdateDate = demodel.UpdateDate;
                    bool flag = supplies_StockOutRepository.Update(model, trans);
                    if (flag)
                    {
                        //删除明细
                        foreach (var item in delList)
                        {
                            supplies_StockOutDetailRepository.Delete(item);
                        }
                        //新增明细
                        foreach (var item in demodel.DetailList)
                        {
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                            decimal Price = 0;
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                Price = Math.Round((iModel.Money ?? 0) / (iModel.Number ?? 1), 2, MidpointRounding.AwayFromZero) * (item.Number ?? 0);
                            }
                            supplies_StockOutDetailRepository.Insert(new RB_Supplies_StockOutDetail()
                            {
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                Number = item.Number,
                                Money = Price,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                Id = 0,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Remark = item.Remark,
                                Status = 0,
                                StockOutId = demodel.Id,
                                SuppliesId = item.SuppliesId,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate
                            }, trans);

                            //新增库存表数据
                            if (ilist.Any() && demodel.StockOutState == StockOutStatusEnum.StockOut)
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number -= item.Number;//减少库存
                                iModel.Money -= Price;
                                if (iModel.Money < 0)
                                {
                                    iModel.Money = 0;
                                }
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = demodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.Number,
                                        Money = Price,
                                        RB_Branch_Id = demodel.RB_Branch_Id,
                                        RB_Group_Id = demodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 2,
                                        Id = 0,
                                        Description = "减少库存-出库"
                                    }, trans);
                                }
                            }
                        }
                    }
                    supplies_StockInRepository.DBSession.Commit();
                    return flag;
                }
                else
                {
                    int Id = supplies_StockOutRepository.Insert(demodel, trans);
                    if (Id > 0)
                    {
                        //编码自动生成
                        string BMStr = Id.ToString();
                        if (BMStr.Length < 5)
                        {
                            switch (BMStr.Length)
                            {
                                case 1:
                                    BMStr = "0000" + BMStr; break;
                                case 2:
                                    BMStr = "000" + BMStr; break;
                                case 3:
                                    BMStr = "00" + BMStr; break;
                                case 4:
                                    BMStr = "0" + BMStr; break;
                            }
                        }
                        BMStr = "CK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                        Dictionary<string, object> files = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_StockOut.StockOutNum),BMStr}
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                    FiledName=nameof(RB_Supplies_StockOut.Id),
                                    FiledValue=Id,
                                    OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        supplies_StockOutRepository.Update(files, wheres, trans);

                        //新增明细
                        foreach (var item in demodel.DetailList)
                        {
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                            decimal Price = 0;
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                Price = Math.Round((iModel.Money ?? 0) / (iModel.Number ?? 1), 2, MidpointRounding.AwayFromZero) * (item.Number ?? 0);
                            }
                            supplies_StockOutDetailRepository.Insert(new RB_Supplies_StockOutDetail()
                            {
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                Number = item.Number,
                                Money = Price,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                Id = 0,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Remark = item.Remark,
                                Status = 0,
                                StockOutId = Id,
                                SuppliesId = item.SuppliesId,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate
                            }, trans);

                            //新增库存表数据
                            if (ilist.Any() && demodel.StockOutState == StockOutStatusEnum.StockOut)
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number -= item.Number;//减少库存
                                iModel.Money -= Price;
                                if (iModel.Money < 0)
                                {
                                    iModel.Money = 0;
                                }
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = demodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.Number,
                                        Money = Price,
                                        RB_Branch_Id = demodel.RB_Branch_Id,
                                        RB_Group_Id = demodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 2,
                                        Id = 0,
                                        Description = "减少库存-出库"
                                    }, trans);
                                }
                            }
                        }
                    }
                    supplies_StockInRepository.DBSession.Commit();
                    return Id > 0;
                }
            }
            catch (Exception ex)
            {
                supplies_StockInRepository.DBSession.Rollback("SetStockOutInfo");
                LogHelper.Write(ex, "SetStockOutInfo");
                return false;
            }
        }

        /// <summary>
        /// 获取出库分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockOut_Extend> GetStockOutPageList(int pageIndex, int pageSize, RB_Supplies_StockOut_Extend demodel, out long count)
        {
            var list = supplies_StockOutRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Supplies_StockOutDetail_Extend> sdList = new List<RB_Supplies_StockOutDetail_Extend>();
            List<RB_Supplies_Inventory_Extend> iList = new List<RB_Supplies_Inventory_Extend>();
            if (list.Any())
            {
                //查询出所有的耗材详细
                string IdStr = string.Join(",", list.Select(x => x.Id).Distinct());
                sdList = supplies_StockOutDetailRepository.GetList(new RB_Supplies_StockOutDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockOutIdStr = IdStr });
                //获取库存
                if (sdList.Any())
                {
                    string Wstr = string.Join(",", list.Select(x => x.WarehouseId).Distinct());
                    string Sstr = string.Join(",", sdList.Select(x => x.SuppliesId).Distinct());
                    iList = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseIdStr = Wstr, SuppliesIdStr = Sstr });

                    foreach (var qitem in sdList)
                    {
                        qitem.GoodsSpecificationList = new List<string>();
                        qitem.GoodsCategoryList = new List<string>();
                        if (!string.IsNullOrEmpty(qitem.SpecificationName))
                        {
                            qitem.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(qitem.SpecificationName);
                        }
                        if (!string.IsNullOrEmpty(qitem.GoodsCategoryName))
                        {
                            qitem.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(qitem.GoodsCategoryName);
                        }
                    }
                }
            }
            foreach (var item in list)
            {
                item.DetailList = sdList.Where(x => x.StockOutId == item.Id).ToList();
                foreach (var citem in item.DetailList)
                {
                    citem.InventoryNum = iList.Where(x => x.WarehouseId == item.WarehouseId && x.SuppliesId == citem.SuppliesId).FirstOrDefault()?.Number ?? 0;
                }
            }

            return list;
        }

        /// <summary>
        /// 获取入库单详情
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        public RB_Supplies_StockIn GetStockInInfo(int Id)
        {
            return supplies_StockInRepository.GetEntity(Id);
        }

        /// <summary>
        /// 获取出库单详情
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        public RB_Supplies_StockOut GetStockOutInfo(int Id)
        {
            return supplies_StockOutRepository.GetEntity(Id);
        }

        /// <summary>
        /// 恢复入库单
        /// </summary>
        /// <param name="stockInId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool RecoverStockInInfo(int stockInId, UserInfo userInfo)
        {
            var demodel = supplies_StockInRepository.GetEntity(stockInId);
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Supplies_StockIn.StockInState),(int)StockInStatusEnum.StockIn},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Supplies_StockIn.Id),
                        FiledValue=stockInId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_StockInRepository.Update(files, wheres);
            if (flag)
            {
                //明细 ---  查库存操作
                var list = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockInId = stockInId });
                foreach (var item in list)
                {
                    //增加库存表数据
                    var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                    if (ilist.Any())
                    {
                        var iModel = ilist.FirstOrDefault();
                        iModel.Number += item.Number;//减少库存
                        iModel.Money += item.Money;
                        var iflag = supplies_InventoryRepository.Update(iModel);
                        if (iflag)
                        {
                            //增加库存明细
                            supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                            {
                                CreateBy = userInfo.EmployeeId,
                                CreateDate = DateTime.Now,
                                InventoryId = iModel.Id,
                                Number = item.Number,
                                Money = item.Money,
                                RB_Branch_Id = userInfo.RB_Branch_id,
                                RB_Group_Id = userInfo.RB_Group_id,
                                Status = 0,
                                Type = 1,
                                Id = 0,
                                Description = "增加库存-恢复入库单"
                            });
                        }
                    }
                }
            }
            return flag;
        }

        /// <summary>
        /// 取消入库单  需要减少库存
        /// </summary>
        /// <param name="stockInId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool CancelStockInInfo(int stockInId, UserInfo userInfo)
        {
            var demodel = supplies_StockInRepository.GetEntity(stockInId);
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Supplies_StockIn.StockInState),(int)StockInStatusEnum.StockInWarting},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Supplies_StockIn.Id),
                        FiledValue=stockInId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_StockInRepository.Update(files, wheres);
            if (flag)
            {
                //删除明细 ---  查库存操作
                var list = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockInId = stockInId });
                foreach (var item in list)
                {
                    //减少库存表数据
                    var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                    if (ilist.Any())
                    {
                        var iModel = ilist.FirstOrDefault();
                        iModel.Number -= item.Number;//减少库存
                        iModel.Money -= item.Money;
                        if (iModel.Money < 0)
                        {
                            iModel.Money = 0;
                        }
                        var iflag = supplies_InventoryRepository.Update(iModel);
                        if (iflag)
                        {
                            //增加库存明细
                            supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                            {
                                CreateBy = userInfo.EmployeeId,
                                CreateDate = DateTime.Now,
                                InventoryId = iModel.Id,
                                Number = item.Number,
                                Money = item.Money,
                                RB_Branch_Id = userInfo.RB_Branch_id,
                                RB_Group_Id = userInfo.RB_Group_id,
                                Status = 0,
                                Type = 2,
                                Id = 0,
                                Description = demodel.IsAgainStock == 1 ? "减少库存-取消退库单" : "减少库存-取消入库单"
                            });
                        }
                    }
                }
                if (demodel.IsAgainStock == 1 && demodel.ReturnsId > 0)
                {
                    //需更新出库单  退库状态
                    Dictionary<string, object> files2 = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_StockOut.IsReturns),0},
                    };
                    List<WhereHelper> wheres2 = new List<WhereHelper>() {
                        new WhereHelper(){
                                FiledName=nameof(RB_Supplies_StockOut.Id),
                                FiledValue=demodel.ReturnsId,
                                OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_StockOutRepository.Update(files2, wheres2);
                }
            }
            return flag;
        }

        /// <summary>
        /// 删除入库单
        /// </summary>
        /// <param name="stockInId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelStockInInfo(int stockInId, UserInfo userInfo)
        {
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Supplies_StockIn.StockInState),(int)StockInStatusEnum.StockInWarting},
                { nameof(RB_Supplies_StockIn.Status),(int)DateStateEnum.Delete},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Supplies_StockIn.Id),
                        FiledValue=stockInId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_StockInRepository.Update(files, wheres);
            if (flag)
            {
                //删除明细 ---  查库存操作
                var list = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, StockInId = stockInId });
                foreach (var item in list)
                {
                    Dictionary<string, object> files1 = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_StockInDetail.Status),(int)DateStateEnum.Delete}
                    };
                    List<WhereHelper> wheres1 = new List<WhereHelper>() {
                        new WhereHelper(){
                                FiledName=nameof(RB_Supplies_StockInDetail.Id),
                                FiledValue=item.Id,
                                OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_StockInDetailRepository.Update(files1, wheres1);
                }
            }
            return flag;
        }

        #endregion

        #region 耗材申请日期设置
        /// <summary>
        /// 耗材申请设置分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Applyfor_Extend> GetApplyForSetPageList(int pageIndex, int pageSize, RB_Supplies_Applyfor_Extend demodel, out long count)
        {
            var list = supplies_ApplyforRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            var slist = new List<RB_Supplies_ApplyforWeekday_Extend>();
            var aslist = new List<RB_Supplies_ApplyforSpecial_Extend>();
            if (list.Any())
            {
                slist = supplies_ApplyforWeekdayRepository.GetList(new RB_Supplies_ApplyforWeekday_Extend() { RB_Group_Id = demodel.RB_Group_Id, ApplyforIds = string.Join(",", list.Select(x => x.Id).Distinct()) });
                aslist = supplies_ApplyforSpecialRepository.GetList(new RB_Supplies_ApplyforSpecial_Extend() { ApplyforIds = string.Join(",", list.Select(x => x.Id).Distinct()) });
            }
            foreach (var item in list)
            {
                //查询所有周期
                item.WeekdayList = slist.Where(x => x.ApplyforId == item.Id).ToList();
                item.SpecialList = aslist.Where(x => x.ApplyforId == item.Id).ToList();
            }
            return list;
        }

        /// <summary>
        /// 设置耗材申请时间
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetApplyForInfo(RB_Supplies_Applyfor_Extend demodel)
        {
            var trans = supplies_ApplyforRepository.DbTransaction;
            try
            {
                if (demodel.Id > 0)
                {
                    Dictionary<string, object> files = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_Applyfor_Extend.BranchId),demodel.BranchId}
                    };
                    List<WhereHelper> wheres = new List<WhereHelper>() {
                     new WhereHelper(){
                      FiledName=nameof(RB_Supplies_Applyfor_Extend.Id),
                       FiledValue=demodel.Id,
                        OperatorEnum=OperatorEnum.Equal
                     }
                    };
                    bool flag = supplies_ApplyforRepository.Update(files, wheres, trans);
                    if (flag)
                    {
                        var slist = supplies_ApplyforWeekdayRepository.GetList(new RB_Supplies_ApplyforWeekday_Extend() { RB_Group_Id = demodel.RB_Group_Id, ApplyforId = demodel.Id });
                        var aslist = supplies_ApplyforSpecialRepository.GetList(new RB_Supplies_ApplyforSpecial_Extend() { ApplyforId = demodel.Id });
                        //删除所有工作日信息
                        foreach (var item in slist)
                        {
                            supplies_ApplyforWeekdayRepository.Delete(item, trans);
                        }
                        //再新增
                        foreach (var item in demodel.WeekdayList)
                        {
                            supplies_ApplyforWeekdayRepository.Insert(new RB_Supplies_ApplyforWeekday()
                            {
                                ApplyforId = demodel.Id,
                                Id = 0,
                                Weekday = item.Weekday,
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                EndTime = item.EndTime,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                RB_Group_Id = demodel.RB_Group_Id,
                                StartTime = item.StartTime,
                                Status = 0,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate
                            }, trans);
                        }
                        //特殊日期
                        foreach (var item in aslist)
                        {
                            supplies_ApplyforSpecialRepository.Delete(item, trans);
                        }
                        //写入特殊日期
                        if (demodel.SpecialList != null && demodel.SpecialList.Any())
                        {
                            foreach (var item in demodel.SpecialList)
                            {
                                supplies_ApplyforSpecialRepository.Insert(new RB_Supplies_ApplyforSpecial()
                                {
                                    ApplyforId = demodel.Id,
                                    Id = 0,
                                    CreateBy = demodel.CreateBy,
                                    CreateDate = demodel.CreateDate,
                                    Date = item.Date,
                                    EndTime = item.EndTime,
                                    StartTime = item.StartTime,
                                    Status = 0,
                                    UpdateBy = demodel.UpdateBy,
                                    UpdateDate = demodel.UpdateDate
                                }, trans);
                            }
                        }
                    }
                }
                else
                {
                    //新增
                    demodel.Status = 0;
                    demodel.Enabled = 1;//默认启用
                    int Id = supplies_ApplyforRepository.Insert(demodel, trans);
                    if (Id > 0)
                    {
                        //写入工作日
                        foreach (var item in demodel.WeekdayList)
                        {
                            supplies_ApplyforWeekdayRepository.Insert(new RB_Supplies_ApplyforWeekday()
                            {
                                ApplyforId = Id,
                                Id = 0,
                                Weekday = item.Weekday,
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                EndTime = item.EndTime,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                RB_Group_Id = demodel.RB_Group_Id,
                                StartTime = item.StartTime,
                                Status = 0,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate
                            }, trans);
                        }
                        //写入特殊日期
                        if (demodel.SpecialList != null && demodel.SpecialList.Any())
                        {
                            foreach (var item in demodel.SpecialList)
                            {
                                supplies_ApplyforSpecialRepository.Insert(new RB_Supplies_ApplyforSpecial()
                                {
                                    ApplyforId = Id,
                                    Id = 0,
                                    CreateBy = demodel.CreateBy,
                                    CreateDate = demodel.CreateDate,
                                    Date = item.Date,
                                    EndTime = item.EndTime,
                                    StartTime = item.StartTime,
                                    Status = 0,
                                    UpdateBy = demodel.UpdateBy,
                                    UpdateDate = demodel.UpdateDate
                                }, trans);
                            }
                        }
                    }
                }
                supplies_ApplyforRepository.DBSession.Commit();
                return true;
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "SetApplyForInfo");
                supplies_ApplyforRepository.DBSession.Rollback();
                return false;
            }
        }

        /// <summary>
        /// 验证公司别
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool ValidateBranch(RB_Supplies_Applyfor_Extend demodel, UserInfo userInfo)
        {
            var list = supplies_ApplyforRepository.GetList(new RB_Supplies_Applyfor_Extend() { RB_Group_Id = userInfo.RB_Group_id, BranchId = demodel.BranchId });
            if (demodel.Id > 0)
            {
                if (list.Where(x => x.Id != demodel.Id).Any())
                {
                    return true;
                }
            }
            else
            {
                if (list.Any())
                {
                    return true;
                }
            }
            return false;
        }

        /// <summary>
        /// 设置状态
        /// </summary>
        /// <param name="applyforId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetApplyForStatus(int applyforId, UserInfo userInfo)
        {
            var model = supplies_ApplyforRepository.GetEntity(applyforId);
            if (model == null)
            {
                return false;
            }
            if (model.Status == 1)
            {
                return false;
            }
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Supplies_Applyfor_Extend.Enabled),model.Enabled==1?2:1},
                { nameof(RB_Supplies_Applyfor_Extend.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Supplies_Applyfor_Extend.UpdateDate),DateTime.Now}
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                FiledName=nameof(RB_Supplies_Applyfor_Extend.Id),
                FiledValue=applyforId,
                OperatorEnum=OperatorEnum.Equal
                }
            };
            return supplies_ApplyforRepository.Update(files, wheres);
        }

        /// <summary>
        /// 获取详情
        /// </summary>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public RB_Supplies_Applyfor_Extend GetApplyForInfo(UserInfo userInfo)
        {
            var list = supplies_ApplyforRepository.GetList(new RB_Supplies_Applyfor_Extend() { BranchId = userInfo.RB_Branch_id, RB_Group_Id = userInfo.RB_Group_id });
            if (list.Any())
            {
                var demodel = list.FirstOrDefault();
                var slist = supplies_ApplyforWeekdayRepository.GetList(new RB_Supplies_ApplyforWeekday_Extend() { RB_Group_Id = demodel.RB_Group_Id, ApplyforId = demodel.Id });
                var aslist = supplies_ApplyforSpecialRepository.GetList(new RB_Supplies_ApplyforSpecial_Extend() { ApplyforId = demodel.Id });
                demodel.WeekdayList = slist;
                demodel.SpecialList = aslist;
                return demodel;
            }
            else
            {
                //查询通用化的
                list = supplies_ApplyforRepository.GetList(new RB_Supplies_Applyfor_Extend() { BranchId = -1, RB_Group_Id = userInfo.RB_Group_id });
                if (list.Any())
                {
                    var demodel = list.FirstOrDefault();
                    var slist = supplies_ApplyforWeekdayRepository.GetList(new RB_Supplies_ApplyforWeekday_Extend() { RB_Group_Id = demodel.RB_Group_Id, ApplyforId = demodel.Id });
                    var aslist = supplies_ApplyforSpecialRepository.GetList(new RB_Supplies_ApplyforSpecial_Extend() { ApplyforId = demodel.Id });
                    demodel.WeekdayList = slist;
                    demodel.SpecialList = aslist;
                    return demodel;
                }
                else
                {
                    return new RB_Supplies_Applyfor_Extend() { Id = -1 };
                }
            }
        }

        #endregion

        #region 采购单


        /// <summary>
        /// 获取采购单分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Procurement_Extend> GetProcurementPageList(int pageIndex, int pageSize, RB_Procurement_Extend demodel, out long count)
        {
            var list = procurementRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            if (list.Any())
            {
                string procurementIds = string.Join(",", list.Select(x => x.Id));
                //查询明细
                var pdList = procurement_DetailRepository.GetList(new RB_Procurement_Detail_Extend() { RB_Group_Id = demodel.RB_Group_Id, ProcurementIds = procurementIds });
                //查询物料
                if (pdList.Any())
                {
                    string MaterialIds = string.Join(",", pdList.Select(x => x.MaterialId).Distinct());
                    var mList = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = demodel.RB_Group_Id, SuppliesIdStr = MaterialIds });
                    foreach (var item in pdList)
                    {
                        item.MaterialModel = mList.Where(x => x.Id == item.MaterialId).FirstOrDefault();
                        if (item.MaterialModel != null)
                        {
                            item.MaterialModel.GoodsSpecificationList = new List<string>();
                            item.MaterialModel.GoodsCategoryList = new List<string>();
                            if (!string.IsNullOrEmpty(item.MaterialModel.SpecificationName))
                            {
                                item.MaterialModel.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(item.MaterialModel.SpecificationName);
                            }
                            if (!string.IsNullOrEmpty(item.MaterialModel.GoodsCategoryName))
                            {
                                item.MaterialModel.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(item.MaterialModel.GoodsCategoryName);
                            }
                            if (item.MaterialModel.Images == "" || item.MaterialModel.Images == null)
                            {
                                item.MaterialModel.Images = "[]";
                            }
                            item.MaterialModel.ImageList = JsonConvert.DeserializeObject<List<string>>(item.MaterialModel.Images);
                        }
                        else
                        {
                            item.MaterialModel = new RB_Supplies_Material_Extend();
                        }
                    }
                }

                var wlist = supplies_WareHouseRepository.GetList(new RB_Supplies_WareHouse_Extend() { RB_Group_Id = demodel.RB_Group_Id, WareHouseIdStr = string.Join(",", list.Select(x => x.WareHouseId ?? 0).Distinct()) });
                foreach (var item in list)
                {
                    item.DetailList = pdList.Where(x => x.ProcurementId == item.Id).ToList();
                    item.WareHouseName = wlist.Where(x => x.Id == item.WareHouseId).FirstOrDefault()?.Name ?? "";
                }
            }
            return list;
        }

        /// <summary>
        /// 获取采购单详情
        /// </summary>
        /// <param name="procurementId"></param>
        /// <param name="TenantId"></param>
        /// <param name="MallBaseId"></param>
        /// <returns></returns>
        public RB_Procurement_Extend GetProcurementInfo(int procurementId, int ERPGroupId)
        {
            var pmodel = procurementRepository.GetEntity<RB_Procurement_Extend>(procurementId);
            //查询明细
            var pdList = procurement_DetailRepository.GetList(new RB_Procurement_Detail_Extend() { RB_Group_Id = ERPGroupId, ProcurementId = procurementId });
            //查询物料
            if (pdList.Any())
            {
                string MaterialIds = string.Join(",", pdList.Select(x => x.MaterialId).Distinct());
                var mList = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = ERPGroupId, SuppliesIdStr = MaterialIds });
                foreach (var item in pdList)
                {
                    item.MaterialModel = mList.Where(x => x.Id == item.MaterialId).FirstOrDefault();
                    if (item.MaterialModel != null)
                    {
                        item.MaterialModel.GoodsSpecificationList = new List<string>();
                        item.MaterialModel.GoodsCategoryList = new List<string>();
                        if (!string.IsNullOrEmpty(item.MaterialModel.SpecificationName))
                        {
                            item.MaterialModel.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(item.MaterialModel.SpecificationName);
                        }
                        if (!string.IsNullOrEmpty(item.MaterialModel.GoodsCategoryName))
                        {
                            item.MaterialModel.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(item.MaterialModel.GoodsCategoryName);
                        }
                        if (item.MaterialModel.Images == "" || item.MaterialModel.Images == null)
                        {
                            item.MaterialModel.Images = "[]";
                        }
                        item.MaterialModel.ImageList = JsonConvert.DeserializeObject<List<string>>(item.MaterialModel.Images);
                    }
                    else
                    {
                        item.MaterialModel = new RB_Supplies_Material_Extend();
                    }
                }
            }
            var wlist = supplies_WareHouseRepository.GetList(new RB_Supplies_WareHouse_Extend() { RB_Group_Id = ERPGroupId, WareHouseIdStr = (pmodel.WareHouseId ?? 0).ToString() });

            pmodel.DetailList = pdList;
            pmodel.WareHouseName = wlist.FirstOrDefault()?.Name ?? "";

            return pmodel;
        }

        /// <summary>
        /// 获取扫码采购商品信息
        /// </summary>
        /// <param name="code"></param>
        /// <param name="wareHouseId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetProcurementGoodsInfo(string code, int wareHouseId, UserInfo userInfo)
        {
            code = code.Replace("A", "-");
            string[] codeArr = code.Split('-');
            if (codeArr.Length != 5 && codeArr.Length != 6)
            {
                return new
                {
                    Status = 1,
                    Msg = "编码格式不正确"
                };
            }
            if (codeArr[0] != "D")
            {
                return new
                {
                    Status = 1,
                    Msg = "编码格式不正确"
                };
            }
            int WarehouseId = Convert.ToInt32(codeArr[1]);
            int ProcurementId = Convert.ToInt32(codeArr[2]);
            int SuppliesId = Convert.ToInt32(codeArr[3]);
            int StockInId = Convert.ToInt32(codeArr[4]);
            int ValidityId = 0;//单个商品id
            string ExpirationDate = "";//过期时间
            if (codeArr.Length == 6) {
                ValidityId = Convert.ToInt32(codeArr[5]);
                if (ValidityId > 0) {
                    var vmodel = supplies_StockInValidityRepository.GetEntity(ValidityId);
                    if (vmodel == null) {
                        return new
                        {
                            Status = 1,
                            Msg = "商品唯一码未查询到"
                        };
                    }
                    if (vmodel.IsOut == 1) {
                        return new
                        {
                            Status = 1,
                            Msg = "商品已出库，请核实后再试"
                        };
                    }
                    ExpirationDate = vmodel.ExpirationDate.ToString("yyyy-MM-dd");
                }
            }
            if (WarehouseId != wareHouseId)
            {
                return new
                {
                    Status = 1,
                    Msg = "商品仓库不正确"
                };
            }

            var materialModel = supplies_MaterialRepository.GetEntity(SuppliesId);
            if (materialModel == null)
            {
                return new
                {
                    Status = 1,
                    Msg = "物料档案不存在"
                };
            }
            List<string> SpecificationList = new List<string>();
            List<string> ImageList = new List<string>();
            if (!string.IsNullOrEmpty(materialModel.SpecificationName) && materialModel.SpecificationName != "[]")
            {
                SpecificationList = JsonConvert.DeserializeObject<List<string>>(materialModel.SpecificationName);
            }
            if (!string.IsNullOrEmpty(materialModel.Images) && materialModel.Images != "[]")
            {
                ImageList = JsonConvert.DeserializeObject<List<string>>(materialModel.Images);
            }

            #region 库存验证
            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = userInfo.RB_Group_id, WarehouseId = WarehouseId, SuppliesId = SuppliesId });
            if (ilist.Any())
            {
                var iModel = ilist.FirstOrDefault();
                if (iModel.Number <= 0)
                {
                    return new
                    {
                        Status = 1,
                        Msg = "该物料库存不足"
                    };
                }
            }
            #endregion

            var stockInList = supplies_StockInRepository.GetList(new RB_Supplies_StockIn_Extend() { RB_Group_Id = userInfo.RB_Group_id, Id = StockInId, ProcurementId = ProcurementId });
            if (!stockInList.Any())
            {
                return new
                {
                    Status = 1,
                    Msg = "该商品未入库"
                };
            }
            var stockInModel = stockInList.FirstOrDefault();
            var stockInDetailList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, SuppliesId = SuppliesId, StockInId = StockInId });
            if (!stockInDetailList.Any())
            {
                return new
                {
                    Status = 1,
                    Msg = "该商品未入库"
                };
            }
            var detModel = stockInDetailList.FirstOrDefault();


            return new
            {
                Status = 0,
                Msg = "查询成功",
                GoodsModel = new
                {
                    WarehouseId,
                    SuppliesId,
                    materialModel.GoodsId,
                    materialModel.Name,
                    materialModel.SuppliesNum,
                    materialModel.SpecificationKey,
                    SpecificationList,
                    ImageList,
                    materialModel.Units,
                    StockInId,
                    stockInModel.StockInNum,
                    StockInDate = stockInModel.StockInDate.HasValue ? stockInModel.StockInDate.Value.ToString("yyyy-MM-dd") : "",
                    detModel.UnitPrice,
                    ValidityId,
                    ExpirationDate
                }
            };
        }

        /// <summary>
        /// 获取已出库商品信息
        /// </summary>
        /// <param name="code"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetStockOutGoodsInfo(string code, UserInfo userInfo)
        {
            code = code.Replace("A", "-");
            string[] codeArr = code.Split('-');
            if (codeArr.Length != 5 && codeArr.Length != 6)
            {
                return new
                {
                    Status = 1,
                    Msg = "编码格式不正确"
                };
            }
            if (codeArr[0] != "D")
            {
                return new
                {
                    Status = 1,
                    Msg = "编码格式不正确"
                };
            }
            int WarehouseId = Convert.ToInt32(codeArr[1]);
            int ProcurementId = Convert.ToInt32(codeArr[2]);
            int SuppliesId = Convert.ToInt32(codeArr[3]);
            int StockInId = Convert.ToInt32(codeArr[4]);
            int ValidityId = 0;//单个商品id
            string ExpirationDate = "";//过期时间
            if (codeArr.Length == 6)
            {
                ValidityId = Convert.ToInt32(codeArr[5]);
                if (ValidityId > 0)
                {
                    var vmodel = supplies_StockInValidityRepository.GetEntity(ValidityId);
                    if (vmodel == null)
                    {
                        return new
                        {
                            Status = 1,
                            Msg = "商品唯一码未查询到"
                        };
                    }
                    if (vmodel.IsOut != 1)
                    {
                        return new
                        {
                            Status = 1,
                            Msg = "商品未出库，请核实后再试"
                        };
                    }
                    ExpirationDate = vmodel.ExpirationDate.ToString("yyyy-MM-dd");
                }
            }

            var materialModel = supplies_MaterialRepository.GetEntity(SuppliesId);
            if (materialModel == null)
            {
                return new
                {
                    Status = 1,
                    Msg = "物料档案不存在"
                };
            }
            List<string> SpecificationList = new List<string>();
            List<string> ImageList = new List<string>();
            if (!string.IsNullOrEmpty(materialModel.SpecificationName) && materialModel.SpecificationName != "[]")
            {
                SpecificationList = JsonConvert.DeserializeObject<List<string>>(materialModel.SpecificationName);
            }
            if (!string.IsNullOrEmpty(materialModel.Images) && materialModel.Images != "[]")
            {
                ImageList = JsonConvert.DeserializeObject<List<string>>(materialModel.Images);
            }

            return new
            {
                Status = 0,
                Msg = "查询成功",
                GoodsModel = new
                {
                    WarehouseId,
                    SuppliesId,
                    materialModel.GoodsId,
                    materialModel.Name,
                    materialModel.SuppliesNum,
                    materialModel.SpecificationKey,
                    SpecificationList,
                    ImageList,
                    materialModel.Units,
                    StockInId,
                    ValidityId,
                    ExpirationDate
                }
            };
        }

        /// <summary>
        /// 获取入库单的标签
        /// </summary>
        /// <param name="procurementId"></param>
        /// <param name="StockInId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetProcurementStockInLableList(int procurementId, int StockInId, UserInfo userInfo)
        {
            List<object> RObj = new List<object>();
            var pmodel = procurementRepository.GetEntity(procurementId);
            int eRPGroupId = userInfo.RB_Group_id;
            var siList = supplies_StockInRepository.GetList(new RB_Supplies_StockIn_Extend() { RB_Group_Id = eRPGroupId, ProcurementId = procurementId, Id = StockInId });
            if (siList.Any())
            {
                string siIds = string.Join(",", siList.Where(x => x.StockInState == StockInStatusEnum.StockIn).Select(x => x.Id));
                var sidList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = eRPGroupId, StockInIdStr = siIds });
                List<RB_Supplies_Material_Extend> materialList = new List<RB_Supplies_Material_Extend>();
                if (sidList.Any())
                {
                    string matIds = string.Join(",", sidList.Select(x => x.SuppliesId).Distinct());
                    materialList = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = eRPGroupId, SuppliesIdStr = matIds });
                }
                foreach (var item in sidList)
                {

                    var siModel = siList.Where(x => x.Id == item.StockInId).FirstOrDefault();
                    var materialModel = materialList.Where(x => x.Id == item.SuppliesId).FirstOrDefault();
                    if (materialModel == null) { continue; }

                    List<string> spList = new List<string>();
                    if (!string.IsNullOrEmpty(materialModel.SpecificationName) && materialModel.SpecificationName != "[]")
                    {
                        spList = JsonConvert.DeserializeObject<List<string>>(materialModel.SpecificationName);
                    }

                    string QRCode = "D-" + (siModel.WarehouseId ?? 0) + "-" + procurementId + "-" + (item.SuppliesId ?? 0) + "-" + (item.StockInId ?? 0);
                    string TQRCode = "DA" + (siModel.WarehouseId ?? 0) + "A" + procurementId + "A" + (item.SuppliesId ?? 0) + "A" + (item.StockInId ?? 0);
                    #region 生成二维码 + 条形码
                    string QRName = "QR-" + DateTime.Now.ToString("yyyyMMdd") + "-" + procurementId + "-" + (item.SuppliesId ?? 0) + ".jpg";
                    string TQRName = "TQR-" + DateTime.Now.ToString("yyyyMMdd") + "-" + procurementId + "-" + (item.SuppliesId ?? 0) + ".jpg";
                    string basepath = AppContext.BaseDirectory;
                    string QRPath = basepath + "\\upfile\\qrcode\\" + QRName;
                    string QRImage = "/upfile/qrcode/" + QRName;
                    string TQRPath = basepath + "\\upfile\\qrcode\\" + TQRName;
                    string TQRImage = "/upfile/qrcode/" + TQRName;
                    //验证文件是否存在，  存在的话就不用生成了
                    if (!File.Exists(QRPath))
                    {
                        QRCodeHelper.CreateQRCode(QRCode, 5, "", QRPath, System.Drawing.Imaging.ImageFormat.Jpeg);
                    }
                    if (!File.Exists(TQRPath))
                    {
                        int width = 340;
                        if (TQRCode.Length > 30)
                        {
                            width = 370;
                        }
                        QRCodeHelper.CreateTQRCode(TQRCode, TQRPath, System.Drawing.Imaging.ImageFormat.Jpeg, width, 50);
                    }
                    #endregion

                    var empModel = CacheManager.User.UserReidsCache.GetEmployee(item.CreateBy);
                    for (int i = 0; i < (item.Number ?? 0); i++)
                    {
                        RObj.Add(new
                        {
                            materialModel.GoodsId,
                            GoodsName = materialModel.Name,
                            SpecificationList = spList,
                            CreateDate = item.CreateDate.HasValue ? item.CreateDate.Value.ToString("yyyy-MM-dd") : "",
                            EmName = empModel?.EmName ?? "",
                            siModel.WareHouseName,
                            CostMoney = item.UnitPrice,
                            QRImage,
                            TQRImage,
                            TQRCode
                        });
                    }
                }

            }
            return RObj;
        }

        /// <summary>
        /// 获取采购入库批次列表
        /// </summary>
        /// <param name="procurementId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetProcurementSotckInBatchList(int procurementId, UserInfo userInfo)
        {
            List<object> RObj = new List<object>();
            var siList = supplies_StockInRepository.GetList(new RB_Supplies_StockIn_Extend() { RB_Group_Id = userInfo.RB_Group_id, ProcurementId = procurementId });
            siList = siList.Where(x => x.StockInState == StockInStatusEnum.StockIn).ToList();
            return siList.Select(x => new
            {
                StockInId = x.Id,
                x.StockInNum
            });
        }

        #endregion

        #region 盘点

        /// <summary>
        /// 获取盘点单分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Check_Extend> GetSuppliesCheckPageList(int pageIndex, int pageSize, RB_Supplies_Check_Extend demodel, out long count)
        {
            var list = supplies_CheckRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            if (list.Any())
            {
                //查询仓库
                var wlist = supplies_WareHouseRepository.GetList(new RB_Supplies_WareHouse_Extend() { RB_Group_Id = demodel.RB_Group_Id, WareHouseIdStr = string.Join(",", list.Select(x => x.WarehouseId ?? 0).Distinct()) });
                foreach (var item in list)
                {
                    var wmodel = wlist.Where(x => x.Id == item.WarehouseId).FirstOrDefault();
                    item.WarehouseName = wmodel?.Name ?? "";
                }
            }
            return list;
        }

        /// <summary>
        /// 根据条件获取盘点列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_Check_Extend> GetSuppliesCheckList(RB_Supplies_Check_Extend dmodel)
        {
            return supplies_CheckRepository.GetList(dmodel);
        }


        /// <summary>
        /// 新增修改盘点单
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetSuppliesCheck(RB_Supplies_Check_Extend demodel)
        {
            var trans = supplies_CheckRepository.DbTransaction;
            try
            {
                if (demodel.Id > 0)
                {
                    var model = supplies_CheckRepository.GetEntity(demodel.Id);

                    model.StartDate = demodel.StartDate;
                    model.EndDate = demodel.EndDate;
                    model.UpdateBy = demodel.UpdateBy;
                    model.UpdateDate = demodel.UpdateDate;
                    var flag = supplies_CheckRepository.Update(model, trans);
                    supplies_CheckRepository.DBSession.Commit();
                    return true;
                }
                else
                {
                    demodel.Periods = DateTime.Now.ToString("yyyyMMdd");
                    int Id = supplies_CheckRepository.Insert(demodel, trans);
                    if (Id > 0)
                    {
                        //根据仓库  查询出所有物料的库存
                        var list = supplies_MaterialRepository.GetSuppliesCheckMaterialList(demodel.WarehouseId, demodel.RB_Group_Id);
                        foreach (var item in list)
                        {
                            supplies_CheckDetailRepository.Insert(new RB_Supplies_CheckDetail()
                            {
                                CheckStatus = PropertyCheckStatusEnum.NoInventory,
                                CheckDate = null,
                                CheckEmpId = 0,
                                CheckId = Id,
                                Id = 0,
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                SuppliesId = item.Id,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Remark = "",
                                Status = 0,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate,
                                DealStatus = 2,
                                FinanceId = 0,
                                Images = "",
                                InventoryNum = item.InventoryNum,
                                RealityNum = 0
                            }, trans);
                        }
                    }
                    supplies_CheckRepository.DBSession.Commit();
                    return true;
                }
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "SetSuppliesCheck");
                supplies_CheckRepository.DBSession.Rollback();
                return false;
            }
        }

        /// <summary>
        /// 获取盘点单
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        public RB_Supplies_Check_Extend GetSuppliesCheck(int Id)
        {
            var model = supplies_CheckRepository.GetEntity<RB_Supplies_Check_Extend>(Id);
            if (model != null)
            {
                model.WarehouseName = supplies_WareHouseRepository.GetEntity(model.WarehouseId ?? 0)?.Name ?? "";
            }
            return model;
        }

        /// <summary>
        /// 取消盘点
        /// </summary>
        /// <param name="checkId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool CancelSuppliesCheck(int checkId, UserInfo userInfo)
        {
            Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                { nameof(RB_Supplies_Check_Extend.CheckState),SuppliesCheckStatusEnum.Cancel},
                { nameof(RB_Supplies_Check_Extend.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Supplies_Check_Extend.UpdateDate),DateTime.Now},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                     FiledName=nameof(RB_Supplies_Check_Extend.Id),
                      FiledValue=checkId,
                       OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_CheckRepository.Update(keyValues, wheres);
            return flag;
        }

        /// <summary>
        /// 盘点单复盘
        /// </summary>
        /// <param name="checkId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool RepeatSuppliesCheck(int checkId, string StartTime, string EndTime, UserInfo userInfo)
        {
            Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                { nameof(RB_Supplies_Check_Extend.CheckState),SuppliesCheckStatusEnum.InTheInventory},
                { nameof(RB_Supplies_Check_Extend.StartDate),Convert.ToDateTime(StartTime)},
                { nameof(RB_Supplies_Check_Extend.EndDate),Convert.ToDateTime(EndTime)},
                { nameof(RB_Supplies_Check_Extend.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Supplies_Check_Extend.UpdateDate),DateTime.Now},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                     FiledName=nameof(RB_Supplies_Check_Extend.Id),
                      FiledValue=checkId,
                       OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_CheckRepository.Update(keyValues, wheres);
            if (flag)
            {
                //是否需要重置盘点明细的盘点状态

            }
            return flag;
        }

        /// <summary>
        /// 获取盘点单明细分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_CheckDetail_Extend> GetSuppliesCheckDetailPageList(int pageIndex, int pageSize, RB_Supplies_CheckDetail_Extend demodel, out long count)
        {
            var list = supplies_CheckDetailRepository.GetPageList(pageIndex, pageSize, demodel, out count);

            if (list.Any())
            {
                //组装规格
                foreach (var item in list)
                {
                    item.SpecificationList = new List<string>();
                    if (!string.IsNullOrEmpty(item.SpecificationName) && item.SpecificationName != "[]")
                    {
                        item.SpecificationList = JsonConvert.DeserializeObject<List<string>>(item.SpecificationName);
                    }
                    item.ImageList = new List<string>();
                    if (!string.IsNullOrEmpty(item.Images) && item.Images != "[]")
                    {
                        item.ImageList = JsonConvert.DeserializeObject<List<string>>(item.Images);
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 获取盘点报损/报溢列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_CheckDetail_Extend> GetSuppliesCheckDetailBreakagePageList(int pageIndex, int pageSize, RB_Supplies_CheckDetail_Extend demodel, out long count)
        {
            var cmodel = supplies_CheckRepository.GetEntity(demodel.CheckId);
            if (cmodel == null)
            {
                count = 0;
                return new List<RB_Supplies_CheckDetail_Extend>();
            }
            var list = supplies_CheckDetailRepository.GetPageList(pageIndex, pageSize, demodel, out count);

            if (list.Any())
            {
                //组装规格
                foreach (var item in list)
                {
                    item.SpecificationList = new List<string>();
                    if (!string.IsNullOrEmpty(item.SpecificationName) && item.SpecificationName != "[]")
                    {
                        item.SpecificationList = JsonConvert.DeserializeObject<List<string>>(item.SpecificationName);
                    }
                    item.ImageList = new List<string>();
                    if (!string.IsNullOrEmpty(item.Images) && item.Images != "[]")
                    {
                        item.ImageList = JsonConvert.DeserializeObject<List<string>>(item.Images);
                    }
                    //查询最新入库价格
                    item.Unit_Money = supplies_CheckDetailRepository.GetSuppliesNewPrice(cmodel.WarehouseId ?? 0, item.SuppliesId ?? 0);
                }
            }
            return list;
        }

        /// <summary>
        /// 验证盘点单状态
        /// </summary>
        /// <param name="checkDetailId"></param>
        /// <returns></returns>
        public bool ValidataSuppliesCheckDetail(int checkDetailId)
        {
            var model = supplies_CheckDetailRepository.GetEntity(checkDetailId);
            var cmodel = supplies_CheckRepository.GetEntity(model?.CheckId ?? 0);
            if (cmodel != null && cmodel.CheckState == SuppliesCheckStatusEnum.InTheInventory)
            {
                return false;
            }
            return true;
        }

        /// <summary>
        /// 获取盘点明细
        /// </summary>
        /// <param name="checkDetailId"></param>
        /// <returns></returns>
        public RB_Supplies_CheckDetail_Extend GetSuppliesCheckDetailInfo(int checkDetailId)
        {
            return supplies_CheckDetailRepository.GetEntity<RB_Supplies_CheckDetail_Extend>(checkDetailId);
        }
        /// <summary>
        /// 根据条件获取盘点列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_CheckDetail_Extend> GetSuppliesCheckDetailList(RB_Supplies_CheckDetail_Extend dmodel)
        {
            return supplies_CheckDetailRepository.GetList(dmodel);
        }



        /// <summary>
        /// 设置盘点明细 耗材实盘数量
        /// </summary>
        /// <param name="checkDetailId"></param>
        /// <param name="type"></param>
        /// <param name="reality"></param>
        /// <param name="imagesList"></param>
        /// <param name="remark"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetSuppliesCheckDetailReality(int checkDetailId, int type, int reality, List<string> imagesList, string remark, UserInfo userInfo)
        {
            var dmodel = supplies_CheckDetailRepository.GetEntity(checkDetailId);
            if (dmodel == null) { return false; }
            if (type == 1)
            {
                if (dmodel.CheckStatus != PropertyCheckStatusEnum.NoInventory && dmodel.CheckStatus != PropertyCheckStatusEnum.HaveInventory && dmodel.DealStatus == 1)
                {
                    return false;
                }
                //更新实际数量
                PropertyCheckStatusEnum pcs = PropertyCheckStatusEnum.HaveInventory;
                if (reality == (dmodel.InventoryNum ?? 0))
                {
                    pcs = PropertyCheckStatusEnum.HaveInventory;
                }
                else if (reality > (dmodel.InventoryNum ?? 0))
                {
                    pcs = PropertyCheckStatusEnum.InventoryProfit;
                }
                else if (reality < (dmodel.InventoryNum ?? 0))
                {
                    pcs = PropertyCheckStatusEnum.InventoryLosses;
                }

                Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_CheckDetail.RealityNum),reality},
                    { nameof(RB_Supplies_CheckDetail.CheckStatus),pcs},
                    { nameof(RB_Supplies_CheckDetail.CheckEmpId),userInfo.EmployeeId},
                    { nameof(RB_Supplies_CheckDetail.CheckDate),DateTime.Now},
                };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_CheckDetail.Id),
                          FiledValue=dmodel.Id,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                return supplies_CheckDetailRepository.Update(keyValues, wheres);
            }
            else if (type == 2)
            {
                //上传图片
                Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_CheckDetail.Images),JsonConvert.SerializeObject(imagesList)},
                };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_CheckDetail.Id),
                          FiledValue=dmodel.Id,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                return supplies_CheckDetailRepository.Update(keyValues, wheres);
            }
            else if (type == 3)
            {
                //更新备注
                Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_CheckDetail.Remark),remark},
                };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_CheckDetail.Id),
                          FiledValue=dmodel.Id,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                return supplies_CheckDetailRepository.Update(keyValues, wheres);
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 批量设置盘点
        /// </summary>
        /// <param name="list"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetBatchSuppliesCheckDetailReality(List<RB_Supplies_CheckDetail_Extend> list, UserInfo userInfo, int Type = 1)
        {
            string checkdetailIds = string.Join(",", list.Select(x => x.Id));
            var dlist = supplies_CheckDetailRepository.GetList(new RB_Supplies_CheckDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, CheckDetailIds = checkdetailIds });
            if (dlist.Select(x => x.CheckId).Distinct().Count() != 1)
            {
                return false;
            }
            foreach (var item in dlist)
            {
                int reality = list.Where(x => x.Id == item.Id).FirstOrDefault()?.RealityNum ?? 0;
                if (item.CheckStatus != PropertyCheckStatusEnum.NoInventory && item.CheckStatus != PropertyCheckStatusEnum.HaveInventory && item.DealStatus == 1)
                {
                    continue;
                }
                //更新实际数量
                PropertyCheckStatusEnum pcs = PropertyCheckStatusEnum.HaveInventory;
                if (reality == (item.InventoryNum ?? 0))
                {
                    pcs = PropertyCheckStatusEnum.HaveInventory;
                }
                else if (reality > (item.InventoryNum ?? 0))
                {
                    pcs = PropertyCheckStatusEnum.InventoryProfit;
                }
                else if (reality < (item.InventoryNum ?? 0))
                {
                    pcs = PropertyCheckStatusEnum.InventoryLosses;
                }

                Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_CheckDetail.RealityNum),reality},
                    { nameof(RB_Supplies_CheckDetail.CheckStatus),pcs},
                    { nameof(RB_Supplies_CheckDetail.CheckEmpId),userInfo.EmployeeId},
                    { nameof(RB_Supplies_CheckDetail.CheckDate),DateTime.Now},
                };
                if (Type == 2)
                {
                    if (!string.IsNullOrEmpty(item.Remark))
                    {
                        keyValues.Add(nameof(RB_Supplies_CheckDetail.Remark), item.Remark);
                    }
                }
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_CheckDetail.Id),
                          FiledValue=item.Id,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                supplies_CheckDetailRepository.Update(keyValues, wheres);
            }
            return true;
        }

        /// <summary>
        /// 设置盘点单完成
        /// </summary>
        /// <param name="checkId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetSuppliesCheckComplete(int checkId, UserInfo userInfo)
        {
            Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                { nameof(RB_Supplies_Check_Extend.CheckState),SuppliesCheckStatusEnum.Completed},
                { nameof(RB_Supplies_Check_Extend.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Supplies_Check_Extend.UpdateDate),DateTime.Now},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                     FiledName=nameof(RB_Supplies_Check_Extend.Id),
                      FiledValue=checkId,
                       OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = supplies_CheckRepository.Update(keyValues, wheres);
            if (flag)
            {
                //未盘的  直接盘亏处理
                var list = supplies_CheckDetailRepository.GetList(new RB_Supplies_CheckDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, CheckId = checkId, CheckStatus = PropertyCheckStatusEnum.NoInventory });
                foreach (var item in list)
                {
                    Dictionary<string, object> flies1 = new Dictionary<string, object>();
                    if ((item.InventoryNum ?? 0) > (item.RealityNum ?? 0))
                    {
                        flies1.Add(nameof(RB_Supplies_CheckDetail_Extend.CheckStatus), PropertyCheckStatusEnum.InventoryLosses);
                    }
                    else if ((item.InventoryNum ?? 0) == (item.RealityNum ?? 0))
                    {
                        flies1.Add(nameof(RB_Supplies_CheckDetail_Extend.CheckStatus), PropertyCheckStatusEnum.HaveInventory);
                    }
                    else if ((item.InventoryNum ?? 0) < (item.RealityNum ?? 0))
                    {
                        flies1.Add(nameof(RB_Supplies_CheckDetail_Extend.CheckStatus), PropertyCheckStatusEnum.InventoryProfit);
                    }
                    List<WhereHelper> wheres1 = new List<WhereHelper>() {
                        new WhereHelper(){
                                FiledName=nameof(RB_Property_CheckDetail_Extend.Id),
                                FiledValue=item.Id,
                                OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_CheckDetailRepository.Update(flies1, wheres1);
                }

            }
            return flag;
        }

        #endregion

        #region 盘点报损
        /// <summary>
        /// 盘点报损分页
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowCount"></param>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Supplies_ReportLossRecord_Extend> GetSuppliesReportLossRecordPageList(int pageIndex, int pageSize, out long rowCount, RB_Supplies_ReportLossRecord_Extend query)
        {
            var list = suppliesReportLossRecordRepository.GetSuppliesReportLossRecordPageList(pageIndex, pageSize, out rowCount, query);

            return list;
        }


        /// <summary>
        /// 盘点报损列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Supplies_ReportLossRecord_Extend> GetReportLossRecordList(RB_Supplies_ReportLossRecord_Extend query)
        {
            return suppliesReportLossRecordRepository.GetReportLossRecordList(query);
        }

        /// <summary>
        /// 盘点报损列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Supplies_ReportLossRecordDetail_Extend> GetReportLossRecordDetail(RB_Supplies_ReportLossRecordDetail_Extend query)
        {
            return suppliesReportLossRecordDetailRepository.GetReportLossRecordDetail(query);
        }


        /// <summary>
        /// 保存商品盘点记录
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetReportLossRecord(RB_Supplies_ReportLossRecord_Extend applyModel, RB_Supplies_StockOut_Extend demodel, RB_Supplies_StockIn_Extend inDemodel, int RB_Department_Id)
        {
            var trans = suppliesReportLossRecordRepository.DbTransaction;
            try
            {
                int Id = suppliesReportLossRecordRepository.Insert(applyModel, trans);
                if (Id > 0)
                {

                    #region 生成财务单据   2021-04-14 ld 教育暂不生成
                    //var detailList = applyModel.DetailList.Select(x => new
                    //{
                    //    CostTypeId = applyModel.CheckStatus == PropertyCheckStatusEnum.InventoryLosses ? 225 : 226,
                    //    Number = x.ReportLossNum,
                    //    OriginalMoney = (x.ReportLossPrice ?? 0),
                    //    UnitPrice = Math.Round((x.ReportLossPrice ?? 0) / (x.ReportLossNum ?? 1), 2, MidpointRounding.AwayFromZero),
                    //    Remark = x.GoodsName + x.SpecificationName
                    //});
                    //string sign = "";
                    //if (applyModel.CheckStatus == PropertyCheckStatusEnum.InventoryLosses)
                    //{
                    //    var financeObj = new
                    //    {
                    //        demodel.CreateBy,
                    //        IsPublic = 0,//  supplierModel.ClientBankAccount.AccountType, //financeConfigurineModel.AccountType,
                    //        ClientType = 10,
                    //        ClientID = 3170,
                    //        CurrencyId = Config.OutCurrencyId,
                    //        WBMoney = applyModel.DetailList.Sum(x => (x.ReportLossPrice ?? 0)),
                    //        RB_Branch_Id = Config.ExpendBranchId,
                    //        PayDate = System.DateTime.Now.ToString("yyyy-MM-dd"),
                    //        TemplateId = 129,
                    //        OrderSource = 16,
                    //        OtherType = 17,
                    //        Remark = System.DateTime.Now.ToString("yyyy年MM月dd日") + "生成" + (applyModel.CheckStatus == PropertyCheckStatusEnum.InventoryLosses ? "盘亏" : "盘盈") + "财务单据",
                    //        detailList,
                    //        RB_Depart_Id = RB_Department_Id,
                    //        ReFinanceId = Id
                    //    };
                    //    sign = EncryptionHelper.AesEncrypt(JsonHelper.Serialize(financeObj), Config.FinanceKey);
                    //}
                    //else if (applyModel.CheckStatus == PropertyCheckStatusEnum.InventoryProfit)
                    //{
                    //    var financeObj = new
                    //    {
                    //        applyModel.CreateBy,
                    //        IsPublic = 0,
                    //        BType = 4,
                    //        AccountId = 27,
                    //        WBMoney = applyModel.DetailList.Sum(x => (x.ReportLossPrice ?? 0)),
                    //        RB_Branch_Id = Config.ExpendBranchId,
                    //        RemitterName = "商品盘点-盘盈",
                    //        TradeDate = System.DateTime.Now.AddDays(-1).ToString("yyyy-MM-dd"),
                    //        AccountNumber = System.DateTime.Now.AddDays(-1).ToString("yyyyMMdd"),
                    //        TemplateId = 130,
                    //        OrderSource = 16,
                    //        OtherType = 17,
                    //        Remark = System.DateTime.Now.ToString("yyyy年MM月dd日") + "自动生成财务单据",
                    //        detailList,
                    //        RB_Depart_Id = RB_Department_Id,
                    //        ReFinanceId = Id
                    //    };
                    //    sign = EncryptionHelper.AesEncrypt(JsonHelper.Serialize(financeObj), Config.FinanceKey);
                    //}




                    //var resultInfo = new
                    //{
                    //    msg = sign,
                    //};
                    //string apiResult = HttpHelper.HttpPost(applyModel.CheckStatus == PropertyCheckStatusEnum.InventoryLosses ? Config.PaymentFinanceApi : Config.IncomeFinanceApi, JsonHelper.Serialize(resultInfo), "");
                    //JObject parmsJob = JObject.Parse(apiResult);
                    //string resultCode = parmsJob.GetStringValue("resultCode");
                    //int frid = parmsJob.GetInt("data", 0);
                    #endregion
                    string resultCode = "1";
                    int frid = 0;
                    if (resultCode == "1" && frid >= 0)//新增记录
                    {
                        applyModel.FinanceId = frid;
                        applyModel.DetailList.ForEach(x => x.ReportLossRecordId = Id);
                        applyModel.DetailList.ForEach(x => x.CheckId = applyModel.CheckId);
                        applyModel.DetailList.ForEach(x => x.CheckStatus = applyModel.CheckStatus);
                        applyModel.DetailList.ForEach(x => x.Status = 0);
                        applyModel.DetailList.ForEach(x => x.CreateBy = applyModel.CreateBy);
                        applyModel.DetailList.ForEach(x => x.CreateDate = applyModel.CreateDate);
                        applyModel.DetailList.ForEach(x => x.RB_Branch_Id = applyModel.RB_Branch_Id);
                        applyModel.DetailList.ForEach(x => x.RB_Group_Id = applyModel.RB_Group_Id);

                        //更新已出库的商品信息
                        foreach (var item in applyModel.DetailList)//更新盘点商品的盘点状态
                        {
                            Dictionary<string, object> filesApplyGoods = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_CheckDetail.DealStatus),1},
                            { nameof(RB_Supplies_CheckDetail.UpdateBy),applyModel.CreateBy},
                             { nameof(RB_Supplies_CheckDetail.UpdateDate),applyModel.CreateDate},
                               { nameof(RB_Supplies_CheckDetail.FinanceId),frid},
                                { nameof(RB_Supplies_CheckDetail.Remark),item.Remark},
                        };
                            List<WhereHelper> wheresApplyGoods = new List<WhereHelper>() {
                            new WhereHelper(){
                                    FiledName=nameof(RB_Supplies_CheckDetail.Id),
                                    FiledValue=item.CheckDetailId,
                                    OperatorEnum=OperatorEnum.Equal
                            }
                        };
                            supplies_CheckDetailRepository.Update(filesApplyGoods, wheresApplyGoods, trans);
                        }
                        applyModel.DetailList.ForEach(x => x.Remark = applyModel.Remark);
                        //新增盘点商品的信息
                        suppliesReportLossRecordDetailRepository.InsertBatch(applyModel.DetailList, trans);
                    }

                    int outOrInId = 0;

                    if (applyModel.CheckStatus == PropertyCheckStatusEnum.InventoryLosses)
                    {
                        outOrInId = supplies_StockOutRepository.Insert(demodel);
                        //编码自动生成
                        string BMStr = outOrInId.ToString();
                        if (BMStr.Length < 5)
                        {
                            switch (BMStr.Length)
                            {
                                case 1:
                                    BMStr = "0000" + BMStr; break;
                                case 2:
                                    BMStr = "000" + BMStr; break;
                                case 3:
                                    BMStr = "00" + BMStr; break;
                                case 4:
                                    BMStr = "0" + BMStr; break;
                            }
                        }
                        BMStr = "CK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                        Dictionary<string, object> files = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_StockOut.StockOutNum),BMStr}
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                    FiledName=nameof(RB_Supplies_StockOut.Id),
                                    FiledValue=outOrInId,
                                    OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        supplies_StockOutRepository.Update(files, wheres, trans);

                        //新增明细
                        foreach (var item in demodel.DetailList)
                        {
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = item.SuppliesId });
                            decimal Price = 0;
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                Price = Math.Round((iModel.Money ?? 0) / (iModel.Number ?? 1), 2, MidpointRounding.AwayFromZero) * (item.Number ?? 0);
                            }
                            supplies_StockOutDetailRepository.Insert(new RB_Supplies_StockOutDetail()
                            {
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                Number = item.Number,
                                Money = Price,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                Id = 0,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Remark = item.Remark,
                                Status = 0,
                                StockOutId = outOrInId,
                                SuppliesId = item.SuppliesId,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate
                            }, trans);

                            //新增库存表数据
                            if (ilist.Any() && demodel.StockOutState == StockOutStatusEnum.StockOut)
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number -= item.Number;//减少库存
                                iModel.Money -= Price;
                                if (iModel.Money < 0)
                                {
                                    iModel.Money = 0;
                                }
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = demodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.Number,
                                        Money = Price,
                                        RB_Branch_Id = demodel.RB_Branch_Id,
                                        RB_Group_Id = demodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 2,
                                        Id = 0,
                                        Description = "商品盘亏-出库"
                                    }, trans);
                                }
                            }
                        }
                    }

                    else if (applyModel.CheckStatus == PropertyCheckStatusEnum.InventoryProfit)
                    {
                        inDemodel.StockInState = StockInStatusEnum.StockIn;
                        outOrInId = supplies_StockInRepository.Insert(inDemodel, trans);
                        //编码自动生成
                        string BMStr = outOrInId.ToString();
                        if (BMStr.Length < 5)
                        {
                            switch (BMStr.Length)
                            {
                                case 1:
                                    BMStr = "0000" + BMStr; break;
                                case 2:
                                    BMStr = "000" + BMStr; break;
                                case 3:
                                    BMStr = "00" + BMStr; break;
                                case 4:
                                    BMStr = "0" + BMStr; break;
                            }
                        }
                        BMStr = "RK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                        Dictionary<string, object> files = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_StockIn.StockInNum),BMStr}
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Supplies_StockIn.Id),
                                  FiledValue=outOrInId,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        supplies_StockInRepository.Update(files, wheres, trans);

                        //新增明细
                        foreach (var item in inDemodel.DetailList)
                        {
                            supplies_StockInDetailRepository.Insert(new RB_Supplies_StockInDetail()
                            {
                                CreateBy = inDemodel.CreateBy,
                                CreateDate = inDemodel.CreateDate,
                                Money = item.Money,
                                Number = item.Number,
                                RB_Branch_Id = inDemodel.RB_Branch_Id,
                                Id = 0,
                                RB_Group_Id = inDemodel.RB_Group_Id,
                                Remark = item.Remark,
                                Status = 0,
                                StockInId = outOrInId,
                                SuppliesId = item.SuppliesId,
                                UnitPrice = item.UnitPrice,
                                UpdateBy = inDemodel.UpdateBy,
                                UpdateDate = inDemodel.UpdateDate
                            }, trans);

                            //新增库存表数据
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = inDemodel.RB_Group_Id, WarehouseId = inDemodel.WarehouseId, SuppliesId = item.SuppliesId });
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number += item.Number;//增加库存
                                iModel.Money += item.Money;
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = inDemodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.Number,
                                        Money = item.Money,
                                        RB_Branch_Id = inDemodel.RB_Branch_Id,
                                        RB_Group_Id = inDemodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "商品盘赢-入库"
                                    }, trans);
                                }
                            }
                            else
                            {
                                //新增库存表
                                int iId = supplies_InventoryRepository.Insert(new RB_Supplies_Inventory()
                                {
                                    CreateBy = inDemodel.CreateBy,
                                    CreateDate = DateTime.Now,
                                    Id = 0,
                                    Number = item.Number,
                                    Money = item.Money,
                                    RB_Branch_Id = inDemodel.RB_Branch_Id,
                                    RB_Group_Id = inDemodel.RB_Group_Id,
                                    Status = 0,
                                    SuppliesId = item.SuppliesId,
                                    UpdateBy = inDemodel.UpdateBy,
                                    UpdateDate = inDemodel.UpdateDate,
                                    WarehouseId = inDemodel.WarehouseId
                                }, trans);
                                if (iId > 0)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = inDemodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iId,
                                        Number = item.Number,
                                        Money = item.Money,
                                        RB_Branch_Id = inDemodel.RB_Branch_Id,
                                        RB_Group_Id = inDemodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "商品盘赢-入库"
                                    }, trans);
                                }
                            }
                        }
                    }


                    //更新申请单的出库状态
                    Dictionary<string, object> filesApply = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_ReportLossRecord.OutOrInId),outOrInId},
                             { nameof(RB_Supplies_ReportLossRecord.FinanceId),frid}
                        };
                    List<WhereHelper> wheresApply = new List<WhereHelper>() {
                            new WhereHelper(){
                                    FiledName=nameof(RB_Supplies_ReportLossRecord.Id),
                                    FiledValue=Id,
                                    OperatorEnum=OperatorEnum.Equal
                            }
                        };
                    suppliesReportLossRecordRepository.Update(filesApply, wheresApply, trans);


                }
                suppliesReportLossRecordRepository.DBSession.Commit();
                return Id > 0;

            }
            catch (Exception ex)
            {
                suppliesReportLossRecordRepository.DBSession.Rollback("SetReportLossRecord");
                LogHelper.Write(ex, "SetReportLossRecord");
                return false;
            }
        }
        #endregion

        #region 物料有效期

        /// <summary>
        /// 获取物料有效期分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockInDetail_Extend> GetSuppliesValidityPageList(int pageIndex, int pageSize, RB_Supplies_StockIn_Extend demodel, out long count)
        {
            return supplies_StockInDetailRepository.GetSuppliesValidityPageList(pageIndex, pageSize, out count, demodel);
        }

        #endregion

        #region  库存操作记录
        /// <summary>
        /// 获取库存分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Inventory_Extend> GetSuppliesInventoryPageList(int pageIndex, int pageSize, RB_Supplies_Inventory_Extend demodel, out long count)
        {
            var list = supplies_InventoryRepository.GetSuppliesInventoryPageList(pageIndex, pageSize, demodel, out count);
            if (list.Any())
            {
                string wstr = string.Join(",", list.Select(x => x.WarehouseId ?? 0).Distinct());
                string sstr = string.Join(",", list.Select(x => x.SuppliesId ?? 0).Distinct());
                //查询仓库
                var wlist = supplies_WareHouseRepository.GetList(new RB_Supplies_WareHouse_Extend() { RB_Group_Id = demodel.RB_Group_Id, WareHouseIdStr = wstr });
                //查询耗材
                var mlist = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = demodel.RB_Group_Id, SuppliesIdStr = sstr }, true);

                foreach (var item in list)
                {
                    item.WModel = wlist.Where(x => x.Id == item.WarehouseId).FirstOrDefault();
                    item.SModel = mlist.Where(x => x.Id == item.SuppliesId).FirstOrDefault();
                    if (item.WModel == null)
                    {
                        item.WModel = new RB_Supplies_WareHouse_Extend();
                    }
                    if (item.SModel == null)
                    {
                        item.SModel = new RB_Supplies_Material_Extend();
                    }
                    item.SModel.GoodsSpecificationList = new List<string>();
                    item.SModel.GoodsCategoryList = new List<string>();
                    if (!string.IsNullOrEmpty(item.SModel.SpecificationName))
                    {
                        item.SModel.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(item.SModel.SpecificationName);
                    }
                    if (!string.IsNullOrEmpty(item.SModel.GoodsCategoryName))
                    {
                        item.SModel.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(item.SModel.GoodsCategoryName);
                    }
                }
            }
            return list;
        }



        /// <summary>
        /// 获取库存分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Inventory_Extend> GetSuppliesInventoryEXCELList(RB_Supplies_Inventory_Extend demodel)
        {
            var list = supplies_InventoryRepository.GetSuppliesInventoryEXCELList(demodel);
            if (list.Any())
            {
                string wstr = string.Join(",", list.Select(x => x.WarehouseId ?? 0).Distinct());
                string sstr = string.Join(",", list.Select(x => x.SuppliesId ?? 0).Distinct());
                //查询仓库
                var wlist = supplies_WareHouseRepository.GetList(new RB_Supplies_WareHouse_Extend() { RB_Group_Id = demodel.RB_Group_Id, WareHouseIdStr = wstr });
                //查询耗材
                var mlist = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = demodel.RB_Group_Id, SuppliesIdStr = sstr }, true);

                foreach (var item in list)
                {
                    item.WModel = wlist.Where(x => x.Id == item.WarehouseId).FirstOrDefault();
                    item.SModel = mlist.Where(x => x.Id == item.SuppliesId).FirstOrDefault();
                    if (item.WModel == null)
                    {
                        item.WModel = new RB_Supplies_WareHouse_Extend();
                    }
                    if (item.SModel == null)
                    {
                        item.SModel = new RB_Supplies_Material_Extend();
                    }
                    item.SModel.GoodsSpecificationList = new List<string>();
                    item.SModel.GoodsCategoryList = new List<string>();
                    if (!string.IsNullOrEmpty(item.SModel.SpecificationName))
                    {
                        item.SModel.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(item.SModel.SpecificationName);
                    }
                    if (!string.IsNullOrEmpty(item.SModel.GoodsCategoryName))
                    {
                        item.SModel.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(item.SModel.GoodsCategoryName);
                    }
                }
            }
            return list;
        }
        #endregion

        #region 耗材入库流程

        /// <summary>
        /// 获取待我审批分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockIn_Extend> GetStockInWaitMyAuditPageList(int pageIndex, int pageSize, RB_Supplies_StockIn_Extend demodel, out long count, int Type = 1, UserInfo userInfo = null)
        {
            var list = supplies_StockInRepository.GetStockInWaitMyAuditPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Supplies_StockInDetail_Extend> sdList = new List<RB_Supplies_StockInDetail_Extend>();
            if (list.Any())
            {
                //查询出所有的耗材详细
                string IdStr = string.Join(",", list.Select(x => x.Id).Distinct());
                sdList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockInIdStr = IdStr });

                foreach (var item in list)
                {
                    item.DetailList = sdList.Where(x => x.StockInId == item.Id).ToList();
                    foreach (var qitem in item.DetailList)
                    {
                        qitem.GoodsSpecificationList = new List<string>();
                        qitem.GoodsCategoryList = new List<string>();
                        if (!string.IsNullOrEmpty(qitem.SpecificationName))
                        {
                            qitem.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(qitem.SpecificationName);
                        }
                        if (!string.IsNullOrEmpty(qitem.GoodsCategoryName))
                        {
                            qitem.GoodsCategoryList = JsonConvert.DeserializeObject<List<string>>(qitem.GoodsCategoryName);
                        }
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 获取审核详情
        /// </summary>
        /// <param name="stockInId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public RB_Supplies_StockIn_Extend GetStockInAuditDetail(int stockInId, UserInfo userInfo)
        {
            var dmodel = supplies_StockInRepository.GetEntity(stockInId).RefMapperTo<RB_Supplies_StockIn_Extend>();
            if (dmodel != null)
            {
                dmodel.DetailList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { StockInId = stockInId, RB_Group_Id = userInfo.RB_Group_id });
                foreach (var qitem in dmodel.DetailList)
                {
                    qitem.GoodsSpecificationList = new List<string>();
                    qitem.GoodsCategoryList = new List<string>();
                    if (!string.IsNullOrEmpty(qitem.SpecificationName))
                    {
                        qitem.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(qitem.SpecificationName);
                    }
                }

                //获取流程模板
                var tempmodel = workflow_TemplateRepository.GetEntity(dmodel.TempleteId ?? 0);
                dmodel.TemplateName = tempmodel?.Name ?? "未启用流程";

                //获取流程相关信息
                List<Rb_Workflow_AuditRelevance_Extend> warlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(dmodel.Id, "", null, 1);
                List<Rb_Workflow_Auditrecord_Extend> walist = new List<Rb_Workflow_Auditrecord_Extend>();
                walist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { WorkFlowId = dmodel.Id, TemplateType = 1 });

                //流程
                dmodel.AuditSteps = new List<Rb_Workflow_AuditRelevance_Extend>();
                #region 制单人信息
                Rb_Workflow_AuditRelevance_Extend rb_Workflow_AuditRelevance_Extend = new Rb_Workflow_AuditRelevance_Extend()
                {
                    AuditDescription = "发起人",
                    Sort = 0,
                    Stauts = WFRrocessStatus.AuditThrough,
                    SpecialNode = WFSpecialNodeEnum.Normal
                };
                rb_Workflow_AuditRelevance_Extend.AuditRecordList = new List<Rb_Workflow_Auditrecord_Extend>();
                var emmodel = CacheManager.User.UserReidsCache.GetEmployee(dmodel.CreateBy);
                Rb_Workflow_Auditrecord_Extend CreateauditInfo = new Rb_Workflow_Auditrecord_Extend()
                {
                    AuditEmName = (emmodel?.EmName ?? "") + (emmodel?.IsLeave == 1 ? "(离职)" : ""),
                    UpdateTime = dmodel.CreateDate.Value,
                    Description = "已提交",
                    Id = 0,
                    AuditStatus = WFRrocessStatus.AuditThrough
                };
                rb_Workflow_AuditRelevance_Extend.AuditRecordList.Add(CreateauditInfo);
                rb_Workflow_AuditRelevance_Extend.NextStep = 0;
                rb_Workflow_AuditRelevance_Extend.AuditWay = WFTAuditWayEnum.Successively;
                dmodel.AuditSteps.Add(rb_Workflow_AuditRelevance_Extend);
                #endregion

                #region 流程步骤信息
                dmodel.Is_AuditSelf = 0;
                dmodel.Is_CanAudit = 0;
                var auditSteps = warlist?.OrderBy(x => x.Sort).ToList();
                var NotAuditedList = auditSteps.Where(x => x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort).ToList();
                var NotAudited = NotAuditedList?.FirstOrDefault();
                foreach (var audititem in auditSteps)
                {
                    #region 审核流程 
                    audititem.AuditRecordList = new List<Rb_Workflow_Auditrecord_Extend>();
                    var record = walist.Where(x => x.AuditId == audititem.Id).ToList();
                    if (NotAudited != null && audititem.Id == NotAudited.Id && audititem.Stauts == WFRrocessStatus.NotAudit)
                    {
                        audititem.NextStep = 1;

                        #region 制单人审核人不能一样
                        if (("," + audititem.ToAuditId + ",").Contains("," + dmodel.CreateBy.Value + ",") && dmodel.CreateBy == userInfo.EmployeeId)
                        {
                            dmodel.Is_AuditSelf = 1;
                        }
                        if (audititem.SpecialNode == WFSpecialNodeEnum.Pay)
                        {
                            dmodel.Is_AuditSelf = 0;
                        }
                        #endregion
                        //待我审批的
                        if (("," + audititem.ToAuditId + ",").Contains("," + userInfo.EmployeeId + ","))
                        {
                            if (dmodel.StockInState == StockInStatusEnum.StockInWarting)
                            {
                                dmodel.Is_CanAudit = 1;
                            }
                        }
                        if (("," + audititem.AuditedId + ",").Contains("," + userInfo.EmployeeId + ","))
                        {
                            if (dmodel.StockInState == StockInStatusEnum.StockInWarting)
                            {
                                dmodel.Is_CanAudit = 0;
                            }
                        }

                    }
                    foreach (var recorditem in record)
                    {
                        List<string> imgList = new List<string>();
                        if (recorditem.Image != "[]" && !string.IsNullOrWhiteSpace(recorditem.Image))
                        {
                            imgList = JsonConvert.DeserializeObject<List<string>>(recorditem.Image);
                        }
                        Rb_Workflow_Auditrecord_Extend auditInfo = new Rb_Workflow_Auditrecord_Extend()
                        {
                            AuditEmName = CacheManager.User.UserReidsCache.GetEmployee(recorditem.AuditEmId)?.EmName ?? "",
                            UpdateTime = recorditem.UpdateTime.Value,
                            Description = recorditem.Description != "" ? recorditem.Description : "",
                            Id = recorditem.Id,
                            CareOfRemarks = recorditem.CareOfRemarks ?? "",
                            AuditStatus = recorditem.AuditStatus,
                            imgList = imgList,
                            SignImage = recorditem.SignImage
                        };
                        audititem.AuditRecordList.Add(auditInfo);
                    }
                    #endregion
                    dmodel.AuditSteps.Add(audititem);
                }
                #endregion

                #region 仓库
                dmodel.WareHouseName = supplies_WareHouseRepository.GetEntity(dmodel.WarehouseId)?.Name ?? "";
                #endregion

                #region 采购
                dmodel.FinanceId = procurementRepository.GetEntity(dmodel.ProcurementId ?? 0)?.FinanceId ?? 0;
                #endregion
            }
            return dmodel;
        }

        /// <summary>
        /// 转交
        /// </summary>
        /// <returns></returns>
        public ApiResult Transfer(List<Rb_Workflow_Auditrecord_Extend> list, UserInfo userInfo)
        {
            bool flag = true;
            foreach (var item in list)
            {
                int WorkFlowId = item.WorkFlowId.Value; int OldEmId = userInfo.EmployeeId; int NewEmId = item.AuditEmId.Value;
                if ((item.TransferEmpId ?? 0) > 0)
                {
                    OldEmId = item.TransferEmpId ?? 0;
                }
                var auditModel = workflow_AuditRelevanceRepository.GetAuditRelevanceList(WorkFlowId, "", null, 1).Where(x => x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort).FirstOrDefault();
                if (auditModel == null)
                {
                    return ApiResult.Failed("财务单据：" + WorkFlowId + "审核流程已完毕");
                }
                int AuditId = auditModel.Id;
                if (AuditId > 0)
                {
                    //验证  是否有已审批通过的  再转交给审批通过者
                    var alist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = AuditId });
                    if (alist != null && alist.Any())
                    {
                        if (alist.Where(x => x.AuditStatus == WFRrocessStatus.AuditThrough && x.AuditEmId == NewEmId).Count() > 0)
                        {
                            return ApiResult.Failed("转交人已参与审批通过,无法转交");
                        }
                    }
                }
                var useModel = supplies_StockInRepository.GetEntity(WorkFlowId);
                if (useModel == null)
                {
                    return ApiResult.Failed("该申请单无效");
                }
                var trans = workflow_AuditrecordRepository.DbTransaction;
                try
                {
                    var OldEmodel = employeeRepository.GetEmployeeInfo(OldEmId);
                    var NewEmodel = employeeRepository.GetEmployeeInfo(NewEmId);
                    if (OldEmodel == null || NewEmodel == null)
                    {
                        return ApiResult.Failed("转交人或者当前审核人不存在，请联系管理员");
                    }
                    var amodel = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = AuditId, AuditEmId = OldEmId })?.FirstOrDefault();
                    if (amodel == null) { return ApiResult.Failed("审核步骤不存在，请联系技术人员"); }
                    var coModelList = new List<SetCareOfModel>();
                    if (!string.IsNullOrWhiteSpace(amodel.CareOfRemarks))
                    {
                        coModelList = JsonConvert.DeserializeObject<List<SetCareOfModel>>(amodel.CareOfRemarks);
                    }
                    SetCareOfModel comodel = new SetCareOfModel()
                    {
                        BeFrom = OldEmodel.EmployeeName,
                        Target = NewEmodel.EmployeeName,
                        Remarks = item.Description
                    };
                    coModelList.Add(comodel);
                    flag = UpdateAuditEmId(AuditId, OldEmId, NewEmId, coModelList, trans);
                    //日志
                    RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                    {
                        LogId = 0,
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        UpdateBy = userInfo.EmployeeId,
                        UpdateDate = DateTime.Now,
                        ResourceId = WorkFlowId,
                        Type = 1,
                        Content = "由" + OldEmodel.EmployeeName + "转交给" + NewEmodel.EmployeeName
                    };
                    workfolw_Change_LogRepository.Insert(logModel, trans);

                }
                catch (Exception ex)
                {
                    LogHelper.Write(ex, "Transfer");
                    workflow_AuditrecordRepository.DBSession.Rollback("Transfer：1，异常信息：" + ex.Message);
                    return ApiResult.Failed("转交失败");
                }
            }
            if (flag)
            {
                workflow_AuditrecordRepository.DBSession.Commit();
                return ApiResult.Success("转交成功");
            }
            else
            {
                workflow_AuditrecordRepository.DBSession.Rollback("Transfer：2");
                return ApiResult.Failed("转交失败");
            }
        }

        /// <summary>
        /// 更新审核人
        /// </summary>
        /// <param name="AuditId"></param>
        /// <param name="OldEmId"></param>
        /// <param name="NewEmId"></param>
        /// <param name="coModelList"></param>
        /// <param name="trans"></param>
        /// <returns></returns>
        public bool UpdateAuditEmId(int AuditId, int OldEmId, int NewEmId, List<SetCareOfModel> coModelList, System.Data.IDbTransaction trans = null)
        {
            bool flag = true, recordflag = true;
            //获取审核步骤
            var auditModel = workflow_AuditRelevanceRepository.GetEntity(AuditId);
            if (auditModel == null) { return false; }
            auditModel.ToAuditId = GetNewToAuditId(auditModel.ToAuditId, NewEmId, OldEmId, out int IsExist);
            if (string.IsNullOrEmpty(auditModel.ToAuditId)) { return false; }
            //更新审核步骤表
            IDictionary<string, object> fileds = new Dictionary<string, object>()
            {
                { nameof(Rb_Workflow_AuditRelevance.ToAuditId),auditModel.ToAuditId }
            };
            IList<WhereHelper> whereHelpers = new List<WhereHelper>()
            {
                new WhereHelper (){ FiledName=nameof(Rb_Workflow_AuditRelevance.Id),FiledValue=auditModel.Id,OperatorEnum=OperatorEnum.Equal}
            };
            try
            {
                flag = workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans);
                #region 审核记录
                if (flag)
                {
                    var record = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = auditModel.Id, AuditEmId = OldEmId, AuditStatus = WFRrocessStatus.NotAudit })?.FirstOrDefault();
                    if (record != null)
                    {
                        //新审核人不在审核记录中
                        if (IsExist == 0)
                        {
                            IDictionary<string, object> filed = new Dictionary<string, object>()
                            {
                                { nameof(Rb_Workflow_Auditrecord.AuditEmId),NewEmId},
                                { nameof(Rb_Workflow_Auditrecord.CareOfRemarks),JsonConvert.SerializeObject(coModelList)}
                            };
                            IList<WhereHelper> whereHelper = new List<WhereHelper>()
                            {
                                new WhereHelper (){ FiledName=nameof(Rb_Workflow_Auditrecord.Id),FiledValue=record.Id,OperatorEnum=OperatorEnum.Equal}
                            };
                            recordflag = workflow_AuditrecordRepository.Update(filed, whereHelper, trans);
                        }
                        //新审核人在审核记录中
                        else
                        {
                            recordflag = workflow_AuditrecordRepository.Delete(record.Id, trans) > 0;
                        }
                    }
                    else
                    {
                        return false;
                    }
                }
                #endregion
                if (flag && recordflag)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "UpdateAuditEmId");
                return false;
            }
        }

        /// <summary>
        /// 获取新的待审核人
        /// </summary>
        /// <param name="ToAuditId"></param>
        /// <param name="NewEmId"></param>
        /// <param name="OldEmId"></param>
        /// <returns></returns>
        public string GetNewToAuditId(string ToAuditId, int NewEmId, int OldEmId, out int IsExist)
        {
            string AuditId = "";
            IsExist = 0;
            List<string> list = new List<string>(ToAuditId.Split(new string[] { "," }, StringSplitOptions.RemoveEmptyEntries));
            foreach (var item in list)
            {
                if (!string.IsNullOrEmpty(item))
                {
                    if (Convert.ToInt32(item) != NewEmId)
                    {
                        if (Convert.ToInt32(item) == OldEmId)
                        {
                            AuditId += NewEmId + ",";
                        }
                        else
                        {

                            AuditId += item + ",";
                        }
                    }
                    //原审核人集合中存在新审核人，则直接去掉旧审核人
                    else
                    {
                        IsExist = 1;
                    }
                }
            }
            if (!string.IsNullOrEmpty(AuditId))
            {
                AuditId = ("," + AuditId);
                AuditId = AuditId[1..^1];
            }
            return AuditId;
        }

        /// <summary>
        /// 审批驳回
        /// </summary>
        /// <param name="model"></param>
        /// <param name="imageList"></param>
        /// <param name="auditDescription"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult AuditReject(RB_Supplies_StockIn_Extend model, List<string> imageList, string auditDescription, UserInfo userInfo)
        {
            return workFlowModule.AuditReject(model, imageList, auditDescription, userInfo);
        }

        /// <summary>
        /// 审批通过
        /// </summary>
        /// <param name="model"></param>
        /// <param name="imageList"></param>
        /// <param name="auditDescription"></param>
        /// <param name="SignImage"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult AuditPass(RB_Supplies_StockIn_Extend model, List<string> imageList, string auditDescription, UserInfo userInfo)
        {
            return workFlowModule.AuditPass(model, imageList, auditDescription, userInfo);
        }

        #endregion


        #region 耗材采购

        /// <summary>
        /// 获取耗材采购分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Procurement_Extend> GetSuppliesProcurementPageList(int pageIndex, int pageSize, RB_Supplies_Procurement_Extend demodel, out long count)
        {
            var list = supplies_ProcurementRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            if (list.Any())
            {
                string procurementIds = string.Join(",", list.Select(x => x.Id));
                var dlist = supplies_ProcurementDetailRepository.GetList(new RB_Supplies_ProcurementDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, ProcurementIds = procurementIds });
                if (dlist.Any())
                {
                    string categoryIds = string.Join(",", dlist.Select(x => x.CategoryId));
                    var cateList = property_CategoryRepository.GetList(new RB_Property_Category_Extend() { RB_Group_Id = demodel.RB_Group_Id, CategoryIdStr = categoryIds });
                    foreach (var item in dlist)
                    {
                        item.CategoryName = cateList.Where(x => x.Id == item.CategoryId).FirstOrDefault()?.Name ?? "";
                    }
                }
                string userIds = string.Join(",", list.Select(x => x.CreateBy).Distinct());
                var emplist = employeeRepository.GetEmployeeListRepository(new Employee_ViewModel() { Group_Id = demodel.RB_Group_Id, QIds = userIds });
                string schoolIds = string.Join(",", list.Select(x => x.SchoolId).Distinct());
                var slist = schoolRepository.GetSchoolListRepository(new RB_School_ViewModel() { Group_Id = demodel.RB_Group_Id, QSIds = schoolIds });
                string wareHouseIds = string.Join(",", list.Select(x => x.WareHouseId).Distinct());
                var wlist = supplies_WareHouseRepository.GetList(new RB_Supplies_WareHouse_Extend() { RB_Group_Id = demodel.RB_Group_Id, WareHouseIdStr = wareHouseIds });
                foreach (var item in list)
                {
                    item.DetailList = dlist.Where(x => x.ProcurementId == item.Id).ToList();
                    item.CreateByName = emplist.Where(x => x.Id == item.CreateBy).FirstOrDefault()?.EmployeeName ?? "";
                    item.SchoolName = slist.Where(x => x.SId == item.SchoolId).FirstOrDefault()?.SName ?? "";
                    item.WareHouseName = wlist.Where(x => x.Id == item.WareHouseId).FirstOrDefault()?.Name ?? "";
                }
            }
            return list;
        }

        /// <summary>
        /// 获取耗材采购详情
        /// </summary>
        /// <param name="procurementId"></param>
        /// <returns></returns>
        public RB_Supplies_Procurement_Extend GetSuppliesProcurementInfo(int procurementId)
        {
            var pmodel = supplies_ProcurementRepository.GetEntity<RB_Supplies_Procurement_Extend>(procurementId);
            if (pmodel!=null)
            {
                var dlist = supplies_ProcurementDetailRepository.GetList(new RB_Supplies_ProcurementDetail_Extend() { RB_Group_Id = pmodel.RB_Group_Id, ProcurementId = procurementId });
                if (dlist.Any())
                {
                    string categoryIds = string.Join(",", dlist.Select(x => x.CategoryId));
                    var cateList = property_CategoryRepository.GetList(new RB_Property_Category_Extend() { RB_Group_Id = pmodel.RB_Group_Id, CategoryIdStr = categoryIds });
                    foreach (var item in dlist)
                    {
                        item.CategoryName = cateList.Where(x => x.Id == item.CategoryId).FirstOrDefault()?.Name ?? "";
                    }
                }

                pmodel.DetailList = dlist;
                pmodel.CreateByName = employeeRepository.GetEmployeeInfo(pmodel.CreateBy)?.EmployeeName ?? "";
                pmodel.SchoolName = schoolRepository.GetEntity(pmodel.SchoolId)?.SName ?? "";
                pmodel.WareHouseName = supplies_WareHouseRepository.GetEntity(pmodel.WareHouseId)?.Name ?? "";

                var rmodel = auditRelevanceRepository.GetList(new RB_Property_AuditRelevance() { RB_Group_Id = pmodel.RB_Group_Id, Type = PropertyFlowEnum.PurchaseStokcIn }).FirstOrDefault();               
                if (rmodel != null && rmodel.Enabled == 1)
                {
                    pmodel.IsAuditEnabled = 1;
                }
            }
            return pmodel;
        }

        /// <summary>
        /// 新增耗材采购单
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult SetSuppliesProcurementInfo(RB_Supplies_Procurement_Extend demodel, UserInfo userInfo)
        {
            if (demodel.BuyingRequisitionId > 0)
            {
                var bmodel = property_BuyingRequisitionRepository.GetEntity(demodel.BuyingRequisitionId);
                if (bmodel == null) { return ApiResult.ParamIsNull("请购单不存在"); }
                if (bmodel.BuyStatus != BuyingRequisitionStatusEnum.Purchased) { return ApiResult.ParamIsNull("请购单未通过，无法生成采购"); }
                if (bmodel.ManagersId != userInfo.EmployeeId) { return ApiResult.ParamIsNull("不是指定经办人，无法生成采购"); }
                if (bmodel.ProcurementId > 0)
                {
                    return ApiResult.ParamIsNull("已经生成采购，无法再次生成");
                }
                if (bmodel.Type != 2)
                {
                    return ApiResult.ParamIsNull("该请购单不是耗材类型");
                }
            }
            var configModel = finance_ConfigRepository.GetList(new RB_Finance_Config_ViewModel() { Group_Id = userInfo.RB_Group_id, Type = FinanceConfigTypeEnum.SuppliesPurchase }).FirstOrDefault();
            if (configModel == null) { return ApiResult.Failed("未配置费用/流程信息，请联系管理员"); }
            var configModel2 = finance_ConfigRepository.GetList(new RB_Finance_Config_ViewModel() { Group_Id = userInfo.RB_Group_id, Type = FinanceConfigTypeEnum.SuppliesCost }).FirstOrDefault();
            if (configModel2 == null) { return ApiResult.Failed("未配置费用/流程信息，请联系管理员"); }
            //查询供应商
            var supplierModel = property_SupplierRepository.GetEntity(demodel.SupplierId);
            if (supplierModel == null || supplierModel.ClientID <= 0)
            {
                return ApiResult.Failed("供应商不存在/供应商未绑定账户信息");
            }
            var clientModel = clientBankAccountRepository.GetEntity(supplierModel.ClientID);
            if (clientModel == null)
            {
                return ApiResult.Failed("账户信息不存在");
            }

            //先生成采购信息
            demodel.SupplierName = supplierModel.Name;
            demodel.TotalNumber = demodel.DetailList.Sum(x => x.Number);
            demodel.TotalCostMoney = demodel.DetailList.Sum(x => x.CostMoney * x.Number);
            if (demodel.TotalCostMoney < demodel.FinanceMoney)
            {
                return ApiResult.Failed("财务制单总金额有误");
            }
            demodel.StockInStatus = 1;
            int ProcurementId = supplies_ProcurementRepository.Insert(demodel);
            if (ProcurementId > 0)
            {
                //插入采购明细
                foreach (var item in demodel.DetailList)
                {
                    supplies_ProcurementDetailRepository.Insert(new RB_Supplies_ProcurementDetail()
                    {
                        Id = 0,
                        MaterialId = item.MaterialId,
                        CostMoney = item.CostMoney,
                        CreateBy = demodel.CreateBy,
                        CreateDate = demodel.CreateDate,
                        Number = item.Number,
                        ProcurementId = ProcurementId,
                        RB_Branch_Id = demodel.RB_Branch_Id,
                        RB_Group_Id = demodel.RB_Group_Id,
                        Status = 0,
                        StockInNum = 0,
                        FinanceMoney = item.FinanceMoney
                    });
                }
                //再生成财务单据
                #region 生成财务单据
                #region 查询所有耗材信息
                string suppliesIds = string.Join(",", demodel.DetailList.Select(x => x.MaterialId).Distinct());
                var materialList = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = userInfo.RB_Group_id, SuppliesIdStr = suppliesIds });
                string categoryIds = string.Join(",", materialList.Select(x => x.CategoryId).Distinct());
                var cateList = property_CategoryRepository.GetList(new RB_Property_Category_Extend() { RB_Group_Id = demodel.RB_Group_Id, CategoryIdStr = categoryIds });
                #endregion

                var detailList = new List<object>();
                foreach (var item in demodel.DetailList)
                {
                    var mModel = materialList.Where(x => x.Id == item.MaterialId).FirstOrDefault();
                    int CostTypeId = configModel.CostTypeId;
                    if ((cateList.Where(x => x.Id == mModel.CategoryId).FirstOrDefault()?.FeeType ?? 1) == 2)
                    {
                        CostTypeId = configModel2.CostTypeId;
                    }
                    if (item.FinanceMoney < (item.CostMoney * item.Number))
                    {
                        //付首款
                        detailList.Add(new
                        {
                            CostTypeId,
                            Number =1,
                            OriginalMoney = item.FinanceMoney,
                            UnitPrice = item.FinanceMoney,
                            Remark = mModel.Name + "(" + mModel.SuppliesNum + ") " + mModel.BrandName + " " + mModel.CategoryName + " 首付单(采购数量" + item.Number + "、采购总额" + item.CostMoney * item.Number + ")"
                        });
                    }
                    else
                    {
                        detailList.Add(new
                        {
                            CostTypeId,
                            item.Number,
                            OriginalMoney = item.CostMoney * item.Number,
                            UnitPrice = item.CostMoney,
                            Remark = mModel.Name + "(" + mModel.SuppliesNum + ") " + mModel.BrandName + " " + mModel.CategoryName
                        });
                    }
                }

                var financeObj = new
                {
                    demodel.CreateBy,
                    demodel.IsPublic,
                    ClientType = 10,
                    ClientID = clientModel.ID,
                    configModel.CurrencyId,
                    WBMoney = demodel.FinanceMoney,
                    RB_Branch_Id = demodel.SchoolId,
                    PayDate = DateTime.Now.ToString("yyyy-MM-dd"),
                    TemplateId = configModel.TempleteId,
                    OrderSource = 17,
                    OtherType = 32,
                    Remark = DateTime.Now.ToString("yyyy年MM月dd日") + "生成财务单据",
                    detailList,
                    RB_Depart_Id = userInfo.RB_Department_Id,
                    ReFinanceId = ProcurementId,
                    FinanceType = 2,
                    RB_Group_Id = userInfo.RB_Group_id,
                    RB_CreateByName = userInfo.emName,
                    RB_DepartName = userInfo.DepartName,
                    RB_BranchName = schoolRepository.GetEntity(demodel.SchoolId)?.SName ?? "",
                    RB_GroupName = userInfo.GroupName
                };
                string sign = EncryptionHelper.AesEncrypt(JsonHelper.Serialize(financeObj), Config.FinanceKey);
                var resultInfo = new
                {
                    msg = sign,
                };
                string apiResult = HttpHelper.HttpPost(Config.PaymentFinanceApi, JsonHelper.Serialize(resultInfo), "");
                JObject parmsJob = JObject.Parse(apiResult);
                string resultCode = parmsJob.GetStringValue("resultCode");
                int frid = parmsJob.GetInt("data", 0);
                #endregion

                if (resultCode == "1" && frid > 0)
                {
                    string Remark = "";
                    //更新请购单 采购id + 单据id
                    if (demodel.BuyingRequisitionId > 0)
                    {
                        Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                            { nameof(RB_Property_BuyingRequisition.ProcurementId),ProcurementId},
                            { nameof(RB_Property_BuyingRequisition.FinanceId),frid},
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Property_BuyingRequisition.Id),
                                  FiledValue=demodel.BuyingRequisitionId,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        property_BuyingRequisitionRepository.Update(keyValues, wheres);
                        Remark = "通过请购单【" + demodel.BuyingRequisitionId + "】生成耗材采购单;";
                    }
                    //更新采购信息  单据id
                    Dictionary<string, object> keyValues1 = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_Procurement.FinanceId),frid},
                        { nameof(RB_Supplies_Procurement.Remark), Remark + " 自动生成财务单据" + frid},
                    };
                    List<WhereHelper> wheres1 = new List<WhereHelper>() {
                        new WhereHelper(){
                             FiledName=nameof(RB_Supplies_Procurement.Id),
                              FiledValue=ProcurementId,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_ProcurementRepository.Update(keyValues1, wheres1);
                }
                else
                {
                    string Remark = "";
                    //更新请购单 采购id + 单据id
                    if (demodel.BuyingRequisitionId > 0)
                    {
                        Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                            { nameof(RB_Property_BuyingRequisition.ProcurementId),ProcurementId},
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Property_BuyingRequisition.Id),
                                  FiledValue=demodel.BuyingRequisitionId,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        property_BuyingRequisitionRepository.Update(keyValues, wheres);
                        Remark = "通过请购单【" + demodel.BuyingRequisitionId + "】生成耗材采购单;";
                    }
                    //更新采购信息  单据id
                    Dictionary<string, object> keyValues1 = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_Procurement.FinanceId),frid},
                        { nameof(RB_Supplies_Procurement.Remark), Remark + " 自动生成财务单据失败，请手动生成"},
                    };
                    List<WhereHelper> wheres1 = new List<WhereHelper>() {
                        new WhereHelper(){
                             FiledName=nameof(RB_Supplies_Procurement.Id),
                              FiledValue=ProcurementId,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_ProcurementRepository.Update(keyValues1, wheres1);
                }
                return ApiResult.Success();
            }
            return ApiResult.Failed();
        }

        /// <summary>
        /// 补交财务单据
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public string SetSuppliesProcurementFinanceNext(RB_Supplies_Procurement_Extend demodel, UserInfo userInfo)
        {
            var pmodel = supplies_ProcurementRepository.GetEntity(demodel.Id);
            if (pmodel == null) { return "采购单不存在"; }

            var configModel = finance_ConfigRepository.GetList(new RB_Finance_Config_ViewModel() { Group_Id = userInfo.RB_Group_id, Type = FinanceConfigTypeEnum.SuppliesPurchase }).FirstOrDefault();
            if (configModel == null) { return "未配置费用/流程信息，请联系管理员"; }
            var configModel2 = finance_ConfigRepository.GetList(new RB_Finance_Config_ViewModel() { Group_Id = userInfo.RB_Group_id, Type = FinanceConfigTypeEnum.SuppliesCost }).FirstOrDefault();
            if (configModel2 == null) { return "未配置费用/流程信息，请联系管理员"; }
            //查询供应商
            var supplierModel = property_SupplierRepository.GetEntity(pmodel.SupplierId);
            if (supplierModel == null || supplierModel.ClientID <= 0)
            {
                return "供应商不存在/供应商未绑定账户信息";
            }
            var clientModel = clientBankAccountRepository.GetEntity(supplierModel.ClientID);
            if (clientModel == null)
            {
                return "账户信息不存在";
            }

            var pdlist = supplies_ProcurementDetailRepository.GetList(new RB_Supplies_ProcurementDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, ProcurementId = demodel.Id });
            //验证可制单金额
            foreach (var item in demodel.DetailList)
            {
                var pdModel = pdlist.Where(x => x.Id == item.Id).FirstOrDefault();
                if (pdModel == null) { return "采购明细Id有误"; }
                if (pdModel.Number * pdModel.CostMoney < pdModel.FinanceMoney + item.FinanceMoney) { return "制单金额大于商品实际金额，请核实后再试"; }
                item.Number = pdModel.Number;
                item.CostMoney = pdModel.CostMoney;
                item.MaterialId = pdModel.MaterialId;
            }
            decimal NowFinanceMoney = demodel.DetailList.Sum(x => x.FinanceMoney);

            #region 生成财务单据
            #region 查询所有耗材信息
            string suppliesIds = string.Join(",", demodel.DetailList.Select(x => x.MaterialId).Distinct());
            var materialList = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = userInfo.RB_Group_id, SuppliesIdStr = suppliesIds });
            string categoryIds = string.Join(",", materialList.Select(x => x.CategoryId).Distinct());
            var cateList = property_CategoryRepository.GetList(new RB_Property_Category_Extend() { RB_Group_Id = pmodel.RB_Group_Id, CategoryIdStr = categoryIds });
            #endregion

            var detailList = new List<object>();
            foreach (var item in demodel.DetailList)
            {
                var mModel = materialList.Where(x => x.Id == item.MaterialId).FirstOrDefault();
                int CostTypeId = configModel.CostTypeId;
                if ((cateList.Where(x => x.Id == mModel.CategoryId).FirstOrDefault()?.FeeType ?? 1) == 2)
                {
                    CostTypeId = configModel2.CostTypeId;
                }
                
                //付尾款
                detailList.Add(new
                {
                    CostTypeId,
                    Number = 1,
                    OriginalMoney = item.FinanceMoney,
                    UnitPrice = item.FinanceMoney,
                    Remark = mModel.Name + "(" + mModel.SuppliesNum + ") " + mModel.BrandName + " " + mModel.CategoryName + " 尾款单(采购数量" + item.Number + "、采购总额" + item.CostMoney * item.Number + ")"
                });
            }

            var financeObj = new
            {
                pmodel.CreateBy,
                demodel.IsPublic,
                ClientType = 10,
                ClientID = clientModel.ID,
                configModel.CurrencyId,
                WBMoney = NowFinanceMoney,
                RB_Branch_Id = pmodel.SchoolId,
                PayDate = DateTime.Now.ToString("yyyy-MM-dd"),
                TemplateId = configModel.TempleteId,
                OrderSource = 17,
                OtherType = 32,
                Remark = DateTime.Now.ToString("yyyy年MM月dd日") + "生成财务单据",
                detailList,
                RB_Depart_Id = userInfo.RB_Department_Id,
                ReFinanceId = pmodel.Id,
                FinanceType = 2,
                RB_Group_Id = userInfo.RB_Group_id,
                RB_CreateByName = userInfo.emName,
                RB_DepartName = userInfo.DepartName,
                RB_BranchName = schoolRepository.GetEntity(pmodel.SchoolId)?.SName ?? "",
                RB_GroupName = userInfo.GroupName
            };
            string sign = EncryptionHelper.AesEncrypt(JsonHelper.Serialize(financeObj), Config.FinanceKey);
            var resultInfo = new
            {
                msg = sign,
            };
            string apiResult = HttpHelper.HttpPost(Config.PaymentFinanceApi, JsonHelper.Serialize(resultInfo), "");
            JObject parmsJob = JObject.Parse(apiResult);
            string resultCode = parmsJob.GetStringValue("resultCode");
            int frid = parmsJob.GetInt("data", 0);
            #endregion

            if (resultCode == "1" && frid > 0)
            {
                //更新采购信息  单据id
                Dictionary<string, object> keyValues1 = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_Procurement.FinanceMoney),pmodel.FinanceMoney + NowFinanceMoney},
                    { nameof(RB_Supplies_Procurement.FinanceId),pmodel.FinanceId +","+ frid},
                    { nameof(RB_Supplies_Procurement.Remark), pmodel.Remark + "," + frid},
                };
                List<WhereHelper> wheres1 = new List<WhereHelper>() {
                        new WhereHelper(){
                             FiledName=nameof(RB_Supplies_Procurement.Id),
                              FiledValue=demodel.Id,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                supplies_ProcurementRepository.Update(keyValues1, wheres1);
                //更新采购明细已制单金额
                foreach (var item in demodel.DetailList)
                {
                    var pdModel = pdlist.Where(x => x.Id == item.Id).FirstOrDefault();
                    Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                        { nameof(RB_Supplies_ProcurementDetail_Extend.FinanceMoney),pdModel.FinanceMoney + item.FinanceMoney}
                    };
                    List<WhereHelper> wheres = new List<WhereHelper>() {
                        new WhereHelper(){
                             FiledName= nameof(RB_Supplies_ProcurementDetail_Extend.Id),
                              FiledValue= item.Id,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_ProcurementDetailRepository.Update(keyValues, wheres);
                }
                return "";
            }
            else
            {
                return "生成财务单据失败，请联系管理员";
            }
        }

        /// <summary>
        /// 耗材采购入库
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult SetSuppliesProcurementStockIn(RB_Supplies_Procurement_Extend demodel, UserInfo userInfo)
        {
            var opModel = supplies_ProcurementRepository.GetEntity(demodel.ProcurementId);
            if (opModel == null) { return ApiResult.Failed("采购单不存在"); }
            if (opModel.StockInStatus == 3) { return ApiResult.Failed("采购单已入库完毕！"); }

            #region 验证  是否开启审核流程
            //判断是否需要流程审批
            var tmodel = GetTempleteModel(PropertyFlowEnum.PurchaseStokcIn, opModel.SchoolId, demodel.RB_Group_Id);
            var rmodel = auditRelevanceRepository.GetList(new RB_Property_AuditRelevance() { RB_Group_Id = demodel.RB_Group_Id, Type = PropertyFlowEnum.PurchaseStokcIn }).FirstOrDefault();
            int TempleteId = 0;//模板id
            if (rmodel != null && rmodel.Enabled == 1)
            {
                if (tmodel == null)
                {
                    return ApiResult.ParamIsNull("未匹配到相关的流程信息,请联系管理员！");
                }
                TempleteId = tmodel?.Id ?? 0;

                if (demodel.VoucherList == null || !demodel.VoucherList.Any()) {
                    return ApiResult.ParamIsNull("请上传凭证");
                }
            }
            #endregion
            var dlist = supplies_ProcurementDetailRepository.GetList(new RB_Supplies_ProcurementDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, ProcurementId = demodel.ProcurementId });
            decimal TotalMoney = 0;
            foreach (var item in demodel.DetailList)
            {
                var dmodel = dlist.Where(x => x.Id == item.Id).FirstOrDefault();
                if (dmodel == null) { return ApiResult.Failed("采购单明细id有误"); }
                if (dmodel.Number < dmodel.StockInNum + dmodel.AuditStokcInNum + item.WaitStockInNum)
                {
                    return ApiResult.Failed("入库数据不正确，请核实后再试");
                }
                item.MaterialId = dmodel.MaterialId;
                item.CostMoney = dmodel.CostMoney;
                if (TempleteId > 0)
                {
                    //需要审核
                    dmodel.AuditStokcInNum += item.WaitStockInNum;
                }
                else
                {
                    dmodel.StockInNum += item.WaitStockInNum;
                }
                TotalMoney += dmodel.CostMoney * item.WaitStockInNum;
            }

            var trans = supplies_StockInRepository.DbTransaction;
            try
            {
                //初始化入库单信息
                var StockInModel = new RB_Supplies_StockIn()
                {
                    Id = 0,
                    CreateBy = userInfo.EmployeeId,
                    CreateDate = DateTime.Now,
                    Money = TotalMoney,
                    ProcurementId = demodel.ProcurementId,
                    RB_Branch_Id = userInfo.RB_Branch_id,
                    RB_Group_Id = userInfo.RB_Group_id,
                    Remark = "采购单(" + demodel.ProcurementId + ")入库，自动生成入库单",
                    Status = 0,
                    StockInDate = Convert.ToDateTime(demodel.StockInDate),
                    StockInNum = "",
                    StockInState = StockInStatusEnum.StockIn,
                    SupplierName = opModel.SupplierName,
                    WarehouseId = opModel.WareHouseId,
                    UpdateBy = userInfo.EmployeeId,
                    UpdateDate = DateTime.Now,
                    TempleteId = TempleteId,
                    Voucher = JsonHelper.Serialize(demodel.VoucherList),
                    AuditRemark = demodel.StockInRemark
                };
                if (TempleteId > 0) {
                    //需要审核
                    StockInModel.StockInState = StockInStatusEnum.StockInWarting;
                }
                int Id = supplies_StockInRepository.Insert(StockInModel, trans);
                if (Id > 0)
                {
                    //编码自动生成
                    string BMStr = Id.ToString();
                    if (BMStr.Length < 5)
                    {
                        switch (BMStr.Length)
                        {
                            case 1:
                                BMStr = "0000" + BMStr; break;
                            case 2:
                                BMStr = "000" + BMStr; break;
                            case 3:
                                BMStr = "00" + BMStr; break;
                            case 4:
                                BMStr = "0" + BMStr; break;
                        }
                    }
                    BMStr = "RK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                    Dictionary<string, object> files = new Dictionary<string, object>() {
                                { nameof(RB_Supplies_StockIn.StockInNum),BMStr}
                            };
                    List<WhereHelper> wheres = new List<WhereHelper>() {
                                new WhereHelper(){
                                     FiledName=nameof(RB_Supplies_StockIn.Id),
                                      FiledValue=Id,
                                       OperatorEnum=OperatorEnum.Equal
                                }
                            };
                    supplies_StockInRepository.Update(files, wheres, trans);

                    //新增明细
                    foreach (var item in demodel.DetailList)
                    {
                        supplies_StockInDetailRepository.Insert(new RB_Supplies_StockInDetail()
                        {
                            CreateBy = userInfo.EmployeeId,
                            CreateDate = DateTime.Now,
                            Money = item.CostMoney * item.WaitStockInNum,
                            Number = item.WaitStockInNum,
                            RB_Branch_Id = userInfo.RB_Branch_id,
                            Id = 0,
                            RB_Group_Id = userInfo.RB_Group_id,
                            Remark = "采购单入库",
                            Status = 0,
                            StockInId = Id,
                            SuppliesId = item.MaterialId,
                            UnitPrice = item.CostMoney,
                            UpdateBy = userInfo.EmployeeId,
                            UpdateDate = DateTime.Now
                        }, trans);

                        if (TempleteId == 0)
                        {
                            //新增库存表数据   无需审核
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = userInfo.RB_Group_id, WarehouseId = opModel.WareHouseId, SuppliesId = item.MaterialId });
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number += item.WaitStockInNum;//增加库存
                                iModel.Money += item.CostMoney * item.WaitStockInNum;
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = userInfo.EmployeeId,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.WaitStockInNum,
                                        Money = item.CostMoney * item.WaitStockInNum,
                                        RB_Branch_Id = userInfo.RB_Branch_id,
                                        RB_Group_Id = userInfo.RB_Group_id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "采购入库、新增库存"
                                    }, trans);
                                }
                            }
                            else
                            {
                                //新增库存表
                                int iId = supplies_InventoryRepository.Insert(new RB_Supplies_Inventory()
                                {
                                    CreateBy = userInfo.EmployeeId,
                                    CreateDate = DateTime.Now,
                                    Id = 0,
                                    Number = item.WaitStockInNum,
                                    Money = item.CostMoney * item.WaitStockInNum,
                                    RB_Branch_Id = userInfo.RB_Branch_id,
                                    RB_Group_Id = userInfo.RB_Group_id,
                                    Status = 0,
                                    SuppliesId = item.MaterialId,
                                    UpdateBy = userInfo.EmployeeId,
                                    UpdateDate = DateTime.Now,
                                    WarehouseId = opModel.WareHouseId
                                }, trans);
                                if (iId > 0)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = userInfo.EmployeeId,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iId,
                                        Number = item.WaitStockInNum,
                                        Money = item.CostMoney * item.WaitStockInNum,
                                        RB_Branch_Id = userInfo.RB_Branch_id,
                                        RB_Group_Id = userInfo.RB_Group_id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "采购入库、新增库存"
                                    }, trans);
                                }
                            }
                        }
                        #region 更新采购入库数量
                        Dictionary<string, object> keyValues1 = new Dictionary<string, object>() { };
                        if (TempleteId > 0)
                        {
                            //需审核
                            item.AuditStokcInNum += item.WaitStockInNum;
                            keyValues1.Add(nameof(RB_Property_ProcurementDetail_Extend.AuditStokcInNum), item.AuditStokcInNum);
                        }
                        else {
                            item.StockInNum += item.WaitStockInNum;
                            keyValues1.Add(nameof(RB_Property_ProcurementDetail_Extend.StockInNum), item.StockInNum);
                        }
                        List<WhereHelper> wheres1 = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Property_ProcurementDetail_Extend.Id),
                                  FiledValue=item.Id,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        supplies_ProcurementDetailRepository.Update(keyValues1, wheres1, trans);
                        #endregion
                    }

                    if (StockInModel.StockInState == StockInStatusEnum.StockInWarting && TempleteId > 0)
                    {
                        //开始创建流程
                        List<EmAccoutIdModel> sendAccount = new List<EmAccoutIdModel>();
                        List<int> ApplyForList = new List<int>() { userInfo.EmployeeId };
                        bool cflag = workFlowModule.InsertAuditRelevance(tmodel, 0, userInfo.EmployeeId, userInfo.EmployeeId, Id, ApplyForList, out sendAccount, 1, null, trans, 3);
                        if (cflag == false)
                        {
                            property_BuyingRequisitionRepository.DBSession.Rollback("SetBuyingRequisitionInfo");
                            return ApiResult.Failed("流程有误，请核实后再试");
                        }
                        //日志
                        RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                        {
                            LogId = 0,
                            RB_Branch_Id = userInfo.RB_Branch_id,
                            RB_Group_Id = userInfo.RB_Group_id,
                            UpdateBy = userInfo.EmployeeId,
                            UpdateDate = System.DateTime.Now,
                            ResourceId = Id,
                            Content = "创建流程",
                            Type = 4
                        };
                        workfolw_Change_LogRepository.Insert(logModel, trans);

                        //推送消息
                        if (sendAccount.Any())
                        {
                            PushAuditMessage(sendAccount, Id, "您有待审核的耗材采购入库信息", "入库审核通知", userInfo.EmployeeId, Common.Models.PushMessageCategoryEnum.SuppliesStokcInAudit);

                            //推送企业微信
                            string markdownContent = $"`您有待审核的耗材采购入库信息\n>**概要信息** \n>入库编号：{BMStr}\n>入库类型：耗材\n>入库时间：<font color='comment'>{DateTime.Now.ToString("MM-dd HH-mm")}</font>\n>入库备注：<font color='comment'>{demodel.Remark}</font>\n>入库人员：{userInfo.emName}\n>";
                            string JumpUrl = System.Web.HttpUtility.UrlEncode($"/rukuNewDetails?Id={Id}&backto=receiptApproval&showTable=1&compType=shenpi");
                            PushWeChatWorkAuditMsg(Common.Models.PushMessageCategoryEnum.PropertyStokcInAudit, markdownContent, "入库审核通知", sendAccount, JumpUrl);
                        }
                    }
                    #region 更新采购单入库状态
                    Dictionary<string, object> keyValues2 = new Dictionary<string, object>();
                    if (dlist.Where(x => x.Number > x.StockInNum).Any())
                    {
                        //修改采购单为部分入库
                        keyValues2.Add(nameof(RB_Supplies_Procurement_Extend.StockInStatus), 2);
                    }
                    else
                    {
                        //修改采购单为已入库
                        keyValues2.Add(nameof(RB_Supplies_Procurement_Extend.StockInStatus), 3);
                    }
                    List<WhereHelper> wheres2 = new List<WhereHelper>() {
                    new WhereHelper(){
                             FiledName=nameof(RB_Supplies_Procurement_Extend.Id),
                              FiledValue=demodel.ProcurementId,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    supplies_ProcurementRepository.Update(keyValues2, wheres2, trans);
                    #endregion
                }

                supplies_StockInRepository.DBSession.Commit();
                return ApiResult.Success();
            }
            catch (Exception ex)
            {
                supplies_StockInRepository.DBSession.Rollback("SetSuppliesProcurementStockIn");
                LogHelper.Write(ex, "SetSuppliesProcurementStockIn");
                return ApiResult.ParamIsNull("出错了,请联系管理员！");
            }
        }

        /// <summary>
        /// 推送资产审批消息
        /// </summary>
        /// <param name="account"></param>
        /// <param name="workFlowId"></param>
        /// <param name="content"></param>
        /// <param name="title"></param>
        /// <param name="empId"></param>
        /// <param name="type"></param>
        public void PushAuditMessage(List<EmAccoutIdModel> account, int workFlowId, string content, string title, int? empId, Common.Models.PushMessageCategoryEnum type)
        {
            List<Common.Message.PushMessageModel> SendList = new List<Common.Message.PushMessageModel>();
            string JumpUrl = "";
            switch (type)
            {
                case Common.Models.PushMessageCategoryEnum.Property:
                    JumpUrl = $"/AssetsShenpi?Id={workFlowId}&compType=shenpi"; break;
                case Common.Models.PushMessageCategoryEnum.BuyingRequisition:
                    JumpUrl = $"/RequisitionShenpi?Id={workFlowId}&compType=shenpi"; break;
                case Common.Models.PushMessageCategoryEnum.PurchaseRequisition:
                    JumpUrl = "/PurchaseRequisitionExamine?showTable=4"; break;
                case Common.Models.PushMessageCategoryEnum.SuppliesStokcInAudit:
                    JumpUrl = $"/SuppliesStockInShenpi?Id={workFlowId}&compType=shenpi"; break;
                case Common.Models.PushMessageCategoryEnum.PropertyStokcInAudit:
                    JumpUrl = $"/PropertyStockInShenpi?Id={workFlowId}&compType=shenpi"; break;
            }
            foreach (var item in account)
            {
                Common.Message.PushMessageModel model = new Common.Message.PushMessageModel()
                {
                    CategoryId = type,
                    Content = content,
                    CoverImg = "",
                    CreateByName = item.EmAccount,
                    JumpUrl = JumpUrl,
                    SendTime = DateTime.Now,
                    SendType = 0,
                    Title = title,
                    Platform = 2,
                    ReceiveId = item.EmployeeId.ToString(),
                };
                SendList.Add(model);
            }
            Common.Message.MessageHelper.SendMessage(SendList);
        }

        /// <summary>
        /// 推送企业微信
        /// </summary>
        /// <param name="type">消息所属分类</param>
        /// <param name="content">内容</param>
        /// <param name="account">账户</param>
        public void PushWeChatWorkAuditMsg(Common.Models.PushMessageCategoryEnum type, string content, string title, List<EmAccoutIdModel> account, string jumpUrl)
        {
            #region 审批完成企业微信通知
            List<Common.Message.PushMessageModel> SendList = new List<Common.Message.PushMessageModel>();
            account.ForEach(x =>
            {
                var to = employeeRepository.GetUserWorkId(x.EmployeeId);
                if (!string.IsNullOrEmpty(to))
                {
                    var userContent = $"{content}请  点  击：[查看详情]({Config.EduPropertyDomainURL}/autologinqy?loginId={x.EmployeeId}&target={jumpUrl})";
                    Common.Message.PushMessageModel modelPubWork = new Common.Message.PushMessageModel()
                    {
                        CategoryId = type,
                        Content = userContent,
                        CoverImg = string.Empty,
                        CreateByName = x.EmAccount,
                        JumpUrl = string.Empty,
                        WorkMsgType = "markdown",
                        SendTime = DateTime.Now,
                        SendType = 0,
                        Title = title,
                        Platform = 5,
                        ReceiveId = to
                    };
                    SendList.Add(modelPubWork);
                }
            });
            Common.Message.MessageHelper.SendMessage(SendList);
            #endregion
        }

        /// <summary>
        /// 获取流程模板
        /// </summary>
        /// <param name="audite"></param>
        /// <param name="BranchId"></param>
        /// <returns></returns>
        private Rb_Workflow_Template_Extend GetTempleteModel(PropertyFlowEnum audite, int BranchId, int GroupId)
        {
            var tempList = workflow_TemplateRepository.GetList(new Rb_Workflow_Template_Extend() { RB_GroupId = GroupId, TemplateSorce = 2, PropertyType = audite, Status = FinanceDataEnum.Normal });
            List<RB_FinanceFlowConnect_Extend> fcList = new List<RB_FinanceFlowConnect_Extend>();
            //再验证公司别
            if (tempList.Any())
            {
                fcList = financeFlowConnectRepository.GetExtendList(new RB_FinanceFlowConnect_Extend() { FlowtemplateIds = string.Join(",", tempList.Select(x => x.Id)) });
            }
            foreach (var item in tempList)
            {
                var fc2list = fcList.Where(x => x.FlowtemplateId == item.Id).ToList();
                if (fc2list.Where(x => x.Type == FinanceFlowConnectEnum.Company).Any())
                {
                    //集团通用
                    return item;
                }
                else if (fc2list.Where(x => x.Type == FinanceFlowConnectEnum.Branch && x.SuitableObjectId == BranchId).Any())
                {
                    //该公司在使用该流程
                    return item;
                }
            }
            return null;
        }
        #endregion

        #region 耗材入库审核（教育）
        /// <summary>
        /// 重新发起入库审核
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public string SetSuppliesStockInAuditInfo(RB_Supplies_StockIn_Extend demodel,UserInfo userInfo)
        {
            var oldModel = supplies_StockInRepository.GetEntity(demodel.Id);
            if (oldModel == null) { return "入库单不存在"; }
            if (oldModel.StockInState != StockInStatusEnum.StockInAuditReject) { return "入库单状态不正确"; }
            var dModel = supplies_ProcurementRepository.GetEntity(oldModel.ProcurementId);
            if (dModel == null) { return "采购单不存在"; }
            #region 验证流程
            //判断是否需要流程审批
            var tmodel = GetTempleteModel(PropertyFlowEnum.PurchaseStokcIn, dModel.SchoolId, demodel.RB_Group_Id ?? 0);
            var rmodel = auditRelevanceRepository.GetList(new RB_Property_AuditRelevance() { RB_Group_Id = demodel.RB_Group_Id, Type = PropertyFlowEnum.PurchaseStokcIn }).FirstOrDefault();
            int TempleteId = 0;
            if (rmodel != null && rmodel.Enabled == 1)
            {
                if (tmodel == null)
                {
                    return "未匹配到相关的流程信息,请联系管理员！";
                }
                TempleteId = tmodel?.Id ?? 0;
            }
            #endregion

            var trans = supplies_StockInRepository.DbTransaction;
            try
            {
                Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_StockIn_Extend.AuditRemark), demodel.AuditRemark},
                    { nameof(RB_Supplies_StockIn_Extend.Voucher), JsonHelper.Serialize(demodel.VoucherList)},
                    { nameof(RB_Supplies_StockIn_Extend.StockInState), StockInStatusEnum.StockInWarting},
                    { nameof(RB_Supplies_StockIn_Extend.UpdateBy), demodel.UpdateBy},
                    { nameof(RB_Supplies_StockIn_Extend.UpdateDate), demodel.UpdateDate},
                };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_StockIn_Extend.Id),
                          FiledValue=demodel.Id,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                bool flag = supplies_StockInRepository.Update(keyValues, wheres, trans);
                if (flag)
                {
                    var dList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, StockInId = demodel.Id });
                    var PDList = supplies_ProcurementDetailRepository.GetList(new RB_Supplies_ProcurementDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id ?? 0, ProcurementId = oldModel.ProcurementId ?? 0 });

                    foreach (var item in demodel.DetailList) {
                        var dmodel = dList.Where(x => x.Id == item.Id).FirstOrDefault();
                        if (dmodel == null) {
                            supplies_StockInRepository.DBSession.Rollback();
                            return "入库明细传递有误";
                        }
                        var pdModel = PDList.Where(x => x.MaterialId == item.SuppliesId).FirstOrDefault();
                        if (pdModel == null) {
                            supplies_StockInRepository.DBSession.Rollback();
                            return "入库明细与采购单不一致";
                        }
                        if (item.Number != dmodel.Number) {
                            int DiffNum = (item.Number ?? 0) - (dmodel.Number ?? 0);
                            //验证数量是否足够
                            if (DiffNum > 0 && DiffNum > pdModel.Number - pdModel.StockInNum - pdModel.AuditStokcInNum)
                            {
                                supplies_StockInRepository.DBSession.Rollback();
                                return item.SuppliesName + "数量不足，请核实后再试";
                            }

                            Dictionary<string, object> keyValues1 = new Dictionary<string, object>() {
                                { nameof(RB_Supplies_StockInDetail_Extend.Number), item.Number}
                            };
                            List<WhereHelper> wheres1 = new List<WhereHelper>() {
                                new WhereHelper(){
                                     FiledName=nameof(RB_Supplies_StockInDetail_Extend.Id),
                                      FiledValue=item.Id,
                                       OperatorEnum=OperatorEnum.Equal
                                }
                            };
                            supplies_StockInDetailRepository.Update(keyValues1, wheres1, trans);

                            Dictionary<string, object> keyValues2 = new Dictionary<string, object>() {
                                { nameof(RB_Supplies_ProcurementDetail_Extend.AuditStokcInNum),pdModel.AuditStokcInNum + DiffNum}
                            };
                            List<WhereHelper> wheres2 = new List<WhereHelper>() {
                                new WhereHelper(){
                                     FiledName=nameof(RB_Supplies_ProcurementDetail_Extend.Id),
                                      FiledValue=pdModel.Id,
                                       OperatorEnum=OperatorEnum.Equal
                                }
                            };
                            supplies_ProcurementDetailRepository.Update(keyValues2, wheres2, trans);
                        }
                    }
                    #region 初始化流程
                    int TeamplateType = 3;
                    //首先删除流程相关 与 流程审批人
                    workFlowModule.ModifyAuditDeleteAllInfo(demodel.Id, TeamplateType, trans);
                    //开始创建流程
                    List<EmAccoutIdModel> sendAccount = new List<EmAccoutIdModel>();
                    List<int> ApplyForList = new List<int>() { demodel.CreateBy ?? 0 };
                    bool cflag = workFlowModule.InsertAuditRelevance(tmodel, 0, userInfo.EmployeeId, userInfo.EmployeeId, demodel.Id, ApplyForList, out sendAccount, 1, null, trans, TeamplateType);
                    if (cflag == false)
                    {
                        supplies_StockInRepository.DBSession.Rollback();
                        return "流程有误，请核实后再试";
                    }
                    //日志
                    RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                    {
                        LogId = 0,
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        UpdateBy = userInfo.EmployeeId,
                        UpdateDate = System.DateTime.Now,
                        ResourceId = demodel.Id,
                        Content = "重新修改提交",
                        Type = TeamplateType + 1
                    };
                    workfolw_Change_LogRepository.Insert(logModel, trans);

                    //推送消息
                    if (sendAccount.Any())
                    {
                        PushAuditMessage(sendAccount, demodel.Id, "您有待审核的耗材入库信息", "耗材入库审核通知", userInfo.EmployeeId, Common.Models.PushMessageCategoryEnum.SuppliesStokcInAudit);

                        //推送企业微信
                        string markdownContent = $"`您有待审核的耗材采购入库信息\n>**概要信息** \n>入库编号：{oldModel.StockInNum}\n>入库类型：耗材\n>入库时间：<font color='comment'>{DateTime.Now.ToString("MM-dd HH-mm")}</font>\n>入库备注：<font color='comment'>{demodel.Remark}</font>\n>入库人员：{userInfo.emName}\n>";
                        string JumpUrl = System.Web.HttpUtility.UrlEncode($"/rukuNewDetails?Id={oldModel.Id}&backto=receiptApproval&showTable=1&compType=shenpi");
                        PushWeChatWorkAuditMsg(Common.Models.PushMessageCategoryEnum.PropertyStokcInAudit, markdownContent, "耗材入库审核通知", sendAccount, JumpUrl);
                    }
                    #endregion                    
                }

                supplies_StockInRepository.DBSession.Commit();
                return "";
            }
            catch (Exception ex)
            {
                supplies_StockInRepository.DBSession.Rollback();
                LogHelper.Write(ex, "SetSuppliesStockInAuditInfo");
                return "出错了，请联系管理员";
            }
        }

        /// <summary>
        /// 取消入库审核
        /// </summary>
        /// <param name="stockInId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public string CancelSuppliesStockInAudit(int stockInId, UserInfo userInfo)
        {
            var oldModel = supplies_StockInRepository.GetEntity(stockInId);
            if (oldModel == null) { return "入库单不存在"; }
            if (oldModel.StockInState != StockInStatusEnum.StockInAuditReject) { return "入库单状态不正确"; }
            var dModel = supplies_ProcurementRepository.GetEntity(oldModel.ProcurementId);
            if (dModel == null) { return "采购单不存在"; }

            var trans = supplies_StockInRepository.DbTransaction;
            try
            {
                Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_StockIn_Extend.StockInState), StockInStatusEnum.Cancel},
                    { nameof(RB_Supplies_StockIn_Extend.UpdateBy), userInfo.EmployeeId},
                    { nameof(RB_Supplies_StockIn_Extend.UpdateDate), DateTime.Now},
                };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_StockIn_Extend.Id),
                          FiledValue=stockInId,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                bool flag = supplies_StockInRepository.Update(keyValues, wheres, trans);
                if (flag)
                {
                    var dList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { RB_Group_Id = oldModel.RB_Group_Id, StockInId = oldModel.Id });
                    var PDList = supplies_ProcurementDetailRepository.GetList(new RB_Supplies_ProcurementDetail_Extend() { RB_Group_Id = oldModel.RB_Group_Id ?? 0, ProcurementId = oldModel.ProcurementId ?? 0 });
                    foreach (var item in dList)
                    {
                        var pdModel = PDList.Where(x => x.MaterialId == item.SuppliesId).FirstOrDefault();
                        if (pdModel == null)
                        {
                            supplies_StockInRepository.DBSession.Rollback();
                            return "入库明细与采购单不一致";
                        }
                        //回扣审核中的数量
                        Dictionary<string, object> keyValues2 = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_ProcurementDetail_Extend.AuditStokcInNum),pdModel.AuditStokcInNum - (item.Number ?? 0)}
                        };
                        List<WhereHelper> wheres2 = new List<WhereHelper>() {
                            new WhereHelper(){
                                    FiledName=nameof(RB_Supplies_ProcurementDetail_Extend.Id),
                                    FiledValue=pdModel.Id,
                                    OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        supplies_ProcurementDetailRepository.Update(keyValues2, wheres2, trans);
                    }
                    #region 记录日志
                    //日志
                    RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                    {
                        LogId = 0,
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        UpdateBy = userInfo.EmployeeId,
                        UpdateDate = System.DateTime.Now,
                        ResourceId = stockInId,
                        Content = "取消审核",
                        Type = 4
                    };
                    workfolw_Change_LogRepository.Insert(logModel, trans);
                    #endregion                    
                }

                supplies_StockInRepository.DBSession.Commit();
                return "";
            }
            catch (Exception ex)
            {
                supplies_StockInRepository.DBSession.Rollback();
                LogHelper.Write(ex, "SetSuppliesStockInAuditInfo");
                return "出错了，请联系管理员";
            }
        }

        /// <summary>
        /// 获取审核详情
        /// </summary>
        /// <param name="stockInId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public RB_Supplies_StockIn_Extend GetSuppliesStockInAuditDetail(int stockInId, UserInfo userInfo)
        {
            var dmodel = supplies_StockInRepository.GetEntity(stockInId).RefMapperTo<RB_Supplies_StockIn_Extend>();
            if (dmodel != null)
            {
                dmodel.DetailList = supplies_StockInDetailRepository.GetList(new RB_Supplies_StockInDetail_Extend() { StockInId = stockInId, RB_Group_Id = userInfo.RB_Group_id });
                foreach (var qitem in dmodel.DetailList)
                {
                    qitem.GoodsSpecificationList = new List<string>();
                    qitem.GoodsCategoryList = new List<string>();
                    if (!string.IsNullOrEmpty(qitem.SpecificationName))
                    {
                        qitem.GoodsSpecificationList = JsonConvert.DeserializeObject<List<string>>(qitem.SpecificationName);
                    }
                }

                //获取流程模板
                var tempmodel = workflow_TemplateRepository.GetEntity(dmodel.TempleteId ?? 0);
                dmodel.TemplateName = tempmodel?.Name ?? "未启用流程";

                //获取流程相关信息
                List<Rb_Workflow_AuditRelevance_Extend> warlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(dmodel.Id, "", null, 3);
                List<Rb_Workflow_Auditrecord_Extend> walist = new List<Rb_Workflow_Auditrecord_Extend>();
                walist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { WorkFlowId = dmodel.Id, TemplateType = 3 });

                //流程
                dmodel.AuditSteps = new List<Rb_Workflow_AuditRelevance_Extend>();
                #region 制单人信息
                Rb_Workflow_AuditRelevance_Extend rb_Workflow_AuditRelevance_Extend = new Rb_Workflow_AuditRelevance_Extend()
                {
                    AuditDescription = "发起人",
                    Sort = 0,
                    Stauts = WFRrocessStatus.AuditThrough,
                    SpecialNode = WFSpecialNodeEnum.Normal
                };
                rb_Workflow_AuditRelevance_Extend.AuditRecordList = new List<Rb_Workflow_Auditrecord_Extend>();
                var emmodel = CacheManager.User.UserReidsCache.GetEmployee(dmodel.CreateBy);
                Rb_Workflow_Auditrecord_Extend CreateauditInfo = new Rb_Workflow_Auditrecord_Extend()
                {
                    AuditEmName = (emmodel?.EmName ?? "") + (emmodel?.IsLeave == 1 ? "(离职)" : ""),
                    UpdateTime = dmodel.CreateDate.Value,
                    Description = "已提交",
                    Id = 0,
                    AuditStatus = WFRrocessStatus.AuditThrough
                };
                rb_Workflow_AuditRelevance_Extend.AuditRecordList.Add(CreateauditInfo);
                rb_Workflow_AuditRelevance_Extend.NextStep = 0;
                rb_Workflow_AuditRelevance_Extend.AuditWay = WFTAuditWayEnum.Successively;
                dmodel.AuditSteps.Add(rb_Workflow_AuditRelevance_Extend);
                #endregion

                #region 流程步骤信息
                dmodel.Is_AuditSelf = 0;
                dmodel.Is_CanAudit = 0;
                var auditSteps = warlist?.OrderBy(x => x.Sort).ToList();
                var NotAuditedList = auditSteps.Where(x => x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort).ToList();
                var NotAudited = NotAuditedList?.FirstOrDefault();
                foreach (var audititem in auditSteps)
                {
                    #region 审核流程 
                    audititem.AuditRecordList = new List<Rb_Workflow_Auditrecord_Extend>();
                    var record = walist.Where(x => x.AuditId == audititem.Id).ToList();
                    if (NotAudited != null && audititem.Id == NotAudited.Id && audititem.Stauts == WFRrocessStatus.NotAudit)
                    {
                        audititem.NextStep = 1;

                        #region 制单人审核人不能一样
                        if (("," + audititem.ToAuditId + ",").Contains("," + dmodel.CreateBy.Value + ",") && dmodel.CreateBy == userInfo.EmployeeId)
                        {
                            dmodel.Is_AuditSelf = 1;
                        }
                        if (audititem.SpecialNode == WFSpecialNodeEnum.Pay)
                        {
                            dmodel.Is_AuditSelf = 0;
                        }
                        #endregion
                        //待我审批的
                        if (("," + audititem.ToAuditId + ",").Contains("," + userInfo.EmployeeId + ","))
                        {
                            if (dmodel.StockInState == StockInStatusEnum.StockInWarting)
                            {
                                dmodel.Is_CanAudit = 1;
                            }
                        }
                        if (("," + audititem.AuditedId + ",").Contains("," + userInfo.EmployeeId + ","))
                        {
                            if (dmodel.StockInState == StockInStatusEnum.StockInWarting)
                            {
                                dmodel.Is_CanAudit = 0;
                            }
                        }

                    }
                    foreach (var recorditem in record)
                    {
                        List<string> imgList = new List<string>();
                        if (recorditem.Image != "[]" && !string.IsNullOrWhiteSpace(recorditem.Image))
                        {
                            imgList = JsonConvert.DeserializeObject<List<string>>(recorditem.Image);
                        }
                        Rb_Workflow_Auditrecord_Extend auditInfo = new Rb_Workflow_Auditrecord_Extend()
                        {
                            AuditEmName = CacheManager.User.UserReidsCache.GetEmployee(recorditem.AuditEmId)?.EmName ?? "",
                            UpdateTime = recorditem.UpdateTime.Value,
                            Description = recorditem.Description != "" ? recorditem.Description : "",
                            Id = recorditem.Id,
                            CareOfRemarks = recorditem.CareOfRemarks ?? "",
                            AuditStatus = recorditem.AuditStatus,
                            imgList = imgList,
                            SignImage = recorditem.SignImage
                        };
                        audititem.AuditRecordList.Add(auditInfo);
                    }
                    #endregion
                    dmodel.AuditSteps.Add(audititem);
                }
                #endregion

                #region 仓库
                dmodel.WareHouseName = supplies_WareHouseRepository.GetEntity(dmodel.WarehouseId)?.Name ?? "";
                #endregion

                #region 采购
                dmodel.FinanceIds = supplies_ProcurementRepository.GetEntity(dmodel.ProcurementId ?? 0)?.FinanceId ?? "";
                #endregion

                dmodel.VoucherList = new List<VoucherModel>();
                if (!string.IsNullOrEmpty(dmodel.Voucher) && dmodel.Voucher != "[]")
                {
                    dmodel.VoucherList = JsonHelper.DeserializeObject<List<VoucherModel>>(dmodel.Voucher);
                }
            }
            return dmodel;
        }

        /// <summary>
        /// 审核通过
        /// </summary>
        /// <param name="model"></param>
        /// <param name="imageList"></param>
        /// <param name="auditDescription"></param>
        /// <param name="signImage"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult SuppliesStockInAuditPass(RB_Supplies_StockIn_Extend model, List<string> imageList, string auditDescription, string signImage, UserInfo userInfo)
        {
            return workFlowModule.SuppliesStockInAuditPass(model, imageList, auditDescription, signImage, userInfo);
        }

        /// <summary>
        /// 审批驳回
        /// </summary>
        /// <param name="model"></param>
        /// <param name="imageList"></param>
        /// <param name="auditDescription"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult SuppliesStockInAuditReject(RB_Supplies_StockIn_Extend model, List<string> imageList, string auditDescription, UserInfo userInfo)
        {
            return workFlowModule.SuppliesStockInAuditReject(model, imageList, auditDescription, userInfo);
        }

        /// <summary>
        /// 转交
        /// </summary>
        /// <returns></returns>
        public ApiResult SuppliesStockInTransfer(List<Rb_Workflow_Auditrecord_Extend> list, UserInfo userInfo, int TemplateType)
        {
            bool flag = true;
            foreach (var item in list)
            {
                int WorkFlowId = item.WorkFlowId.Value; int OldEmId = userInfo.EmployeeId; int NewEmId = item.AuditEmId.Value;
                if ((item.TransferEmpId ?? 0) > 0)
                {
                    OldEmId = item.TransferEmpId ?? 0;
                }
                var auditModel = workflow_AuditRelevanceRepository.GetAuditRelevanceList(WorkFlowId, "", null, TemplateType).Where(x => x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort).FirstOrDefault();
                if (auditModel == null)
                {
                    return ApiResult.Failed("财务单据：" + WorkFlowId + "审核流程已完毕");
                }
                int AuditId = auditModel.Id;
                if (AuditId > 0)
                {
                    //验证  是否有已审批通过的  再转交给审批通过者
                    var alist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = AuditId, TemplateType = TemplateType });
                    if (alist != null && alist.Any())
                    {
                        //AuditStatus
                        if (alist.Where(x => x.AuditStatus == WFRrocessStatus.AuditThrough && x.AuditEmId == NewEmId).Count() > 0)
                        {
                            return ApiResult.Failed("转交人已参与审批通过,无法转交");
                        }
                    }
                }
                var trans = workflow_AuditrecordRepository.DbTransaction;
                try
                {
                    var OldEmodel = employeeRepository.GetEmployeeInfo(OldEmId);
                    var NewEmodel = employeeRepository.GetEmployeeInfo(NewEmId);
                    if (OldEmodel == null || NewEmodel == null)
                    {
                        return ApiResult.Failed("转交人或者当前审核人不存在，请联系管理员");
                    }
                    var amodel = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = AuditId, AuditEmId = OldEmId, TemplateType = TemplateType })?.FirstOrDefault();
                    if (amodel == null) { return ApiResult.Failed("审核步骤不存在，请联系技术人员"); }
                    var coModelList = new List<SetCareOfModel>();
                    if (!string.IsNullOrWhiteSpace(amodel.CareOfRemarks))
                    {
                        coModelList = JsonConvert.DeserializeObject<List<SetCareOfModel>>(amodel.CareOfRemarks);
                    }
                    SetCareOfModel comodel = new SetCareOfModel()
                    {
                        BeFrom = OldEmodel.EmployeeName,
                        Target = NewEmodel.EmployeeName,
                        Remarks = item.Description
                    };
                    coModelList.Add(comodel);
                    flag = UpdateAuditEmId(AuditId, OldEmId, NewEmId, coModelList, trans);
                    //日志
                    RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                    {
                        LogId = 0,
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        UpdateBy = userInfo.EmployeeId,
                        UpdateDate = DateTime.Now,
                        ResourceId = WorkFlowId,
                        Type = TemplateType + 1,
                        Content = "由" + OldEmodel.EmployeeName + "转交给" + NewEmodel.EmployeeName
                    };
                    workfolw_Change_LogRepository.Insert(logModel, trans);

                }
                catch (Exception ex)
                {
                    LogHelper.Write(ex, "Transfer");
                    workflow_AuditrecordRepository.DBSession.Rollback("Transfer：1，异常信息：" + ex.Message);
                    return ApiResult.Failed("转交失败");
                }
            }
            if (flag)
            {
                workflow_AuditrecordRepository.DBSession.Commit();
                return ApiResult.Success("转交成功");
            }
            else
            {
                workflow_AuditrecordRepository.DBSession.Rollback("Transfer：2");
                return ApiResult.Failed("转交失败");
            }
        }
        #endregion

        #region 耗材出库申请

        /// <summary>
        /// 获取耗材出库申请分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockOutApplyFor_Extend> GetSuppliesStockOutApplyForPageList(int pageIndex, int pageSize, RB_Supplies_StockOutApplyFor_Extend demodel, out long count)
        {
            var list = supplies_StockOutApplyForRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            if (list.Any()) {
                //查询明细
                string Ids = string.Join(",", list.Select(x => x.Id));
                var dlist = supplies_StockOutApplyForDetailRepository.GetList(new RB_Supplies_StockOutApplyForDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, ApplyForIds = Ids });
                //查询人员
                string createByIds = string.Join(",", list.Select(x => x.CreateBy).Distinct());
                var ulist = employeeRepository.GetEmployeeListRepository(new Employee_ViewModel() { Group_Id = demodel.RB_Group_Id, QIds = createByIds });
                foreach (var item in list) {
                    item.DetailList = dlist.Where(x => x.ApplyForId == item.Id).ToList();
                    item.CreateByName = ulist.Where(x => x.Id == item.CreateBy).FirstOrDefault()?.EmployeeName ?? "";
                }
            }
            return list;
        }

        /// <summary>
        /// 获取耗材出库申请详情
        /// </summary>
        /// <param name="applyForId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public RB_Supplies_StockOutApplyFor_Extend GetSuppliesStokcOutApplyForInfo(int applyForId, UserInfo userInfo)
        {
            var model = supplies_StockOutApplyForRepository.GetEntity<RB_Supplies_StockOutApplyFor_Extend>(applyForId);
            if (model != null) {
                model.DetailList = supplies_StockOutApplyForDetailRepository.GetList(new RB_Supplies_StockOutApplyForDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, ApplyForId = model.Id });
                model.CreateByName = employeeRepository.GetEmployeeInfo(model.CreateBy)?.EmployeeName ?? "";
            }
            return model;
        }

        /// <summary>
        /// 新增耗材出库申请
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public string SetSuppliesStockOutApplyForInfo(RB_Supplies_StockOutApplyFor_Extend demodel, UserInfo userInfo)
        {
            #region 验证库存是否足够
            string suppliesIds = string.Join(",", demodel.DetailList.Select(x => x.SuppliesId).Distinct());
            var inventoryList = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = userInfo.RB_Group_id, SuppliesIdStr = suppliesIds });
            foreach (var item in demodel.DetailList) {
                int num = inventoryList.Where(x => x.SuppliesId == item.SuppliesId).Sum(x => x.Number ?? 0);
                int SONumber = demodel.DetailList.Where(x => x.SuppliesId == item.SuppliesId).Sum(x => x.Number);
                if (num < SONumber) {
                    return "耗材" + item.SuppliesName + "(" + item.SuppliesId + ")库存不足，请核实后再试";
                }
            }
            #endregion
            if (demodel.Id > 0)
            {
                var oldModel = supplies_StockOutApplyForRepository.GetEntity(demodel.Id);
                if (oldModel == null || oldModel.AuditStatus == 2) { return "状态不正确，无法修改"; }
                demodel.TotalNumber = demodel.DetailList.Sum(x => x.Number);
                Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_StockOutApplyFor_Extend.TotalNumber),demodel.TotalNumber},
                    { nameof(RB_Supplies_StockOutApplyFor_Extend.Remark),demodel.Remark},
                    { nameof(RB_Supplies_StockOutApplyFor_Extend.AuditStatus),1},
                    { nameof(RB_Supplies_StockOutApplyFor_Extend.AuditEmpId),0},
                    { nameof(RB_Supplies_StockOutApplyFor_Extend.AuditRemark),""},
                    { nameof(RB_Supplies_StockOutApplyFor_Extend.AuditDate),null},
                    { nameof(RB_Supplies_StockOutApplyFor_Extend.UpdateBy), userInfo.EmployeeId},
                    { nameof(RB_Supplies_StockOutApplyFor_Extend.UpdateDate), DateTime.Now},
                };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_StockOutApplyFor_Extend.Id),
                          FiledValue=demodel.Id,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                bool flag = supplies_StockOutApplyForRepository.Update(keyValues, wheres);
                if (flag) {
                    var list = supplies_StockOutApplyForDetailRepository.GetList(new RB_Supplies_StockOutApplyForDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, ApplyForId = demodel.Id });
                    foreach (var item in demodel.DetailList) {
                        var oldDetail = list.Where(x => x.ClassId == item.ClassId && x.SuppliesId == item.SuppliesId).FirstOrDefault();
                        if (oldDetail == null)
                        {
                            //新增
                            supplies_StockOutApplyForDetailRepository.Insert(new RB_Supplies_StockOutApplyForDetail()
                            {
                                Id = 0,
                                ApplyForId = demodel.Id,
                                ClassId = item.ClassId,
                                ClassName = item.ClassName,
                                CourseName = item.CourseName,
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                Number = item.Number,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Status = 0,
                                StockOutNum = 0,
                                SuppliesId = item.SuppliesId,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate,
                                SchoolId = item.SchoolId,
                                SchoolName = item.SchoolName
                            });
                        }
                        else {
                            if (item.Number != oldDetail.Number) {
                                Dictionary<string, object> keyValues1 = new Dictionary<string, object>() {
                                    { nameof(RB_Supplies_StockOutApplyForDetail.Number),item.Number}
                                };
                                List<WhereHelper> wheres1 = new List<WhereHelper>() {
                                     new WhereHelper(){
                                         FiledName=nameof(RB_Supplies_StockOutApplyForDetail.Id),
                                          FiledValue=oldDetail.Id,
                                           OperatorEnum=OperatorEnum.Equal
                                     }
                                };
                                supplies_StockOutApplyForDetailRepository.Update(keyValues1, wheres1);
                            }
                        }
                    }
                    foreach (var item in list) {
                        var model = demodel.DetailList.Where(x => x.ClassId == item.ClassId && x.SuppliesId == item.SuppliesId).FirstOrDefault();
                        if (model == null) {
                            //删除
                            Dictionary<string, object> keyValues1 = new Dictionary<string, object>() {
                                { nameof(RB_Supplies_StockOutApplyForDetail.Status),1}
                            };
                            List<WhereHelper> wheres1 = new List<WhereHelper>() {
                                    new WhereHelper(){
                                        FiledName=nameof(RB_Supplies_StockOutApplyForDetail.Id),
                                        FiledValue=item.Id,
                                        OperatorEnum=OperatorEnum.Equal
                                    }
                            };
                            supplies_StockOutApplyForDetailRepository.Update(keyValues1, wheres1);
                        }
                    }
                    return "";
                }
                return "出错了，请联系管理员";
            }
            else
            {
                demodel.FinanceIds = "[]";
                demodel.TotalNumber = demodel.DetailList.Sum(x => x.Number);
                var applyForId = supplies_StockOutApplyForRepository.Insert(demodel);
                if (applyForId > 0)
                {
                    //插入明细
                    foreach (var item in demodel.DetailList)
                    {
                        supplies_StockOutApplyForDetailRepository.Insert(new RB_Supplies_StockOutApplyForDetail()
                        {
                            Id = 0,
                            ApplyForId = applyForId,
                            ClassId = item.ClassId,
                            ClassName = item.ClassName,
                            CourseName = item.CourseName,
                            CreateBy = demodel.CreateBy,
                            CreateDate = demodel.CreateDate,
                            Number = item.Number,
                            RB_Branch_Id = demodel.RB_Branch_Id,
                            RB_Group_Id = demodel.RB_Group_Id,
                            Status = 0,
                            StockOutNum = 0,
                            SuppliesId = item.SuppliesId,
                            UpdateBy = demodel.UpdateBy,
                            UpdateDate = demodel.UpdateDate,
                            SchoolId = item.SchoolId,
                            SchoolName = item.SchoolName
                        });
                    }
                    return "";
                }
                return "出错了，请联系管理员";
            }
        }

        /// <summary>
        /// 获取出库申请实体
        /// </summary>
        /// <param name="applyForId"></param>
        /// <returns></returns>
        public RB_Supplies_StockOutApplyFor_Extend GetSuppliesStokcOutApplyForEntry(int applyForId)
        {
            return supplies_StockOutApplyForRepository.GetEntity<RB_Supplies_StockOutApplyFor_Extend>(applyForId);
        }

        /// <summary>
        /// 设置出库申请状态
        /// </summary>
        /// <param name="applyForId"></param>
        /// <param name="type"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetSuppliesStockOutApplyForState(int applyForId, int type, string remark, UserInfo userInfo)
        {
            Dictionary<string, object> keyValues = new Dictionary<string, object>();
            if (type == 1)
            {
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.Status), 1);
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.UpdateBy), userInfo.EmployeeId);
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.UpdateDate), DateTime.Now);
            }
            else if (type == 2)
            {
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.AuditStatus), 2);
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.AuditEmpId), userInfo.EmployeeId);
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.AuditRemark), remark);
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.AuditDate), DateTime.Now);
            }
            else if (type == 3) {
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.AuditStatus), 3);
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.AuditEmpId), userInfo.EmployeeId);
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.AuditRemark), remark);
                keyValues.Add(nameof(RB_Supplies_StockOutApplyFor.AuditDate), DateTime.Now);
            }
            else {
                return false;
            }
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                     FiledName=nameof(RB_Supplies_StockOutApplyFor.Id),
                      FiledValue=applyForId,
                       OperatorEnum=OperatorEnum.Equal
                }
            };
            return supplies_StockOutApplyForRepository.Update(keyValues, wheres);
        }

        /// <summary>
        /// 出库
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public string SetSuppliesApplyForStockOut(RB_Supplies_StockOutApplyFor_Extend demodel, UserInfo userInfo)
        {
            var oldModel = supplies_StockOutApplyForRepository.GetEntity(demodel.Id);
            if (oldModel == null) { return "出库申请不存在"; }
            if (oldModel.AuditStatus != 2) { return "未审核通过，无法出库"; }
            if (oldModel.StockOutStatus == 3) { return "已出库完毕"; }

            RB_Finance_Config_ViewModel configModel = null;
            if (oldModel.Type == 1 || oldModel.Type == 3) {
                configModel = finance_ConfigRepository.GetList(new RB_Finance_Config_ViewModel() { Group_Id = userInfo.RB_Group_id, Type = FinanceConfigTypeEnum.SuppliesStockOut }).FirstOrDefault();
            }
            else {
                configModel = finance_ConfigRepository.GetList(new RB_Finance_Config_ViewModel() { Group_Id = userInfo.RB_Group_id, Type = FinanceConfigTypeEnum.OtherSuppliesStockOut }).FirstOrDefault();
            }
            if (configModel == null) { return "未配置费用/流程信息，请联系管理员"; }

            var list = supplies_StockOutApplyForDetailRepository.GetList(new RB_Supplies_StockOutApplyForDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, ApplyForId = demodel.Id });

            List<RB_Supplies_StockOutApplyForDetail_Extend> SuppliesList = new List<RB_Supplies_StockOutApplyForDetail_Extend>();
            List<int> ClassIdList = new List<int>();
            foreach (var item in demodel.DetailList) {
                var model = list.Where(x => x.Id == item.Id).FirstOrDefault();
                item.SuppliesId = model.SuppliesId;
                item.SuppliesName = model.SuppliesName;
                item.Number = model.Number;
                item.StockOutNum = model.StockOutNum;
                if (item.Number < item.StockOutNum + item.WaitStockOutNum) {
                    return "耗材" + item.SuppliesName + "(" + item.SuppliesId + ")超过最大出库数量，请核实后再试";
                }
                item.ClassId = model.ClassId;
                item.ClassName = model.ClassName;
                item.CourseName = model.CourseName;
                item.SchoolId = model.SchoolId;
                item.SchoolName = model.SchoolName;
                ClassIdList.Add(model.ClassId);
                var smodel = SuppliesList.Where(x => x.SuppliesId == item.SuppliesId).FirstOrDefault();
                if (smodel == null)
                {
                    SuppliesList.Add(new RB_Supplies_StockOutApplyForDetail_Extend()
                    {
                        SuppliesId = item.SuppliesId,
                        WaitStockOutNum = item.WaitStockOutNum,
                        SuppliesName = item.SuppliesName,
                        BrandName = model.BrandName + "(" + item.WaitStockOutNum + "件)"
                    });
                }
                else {
                    smodel.WaitStockOutNum += item.WaitStockOutNum;
                    smodel.BrandName += ";" + model.BrandName + "(" + item.WaitStockOutNum + "件)";
                }
            }
            #region 验证库存是否足够
            string suppliesIds = string.Join(",", demodel.DetailList.Select(x => x.SuppliesId).Distinct());
            var inventoryList = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = userInfo.RB_Group_id, WarehouseId = demodel.WareHouseId, SuppliesIdStr = suppliesIds });
            foreach (var item in SuppliesList)
            {
                int num = inventoryList.Where(x => x.SuppliesId == item.SuppliesId).Sum(x => x.Number ?? 0);
                if (num < item.WaitStockOutNum)
                {
                    return "耗材" + item.SuppliesName + "(" + item.SuppliesId + ")库存不足，请核实后再试";
                }
            }
            #endregion

            var trans = supplies_StockOutApplyForRepository.DbTransaction;
            try
            {
                #region 更新出库数量
                foreach (var item in demodel.DetailList)
                {
                    item.StockOutNum += item.WaitStockOutNum;
                    Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_StockOutApplyForDetail_Extend.StockOutNum),item.StockOutNum}
                };
                    List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Supplies_StockOutApplyForDetail_Extend.Id),
                          FiledValue=item.Id,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                    supplies_StockOutApplyForDetailRepository.Update(keyValues, wheres, trans);
                }
                #endregion

                #region 新增出库单
                int StockOutId = supplies_StockOutRepository.Insert(new RB_Supplies_StockOut()
                {
                    BranchId = userInfo.RB_Branch_id,
                    CreateBy = userInfo.EmployeeId,
                    CreateDate = DateTime.Now,
                    EmployeeId = oldModel.CreateBy,
                    DepartmentId = userInfo.RB_Department_Id,
                    Id = 0,
                    RB_Branch_Id = userInfo.RB_Branch_id,
                    RB_Group_Id = userInfo.RB_Group_id,
                    Remark = "耗材出库-自动生成出库单",
                    Status = 0,
                    StockOutDate = DateTime.Now,
                    StockOutNum = "",
                    StockOutState = StockOutStatusEnum.StockOut,
                    UpdateBy = userInfo.EmployeeId,
                    UpdateDate = DateTime.Now,
                    WarehouseId = demodel.WareHouseId,
                    ApplyForId = demodel.Id
                }, trans);
                if (StockOutId > 0)
                {
                    #region 编码更新
                    string BMStr = StockOutId.ToString();
                    if (BMStr.Length < 5)
                    {
                        switch (BMStr.Length)
                        {
                            case 1:
                                BMStr = "0000" + BMStr; break;
                            case 2:
                                BMStr = "000" + BMStr; break;
                            case 3:
                                BMStr = "00" + BMStr; break;
                            case 4:
                                BMStr = "0" + BMStr; break;
                        }
                    }
                    BMStr = "CK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                    Dictionary<string, object> files = new Dictionary<string, object>() {
                    { nameof(RB_Supplies_StockOut.StockOutNum),BMStr}
                };
                    List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                            FiledName=nameof(RB_Supplies_StockOut.Id),
                            FiledValue=StockOutId,
                            OperatorEnum=OperatorEnum.Equal
                    }
                };
                    supplies_StockOutRepository.Update(files, wheres, trans);
                    #endregion
                    //新增明细
                    foreach (var item in SuppliesList)
                    {
                        var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WareHouseId, SuppliesId = item.SuppliesId });
                        decimal Price = 0;
                        if (ilist.Any())
                        {
                            var iModel = ilist.FirstOrDefault();
                            item.Money = Math.Round((iModel.Money ?? 0) / (iModel.Number ?? 1), 2, MidpointRounding.AwayFromZero);
                            Price = item.Money * item.WaitStockOutNum;
                        }
                        supplies_StockOutDetailRepository.Insert(new RB_Supplies_StockOutDetail()
                        {
                            CreateBy = demodel.CreateBy,
                            CreateDate = demodel.CreateDate,
                            Number = item.WaitStockOutNum,
                            Money = Price,
                            RB_Branch_Id = demodel.RB_Branch_Id,
                            Id = 0,
                            RB_Group_Id = demodel.RB_Group_Id,
                            Remark = item.BrandName,
                            Status = 0,
                            StockOutId = StockOutId,
                            SuppliesId = item.SuppliesId,
                            UpdateBy = demodel.UpdateBy,
                            UpdateDate = demodel.UpdateDate
                        }, trans);

                        //新增库存表数据
                        if (ilist.Any())
                        {
                            var iModel = ilist.FirstOrDefault();
                            iModel.Number -= item.WaitStockOutNum;//减少库存
                            iModel.Money -= Price;
                            if (iModel.Money < 0)
                            {
                                iModel.Money = 0;
                            }
                            var iflag = supplies_InventoryRepository.Update(iModel, trans);
                            if (iflag)
                            {
                                //增加库存明细
                                supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                {
                                    CreateBy = demodel.CreateBy,
                                    CreateDate = DateTime.Now,
                                    InventoryId = iModel.Id,
                                    Number = item.WaitStockOutNum,
                                    Money = Price,
                                    RB_Branch_Id = demodel.RB_Branch_Id,
                                    RB_Group_Id = demodel.RB_Group_Id,
                                    Status = 0,
                                    Type = 2,
                                    Id = 0,
                                    Description = "减少库存-出库"
                                }, trans);
                            }
                        }
                    }
                }
                #endregion

                #region 生成财务单据
                #region 查询所有耗材信息
                var materialList = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = userInfo.RB_Group_id, SuppliesIdStr = suppliesIds });
                string categoryIds = string.Join(",", materialList.Select(x => x.CategoryId).Distinct());
                var cateList = property_CategoryRepository.GetList(new RB_Property_Category_Extend() { RB_Group_Id = demodel.RB_Group_Id, CategoryIdStr = categoryIds });
                #endregion
                List<int> FinanceIdList = JsonConvert.DeserializeObject<List<int>>(oldModel.FinanceIds);
                string FinanceRematk = oldModel.Remark;
                //根据班级区分  每个班级生成一张财务单据
                ClassIdList = ClassIdList.Distinct().ToList();
                foreach (var classId in ClassIdList)
                {
                    var dlist = demodel.DetailList.Where(x => x.ClassId == classId).ToList();
                    var dmodel = dlist.FirstOrDefault();
                    #region 生成财务单据
                    var detailList = new List<object>();
                    decimal TotalCostMoney = 0;
                    int SchoolId = dmodel?.SchoolId ?? 0;
                    foreach (var item in dlist)
                    {
                        var mModel = materialList.Where(x => x.Id == item.SuppliesId).FirstOrDefault();
                        decimal UnitPrice = SuppliesList.Where(x => x.SuppliesId == item.SuppliesId).FirstOrDefault()?.Money ?? 0;
                        detailList.Add(new
                        {
                            configModel.CostTypeId,
                            Number = item.WaitStockOutNum,
                            OriginalMoney = UnitPrice * item.WaitStockOutNum,
                            UnitPrice,
                            Remark = (classId > 0 ? item.ClassName + " " : "") + mModel.Name + "(" + mModel.SuppliesNum + ") "
                        });
                        TotalCostMoney += UnitPrice * item.WaitStockOutNum;
                    }

                    var financeObj = new
                    {
                        CreateBy = userInfo.EmployeeId,
                        IsPublic = 0,//存货出库
                        ClientType = 10,
                        configModel.ClientID,
                        configModel.CurrencyId,
                        WBMoney = TotalCostMoney,
                        RB_Branch_Id = SchoolId,
                        PayDate = DateTime.Now.ToString("yyyy-MM-dd"),
                        TemplateId = configModel.TempleteId,
                        OrderSource = 17,
                        OtherType = 33,
                        Remark = DateTime.Now.ToString("yyyy年MM月dd日") + "生成财务单据",
                        detailList,
                        RB_Depart_Id = userInfo.RB_Department_Id,
                        ReFinanceId = StockOutId,
                        ReFinanceId2 = demodel.Id,
                        OrderID = oldModel.Type == 3 ? classId : 0,
                        TCIDList = oldModel.Type == 3 ? new List<int> { Convert.ToInt32(dmodel.CourseName) } : classId > 0 ? new List<int>() { classId } : new List<int>(),
                        FinanceType = 2,
                        RB_Group_Id = userInfo.RB_Group_id,
                        RB_CreateByName = userInfo.emName,
                        RB_DepartName = userInfo.DepartName,
                        RB_BranchName = schoolRepository.GetEntity(SchoolId)?.SName ?? "",
                        RB_GroupName = userInfo.GroupName,
                        ECOrderList = oldModel.MallOrderId > 0 ? JsonHelper.DeserializeObject<List<object>>(oldModel.MallRelevance) : new List<object>(),
                        RelevanceFrId = oldModel.MallOrderId
                    };
                    string sign = EncryptionHelper.AesEncrypt(JsonHelper.Serialize(financeObj), Config.FinanceKey);
                    var resultInfo = new
                    {
                        msg = sign,
                    };
                    string apiResult = HttpHelper.HttpPost(Config.PaymentFinanceApi, JsonHelper.Serialize(resultInfo), "");
                    JObject parmsJob = JObject.Parse(apiResult);
                    int frid = parmsJob.GetInt("data", 0);
                    #endregion
                    if (frid > 0)
                    {
                        FinanceIdList.Add(frid);
                        FinanceRematk += dmodel?.ClassName + "生成单据" + frid + "；";
                    }
                    else
                    {
                        FinanceRematk += dmodel?.ClassName + "生成单据失败；";
                    }
                }
                #endregion

                #region 更新申请单
                bool UpdateGoodsCost = false;
                Dictionary<string, object> keyValues1 = new Dictionary<string, object>() {
                { nameof(RB_Supplies_StockOutApplyFor_Extend.FinanceIds),JsonConvert.SerializeObject(FinanceIdList)},
                { nameof(RB_Supplies_StockOutApplyFor_Extend.Remark),FinanceRematk},
            };
                if (demodel.DetailList.Where(x => x.Number > x.StockOutNum).Any())
                {
                    keyValues1.Add(nameof(RB_Supplies_StockOutApplyFor_Extend.StockOutStatus), 2);
                }
                else
                {
                    keyValues1.Add(nameof(RB_Supplies_StockOutApplyFor_Extend.StockOutStatus), 3);
                    UpdateGoodsCost = true;
                }
                List<WhereHelper> wheres1 = new List<WhereHelper>() {
                new WhereHelper(){
                     FiledName=nameof(RB_Supplies_StockOutApplyFor_Extend.Id),
                      FiledValue=demodel.Id,
                       OperatorEnum=OperatorEnum.Equal
                }
            };
                supplies_StockOutApplyForRepository.Update(keyValues1, wheres1);
                #endregion

                supplies_StockOutApplyForRepository.DBSession.Commit();
                if (UpdateGoodsCost && oldModel.MallOrderId > 0) {
                    //更新 电商订单成本
                    try
                    {
                        var stockOutList = supplies_StockOutRepository.GetList(new RB_Supplies_StockOut_Extend() { RB_Group_Id = oldModel.RB_Group_Id, ApplyForId = oldModel.Id });
                        if (stockOutList.Any()) {
                            string soIds = string.Join(",", stockOutList.Select(x => x.Id));
                            var sdetailList = supplies_StockOutDetailRepository.GetList(new RB_Supplies_StockOutDetail_Extend() { RB_Group_Id = oldModel.RB_Group_Id, StockOutIdStr = soIds });
                            decimal TCostMoney = sdetailList.Sum(x => x.Money ?? 0);//平均算法下的 总金额

                            //设置 电商商品的成本金额 （有了成本金额之后  无法再取消）
                            goods_OrderDetailRepository.UpdateEduGoodsCostMoney(TCostMoney, oldModel.MallOrderId);
                            //设置 教育关联订单 成本金额  （后续统计使用）
                            finance_ConfigRepository.UpdateEduGoodsCostMoney(TCostMoney, oldModel.MallOrderId);
                            foreach (var qtem in list) {
                                //单商品的总成本价格
                                decimal costMoney = sdetailList.Where(x => x.SuppliesId == qtem.SuppliesId).Sum(x => x.Money ?? 0);
                                goods_OrderDetailRepository.UpdateEduGoodsDetailCostMoney(costMoney, oldModel.MallOrderId, qtem.SuppliesId);
                                finance_ConfigRepository.UpdateEduGoodsDetailCostMoney(costMoney, oldModel.MallOrderId, qtem.SuppliesId);
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        LogHelper.Write(ex, "UpdateGoodsCost");
                    }
                }
                return "";
            }
            catch (Exception ex)
            {
                supplies_StockOutApplyForRepository.DBSession.Rollback();
                LogHelper.Write(ex, "SetSuppliesApplyForStockOut");
                return "出错了，请联系管理员";
            }
        }

        #endregion

        #region 资产耗材调拨

        /// <summary>
        /// 设置资产耗材调拨
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public string SetPropertySuppliesAllot(RB_Allocate_Record_Extend demodel, UserInfo userInfo)
        {
            if (demodel.Type == 1)
            {
                //资产转耗材
                var pmodel = property_InfoRepository.GetEntity(demodel.PropertyId);
                if (pmodel == null || pmodel.Status == 1) { return "资产不存在"; }
                if (pmodel.PropertyStatus != PropertyStatusEnum.Leisure) { return "不是空闲资产，无法调拨至耗材"; }
                //资产供应商
                string SupplierName = property_SupplierRepository.GetEntity(pmodel.SupplierId)?.Name ?? "";

                //查询耗材信息
                var mmodel = supplies_MaterialRepository.GetEntity(demodel.MaterialId);
                if (mmodel == null || mmodel.Status == 1) { return "物料档案不存在"; }
                var wmodel = supplies_WareHouseRepository.GetEntity(demodel.WarehouseId);
                if (wmodel == null || wmodel.Status == 1) { return "仓库不存在"; }
                //初始化数据
                RB_Supplies_StockIn_Extend smodel = new RB_Supplies_StockIn_Extend()
                {
                    Id = 0,
                    WarehouseId = demodel.WarehouseId,
                    StockInState = StockInStatusEnum.StockIn,
                    StockInDate = pmodel.BuyDate,
                    Money = pmodel.Money,
                    SupplierName = SupplierName,
                    Remark = "资产(" + pmodel.Id + ")调拨至耗材",
                    Status = 0,
                    RB_Branch_Id = userInfo.RB_Branch_id,
                    RB_Group_Id = userInfo.RB_Group_id,
                    CreateBy = userInfo.EmployeeId,
                    CreateDate = DateTime.Now,
                    UpdateBy = userInfo.EmployeeId,
                    UpdateDate = DateTime.Now,
                    StockInNum = "",
                    ProcurementId = 0,
                    TempleteId = 0,
                    IsAgainStock = 0,
                    ReturnsId = 0,
                    ReturnsNo = ""
                };
                smodel.DetailList = new List<RB_Supplies_StockInDetail_Extend>() {
                    new RB_Supplies_StockInDetail_Extend(){
                        CreateBy = demodel.CreateBy,
                            CreateDate = DateTime.Now,
                            Money = pmodel.Money,
                            Number = 1,
                            RB_Branch_Id = userInfo.RB_Branch_id,
                            Id = 0,
                            RB_Group_Id = userInfo.RB_Group_id,
                            Remark = "",
                            Status = 0,
                            StockInId = 0,
                            SuppliesId = demodel.MaterialId,
                            UnitPrice = pmodel.Money,
                            UpdateBy = userInfo.EmployeeId,
                            UpdateDate = DateTime.Now
                    }
                };
                //生产编号

                var trans = allocate_RecordRepository.DbTransaction;
                try
                {
                    int Id = supplies_StockInRepository.Insert(smodel, trans);
                    if (Id > 0)
                    {
                        //编码自动生成
                        string BMStr = Id.ToString();
                        if (BMStr.Length < 5)
                        {
                            switch (BMStr.Length)
                            {
                                case 1:
                                    BMStr = "0000" + BMStr; break;
                                case 2:
                                    BMStr = "000" + BMStr; break;
                                case 3:
                                    BMStr = "00" + BMStr; break;
                                case 4:
                                    BMStr = "0" + BMStr; break;
                            }
                        }
                        BMStr = "TRK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                        Dictionary<string, object> files = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_StockIn.StockInNum),BMStr}
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Supplies_StockIn.Id),
                                  FiledValue=Id,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        supplies_StockInRepository.Update(files, wheres, trans);

                        //新增明细
                        foreach (var item in smodel.DetailList)
                        {
                            supplies_StockInDetailRepository.Insert(new RB_Supplies_StockInDetail()
                            {
                                CreateBy = item.CreateBy,
                                CreateDate = item.CreateDate,
                                Money = item.Money,
                                Number = item.Number,
                                RB_Branch_Id = item.RB_Branch_Id,
                                Id = 0,
                                RB_Group_Id = item.RB_Group_Id,
                                Remark = item.Remark,
                                Status = 0,
                                StockInId = Id,
                                SuppliesId = item.SuppliesId,
                                UnitPrice = item.UnitPrice,
                                UpdateBy = item.UpdateBy,
                                UpdateDate = item.UpdateDate
                            }, trans);

                            //新增库存表数据
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = smodel.RB_Group_Id, WarehouseId = smodel.WarehouseId, SuppliesId = item.SuppliesId });
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number += item.Number;//增加库存
                                iModel.Money += item.Money;
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = smodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.Number,
                                        Money = item.Money,
                                        RB_Branch_Id = smodel.RB_Branch_Id,
                                        RB_Group_Id = smodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "新增库存 - 资产调拨至耗材"
                                    }, trans);
                                }
                            }
                            else
                            {
                                //新增库存表
                                int iId = supplies_InventoryRepository.Insert(new RB_Supplies_Inventory()
                                {
                                    CreateBy = smodel.CreateBy,
                                    CreateDate = DateTime.Now,
                                    Id = 0,
                                    Number = item.Number,
                                    Money = item.Money,
                                    RB_Branch_Id = smodel.RB_Branch_Id,
                                    RB_Group_Id = smodel.RB_Group_Id,
                                    Status = 0,
                                    SuppliesId = item.SuppliesId,
                                    UpdateBy = smodel.UpdateBy,
                                    UpdateDate = smodel.UpdateDate,
                                    WarehouseId = smodel.WarehouseId
                                }, trans);
                                if (iId > 0)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = smodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iId,
                                        Number = item.Number,
                                        Money = item.Money,
                                        RB_Branch_Id = smodel.RB_Branch_Id,
                                        RB_Group_Id = smodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 1,
                                        Id = 0,
                                        Description = "新增库存 - 知产调拨至耗材"
                                    }, trans);
                                }
                            }
                        }

                        #region 更新资产为调拨
                        Dictionary<string, object> keyValues = new Dictionary<string, object>() {
                            { nameof(RB_Property_Info.PropertyStatus),PropertyStatusEnum.Supplies},
                            { nameof(RB_Property_Info.IsDepreciation),0}
                        };
                        List<WhereHelper> wheres1 = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Property_Info.Id),
                                  FiledValue=pmodel.Id,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        property_InfoRepository.Update(keyValues, wheres1, trans);
                        property_LogRepository.Insert(new RB_Property_Log()
                        {
                            PropertyId = pmodel.Id,
                            Content = "资产调拨至耗材",
                            CreateBy = userInfo.EmployeeId,
                            CreateDate = DateTime.Now,
                            Id = 0,
                            RB_Branch_Id = userInfo.RB_Branch_id,
                            RB_Group_Id = userInfo.RB_Group_id,
                            Status = 0,
                            TypeName = "耗材调拨"
                        }, trans);
                        #endregion

                        #region 记录调拨日志
                        demodel.StockInOutNo = BMStr;
                        allocate_RecordRepository.Insert(demodel,trans);
                        #endregion
                    }
                    allocate_RecordRepository.DBSession.Commit();
                    return "";
                }
                catch (Exception ex)
                {
                    LogHelper.Write(ex, "SetPropertySuppliesAllot");
                    allocate_RecordRepository.DBSession.Rollback();
                    return "出错了，请联系管理员";
                }
            }
            else {
                //耗材转资产
                //查询耗材信息
                var mmodel = supplies_MaterialRepository.GetEntity(demodel.MaterialId);
                if (mmodel == null || mmodel.Status == 1) { return "物料档案不存在"; }
                var wmodel = supplies_WareHouseRepository.GetEntity(demodel.WarehouseId);
                if (wmodel == null || wmodel.Status == 1) { return "仓库不存在"; }
                var imodel = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = demodel.RB_Group_Id, WarehouseId = demodel.WarehouseId, SuppliesId = demodel.MaterialId }).FirstOrDefault();
                if (imodel == null || (imodel.Number ?? 0) <= 0) { return "该物料库存不足"; }
                decimal UnitPrice = Math.Round((imodel.Money ?? 0) / (imodel.Number ?? 1), 2, MidpointRounding.AwayFromZero);//资产单价
                //初始化资产信息
                RB_Property_Info pmodel = new RB_Property_Info()
                {
                    Name = mmodel.Name,
                    PropertyNum = "",
                    CategoryId = demodel.CategoryId,
                    BrandName = mmodel.BrandName,
                    Money = UnitPrice,
                    BuyDate = Convert.ToDateTime(demodel.BuyDate),
                    BuyType = PropertyBuyTypeEnum.Purchase,
                    Units = mmodel.Units,
                    UseMonths = 0,
                    UseStatus = PropertyUseStateEnum.Normal,
                    PropertyStatus = PropertyStatusEnum.Leisure,
                    PropertyModel = mmodel.SuppliesModel,
                    Images = mmodel.Images,
                    SerialNumber = "",
                    Remark = "耗材转资产",
                    EmployeeId = 0,
                    GetTime = null,
                    BackTime = null,
                    SupplierId = 12,//弄个默认的
                    Status = 0,
                    RB_Branch_Id = userInfo.RB_Branch_id,
                    RB_Group_Id = userInfo.RB_Group_id,
                    CreateBy = userInfo.EmployeeId,
                    CreateDate = DateTime.Now,
                    UpdateBy = userInfo.EmployeeId,
                    UpdateDate = DateTime.Now,
                    BranchId = demodel.SchoolId,
                    QRCode = "",//这个需要生成
                    ProcurementId = 0,
                    IsDepreciation = 0
                };
                //初始化出库单
                RB_Supplies_StockOut_Extend smodel = new RB_Supplies_StockOut_Extend()
                {
                    Id = 0,
                    EmployeeId = 0,
                    WarehouseId = demodel.WarehouseId,
                    StockOutState = StockOutStatusEnum.StockOut,
                    StockOutDate = DateTime.Now,
                    Remark = "耗材转资产",
                    Status = 0,
                    RB_Branch_Id = userInfo.RB_Branch_id,
                    RB_Group_Id = userInfo.RB_Group_id,
                    CreateBy = userInfo.EmployeeId,
                    CreateDate = DateTime.Now,
                    UpdateBy = userInfo.EmployeeId,
                    UpdateDate = DateTime.Now,
                    DepartmentId = userInfo.RB_Department_Id,
                    BranchId = demodel.SchoolId,
                    StockOutNum = "",
                    ApplyForId = 0,
                    IsReturns = 0
                };
                smodel.DetailList = new List<RB_Supplies_StockOutDetail_Extend>() {
                        new RB_Supplies_StockOutDetail_Extend(){
                            CreateBy = demodel.CreateBy,
                                CreateDate = DateTime.Now,
                                Number = demodel.SuppliesNumber,
                                RB_Branch_Id = userInfo.RB_Branch_id,
                                Id = 0,
                                RB_Group_Id = userInfo.RB_Group_id,
                                Remark = "",
                                Status = 0,
                                StockOutId = 0,
                                SuppliesId = demodel.MaterialId,
                                Money = UnitPrice * demodel.SuppliesNumber,
                                UpdateBy = userInfo.EmployeeId,
                                UpdateDate = DateTime.Now
                        }
                    };

                var trans = allocate_RecordRepository.DbTransaction;
                try
                {
                    //首先生成出库信息
                    int Id = supplies_StockOutRepository.Insert(smodel, trans);
                    if (Id > 0)
                    {
                        //编码自动生成
                        string BMStr = Id.ToString();
                        if (BMStr.Length < 5)
                        {
                            switch (BMStr.Length)
                            {
                                case 1:
                                    BMStr = "0000" + BMStr; break;
                                case 2:
                                    BMStr = "000" + BMStr; break;
                                case 3:
                                    BMStr = "00" + BMStr; break;
                                case 4:
                                    BMStr = "0" + BMStr; break;
                            }
                        }
                        BMStr = "TCK" + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                        Dictionary<string, object> files = new Dictionary<string, object>() {
                            { nameof(RB_Supplies_StockOut.StockOutNum),BMStr}
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                    FiledName=nameof(RB_Supplies_StockOut.Id),
                                    FiledValue=Id,
                                    OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        supplies_StockOutRepository.Update(files, wheres, trans);

                        //新增明细
                        foreach (var item in smodel.DetailList)
                        {
                            var ilist = supplies_InventoryRepository.GetList(new RB_Supplies_Inventory_Extend() { RB_Group_Id = smodel.RB_Group_Id, WarehouseId = smodel.WarehouseId, SuppliesId = item.SuppliesId });
                            decimal Price = 0;
                            if (ilist.Any())
                            {
                                var iModel = ilist.FirstOrDefault();
                                Price = Math.Round((iModel.Money ?? 0) / (iModel.Number ?? 1), 2, MidpointRounding.AwayFromZero) * (item.Number ?? 0);
                            }
                            supplies_StockOutDetailRepository.Insert(new RB_Supplies_StockOutDetail()
                            {
                                CreateBy = smodel.CreateBy,
                                CreateDate = smodel.CreateDate,
                                Number = item.Number,
                                Money = Price,
                                RB_Branch_Id = smodel.RB_Branch_Id,
                                Id = 0,
                                RB_Group_Id = smodel.RB_Group_Id,
                                Remark = item.Remark,
                                Status = 0,
                                StockOutId = Id,
                                SuppliesId = item.SuppliesId,
                                UpdateBy = smodel.UpdateBy,
                                UpdateDate = smodel.UpdateDate
                            }, trans);

                            //新增库存表数据
                            if (ilist.Any() && smodel.StockOutState == StockOutStatusEnum.StockOut)
                            {
                                var iModel = ilist.FirstOrDefault();
                                iModel.Number -= item.Number;//减少库存
                                iModel.Money -= Price;
                                if (iModel.Money < 0)
                                {
                                    iModel.Money = 0;
                                }
                                var iflag = supplies_InventoryRepository.Update(iModel, trans);
                                if (iflag)
                                {
                                    //增加库存明细
                                    supplies_InventoryDetailRepository.Insert(new RB_Supplies_InventoryDetail()
                                    {
                                        CreateBy = smodel.CreateBy,
                                        CreateDate = DateTime.Now,
                                        InventoryId = iModel.Id,
                                        Number = item.Number,
                                        Money = Price,
                                        RB_Branch_Id = smodel.RB_Branch_Id,
                                        RB_Group_Id = smodel.RB_Group_Id,
                                        Status = 0,
                                        Type = 2,
                                        Id = 0,
                                        Description = "减少库存-耗材调拨至资产"
                                    }, trans);
                                }
                            }
                        }

                        #region 生成资产

                        for (var i = 1; i <= demodel.SuppliesNumber; i++) {
                            int PropertyId = property_InfoRepository.Insert(pmodel);
                            bool flag = PropertyId > 0;
                            if (flag)
                            {
                                //编码自动生成
                                string BMStr2 = PropertyId.ToString();
                                if (BMStr2.Length < 5)
                                {
                                    switch (BMStr2.Length)
                                    {
                                        case 1:
                                            BMStr2 = "0000" + BMStr2; break;
                                        case 2:
                                            BMStr2 = "000" + BMStr2; break;
                                        case 3:
                                            BMStr2 = "00" + BMStr2; break;
                                        case 4:
                                            BMStr2 = "0" + BMStr2; break;
                                    }
                                }

                                #region 生成二维码
                                string QRPath = DateTime.Now.Ticks.ToString() + ".png";
                                string basepath = AppContext.BaseDirectory;
                                string path_server = basepath + "\\upfile\\code\\" + QRPath;
                                string ImageAddress = "/upfile/code/" + QRPath;
                                string logoPath = basepath + "\\ExportFile\\Branch\\Logo.png";
                                try
                                {
                                    QRCodeHelper.Create_CodeImages("PropertyCheck|Id=" + PropertyId, 5, logoPath, path_server, System.Drawing.Imaging.ImageFormat.Png);
                                }
                                catch (Exception ex)
                                {
                                    LogHelper.Write(ex, "QRCodeHelper.Create_CodeImages");
                                    ImageAddress = "";
                                }


                                #endregion

                                Dictionary<string, object> files2 = new Dictionary<string, object>() {
                                    { nameof(RB_Property_Info.PropertyNum),BMStr2},
                                    { nameof(RB_Property_Info.QRCode),ImageAddress}
                                };
                                List<WhereHelper> wheres2 = new List<WhereHelper>() {
                                    new WhereHelper(){
                                         FiledName=nameof(RB_Property_Info.Id),
                                          FiledValue=PropertyId,
                                           OperatorEnum=OperatorEnum.Equal
                                    }
                                };
                                property_InfoRepository.Update(files2, wheres2);
                                //写入日志
                                property_LogRepository.Insert(new RB_Property_Log()
                                {
                                    PropertyId = PropertyId,
                                    Status = 0,
                                    Content = "新增资产 - 耗材调拨至资产",
                                    TypeName = "入库",
                                    RB_Branch_Id = userInfo.RB_Branch_id,
                                    RB_Group_Id = userInfo.RB_Group_id,
                                    CreateBy = userInfo.EmployeeId,
                                    CreateDate = DateTime.Now
                                });

                                //记录调拨日志
                                demodel.StockInOutNo = BMStr;
                                demodel.PropertyId = PropertyId;
                                allocate_RecordRepository.Insert(demodel, trans);
                            }
                        }
                        #endregion
                    }
                    allocate_RecordRepository.DBSession.Commit();
                    return "";
                }
                catch (Exception ex)
                {
                    LogHelper.Write(ex, "SetPropertySuppliesAllot");
                    allocate_RecordRepository.DBSession.Rollback();
                    return "出错了，请联系管理员";
                }
            }
        }

        /// <summary>
        /// 资产耗材调拨导出
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="count"></param>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Allocate_Record_Extend> GetPropertySuppliesAllotPageList(int pageIndex, int pageSize, out long count, RB_Allocate_Record_Extend demodel)
        {
            var list = allocate_RecordRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            if (list.Any()) {
                //查询资产
                string pids = string.Join(",", list.Select(x => x.PropertyId));
                var plist = property_InfoRepository.GetList(new RB_Property_Info_Extend() { RB_Group_Id = demodel.RB_Group_Id, PropertyIdStr = pids });
                //查询物料
                string mids = string.Join(",", list.Select(x => x.MaterialId));
                var mlist = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = demodel.RB_Group_Id, SuppliesIdStr = mids });
                //查询仓库
                string wids = string.Join(",", list.Select(x => x.WarehouseId));
                var wlist = supplies_WareHouseRepository.GetList(new RB_Supplies_WareHouse_Extend() { RB_Group_Id = demodel.RB_Group_Id, WareHouseIdStr = wids });

                foreach (var item in list) {
                    item.PropertyName = plist.Where(x => x.Id == item.PropertyId).FirstOrDefault()?.Name ?? "";
                    item.SuppliesName = mlist.Where(x => x.Id == item.MaterialId).FirstOrDefault()?.Name ?? "";
                    item.WarehouseName = wlist.Where(x => x.Id == item.WarehouseId).FirstOrDefault()?.Name ?? "";
                }
            }
            return list;
        }

        #endregion
    }
}
